#!/usr/bin/env python
# -*- coding: utf-8 -*-

'''
do archivu vlozi statistiky z awstats za predchazejici mesic
'''

from datetime import date
from optparse import OptionParser
import os
import os.path
import subprocess


def vytvor_statistiky(opts):
    outdir = '/var/app4/%(config)s/static/awstats/archiv/%(year)s/%(month)s' % dict(year=opts.year, month=opts.month, config=opts.config)
    if not os.path.isdir(outdir):
        os.makedirs(outdir)
    if not os.path.lexists(os.path.join(outdir, 'icon')):
        os.symlink('/usr/share/awstats/icon/', os.path.join(outdir, 'icon'))

    command = [
        '/usr/share/doc/awstats/examples/awstats_buildstaticpages.pl',
        '-config=%s' % opts.config,
        '-month=%s' % opts.month,
        '-year=%s' % opts.year,
        '-awstatsprog=/usr/lib/cgi-bin/awstats.pl',
        '-dir=%s' % outdir,
        ]
    p = subprocess.call(command)


def getOpts():
    td = date.today()
    if td.month == 1:
        default_year = td.year-1
        default_month = 12
    else:
        default_year = td.year
        default_month = td.month - 1

    usage = 'usage: %prog [options] appname'
    parser = OptionParser(usage=usage)
    parser.add_option(
            '--year', dest='year', default=default_year)
    parser.add_option(
            '--month', dest='month', default=default_month)

    opts, args = parser.parse_args()

    if len(args) < 1:
        parser.error('appname is required')
    elif len(args) == 1:
        opts.config, = args
    else:
        parser.error('too much arguments')
    return opts


if __name__ == '__main__':
    opts = getOpts()
    vytvor_statistiky(opts)
