#!/usr/bin/env python

import cgitb; cgitb.enable()
import cgi, os, sys, StringIO
from lib4.cgi import parse_auth
from xml4 import templates, const
from xml4.serialization import XHTMLSerializer


TMPL = '''\
<?xml version="1.0" encoding="utf-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>info.cgi</title>
  </head>
  <body>
    <h1>info.cgi</h1>

    <h2>environment</h2>
    <table>
        <tr py:for="k,v in sorted(env.items())">
            <td>$k</td><td>${str(v)[:100]}</td>
        </tr>
    </table>

    <h2>web4 command line</h2>
    <form action="${env['SCRIPT_NAME']}" method="post">
        <pre>$cmd</pre>
        <input type="hidden" name="info_cgi_cmd" value="$cmd64"/>
        <div>
            <input type="submit" name="info_cgi_save" value="Save" />
        </div>
    </form>

  </body>
</html>
'''

def render(**params):
    parser = templates.TemplateParser()
    serializer = XHTMLSerializer()
    tmpl = parser.parse(TMPL)
    state = templates.State(ldict=params)
    return u''.join(serializer(tmpl.expand(state)))

stdin = StringIO.StringIO(sys.stdin.read())
env = os.environ

auth = env.get('HTTP_AUTHORIZATION',env.get('HTTP_CGI_AUTHORIZATION'))
if auth:
    auth = parse_auth(auth)
else:
    auth = None

fs = cgi.FieldStorage(fp=stdin, keep_blank_values=1)
ct = env.get('CONTENT_TYPE', 'application/x-www-form-urlencoded')
meth = env.get('REQUEST_METHOD', 'GET')

cmd = ''

cmd = '#!/bin/sh\n\nweb4'
if auth:
    cmd += ' -A %s:%s' % auth
if meth == 'GET':
    cmd += ' -M GET'
    for k in fs.keys():
        v = fs[k].value
        cmd += ' -V %s=%s' % (k,v)
    cmd += ' <APP> <URL>'
else:
    if ct == 'application/x-www-form-urlencoded':
        cmd += ' -M POST'
    else:
        cmd += ' -M MULTIPART'
    cmd += ' -F - <APP> <URL> <<EOF\n' + stdin.getvalue()
    if ct == 'application/x-www-form-urlencoded':
        cmd += '\n'
    cmd += 'EOF'

if 'info_cgi_save' in fs:
    cmd = fs['info_cgi_cmd'].value.decode('base64')
    print 'Content-Type: text/plain; charset=utf-8'
    print 'Content-Disposition: attachment; filename="webtest.sh'
    print
    print cmd

else:
    cmd64 = cmd.encode('base64')
    html = render(
        env = os.environ,
        auth = auth,
        fs = fs,
        cmd = unicode(cmd, 'utf-8'),
        cmd64 = cmd64,
    )
    print 'Content-Type: text/html; charset=utf-8'
    print
    print html.encode('utf-8')
