-- --------------------------------------------------------------------------
-- Triggers for blobs
-- --------------------------------------------------------------------------

-- CREATE TRIGGER "table_blob_trigger_"
--   BEFORE UPDATE OR DELETE ON cms_node FOR EACH ROW
--   EXECUTE PROCEDURE blob_trigger('blob');


CREATE OR REPLACE FUNCTION blob_trigger() RETURNS TRIGGER AS
'
    if TD["event"] == "UPDATE" :
        old, new = TD["old"], TD["new"]
        for battr in TD["args"] :
            if old[battr] and new[battr] != old[battr] :
                plpy.execute("SELECT lo_unlink(%s)" % old[battr])
    elif TD["event"] == "DELETE" :
        old = TD["old"]
        for battr in TD["args"] :
            if old[battr] :
                plpy.execute("SELECT lo_unlink(%s)" % old[battr])
    return "OK"
' LANGUAGE plpythonu;
