-- --------------------------------------------------------------------------
-- Triggers for tables with logging into history table
-- --------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION history_update_before ()
RETURNS TRIGGER LANGUAGE plpythonu AS '
    import pgspi, datetime

    cRel = pgspi.relName(TD["relid"])
    hRel = "%s_h" % cRel
    old  = TD["old"]
    
    pkey = "%s_h_plan" % cRel 

    if SD.has_key(pkey) :
        plan = SD[pkey]
    else :
        SD[pkey] = plan = pgspi.InsertPlan(hRel)

    rec = dict(old.items())
    rec["hstamp"] = str(datetime.datetime.now())
    plan.execute(rec)
    return "OK"
';



CREATE OR REPLACE FUNCTION history_setup (TEXT)
RETURNS TEXT LANGUAGE plpythonu AS
'
    t, = args
    
    q = "SELECT *, NOW() AS hstamp INTO %s_h FROM %s WHERE wm_oid=-42" % (t,t)
    plpy.execute(q)
    q = """CREATE TRIGGER "10_history_update_before"
            BEFORE UPDATE OR DELETE ON %s FOR EACH ROW
           EXECUTE PROCEDURE history_update_before();""" % t
    plpy.execute(q)
    return "historic setup on %s complete" % t
';

