BEGIN;

-- /usr/share/postgresql/8.3/tsearch_data

CREATE TEXT SEARCH CONFIGURATION public.cs ( COPY = pg_catalog.russian );

CREATE TEXT SEARCH DICTIONARY czech_ispell (
    TEMPLATE = ispell,
    DictFile = czech,
    AffFile = czech,
    StopWords = czech
);

ALTER TEXT SEARCH CONFIGURATION cs
    ALTER MAPPING FOR asciiword, asciihword, hword_asciipart,
                      word, hword, hword_part
    WITH czech_ispell, simple;

ALTER TEXT SEARCH CONFIGURATION cs
    DROP MAPPING FOR email, url, url_path, sfloat, float;

SET default_text_search_config = 'public.cs';

END;
