from enums import *

__all__ = ['ByteCount', 'ByteUnit']


class ByteUnit (Enum) :
    B  = enum(1)
    KB = enum(1024)
    MB = enum(1024 * 1024)
    GB = enum(1024 * 1024 * 1024)
    TB = enum(1024 * 1024 * 1024 * 1024)


class ByteCount(long):

    __slots__ = ()

    def __new__(klass, val):
        # XXX parsing from string ('128MB', ....)
        if val < 0 :
            raise ValueError('Count cannot be negative')
        return long.__new__(klass, val)

    def fmt(self, unit=ByteUnit.B, rounding=2):
        bu = ByteUnit
        if self == 0 :
            return '0 %s' % bu.B.name
        for u in (bu.TB, bu.GB, bu.MB, bu.KB):
            if self > u.value:
                fmt = '%%.%df %%s'  % rounding
                return fmt % (float(self)/u.value, u.name)
        return '%d B' % long(self)


    def __str__(self):
        return self.fmt()
