import re

__all__ = ["MAC"]

# 08002b:010203
# 08002b-010203
# 0800.2b01.0203
# 08-00-2b-01-02-03
# 08:00:2b:01:02:03

macmatch = re.compile(
    '^([0-9a-f]{2})'
    '[-:.]?([0-9a-f]{2})'
    '[-:.]?([0-9a-f]{2})'
    '[-:.]?([0-9a-f]{2})'
    '[-:.]?([0-9a-f]{2})'
    '[-:.]?([0-9a-f]{2})$', re.I).match


class MAC(str):

    def __new__(klass, addr):
        m = macmatch(addr)
        if not m:
            raise ValueError('Invalid MAC address', addr)
        return str.__new__(klass, ':'.join(g.upper() for g in m.groups()))
