from decimal import *

__all__ = ['MoneyContext', 'Money']

MoneyContext = Context(
    prec=2, rounding=ROUND_HALF_UP,
    traps=[DivisionByZero, Overflow, InvalidOperation, Clamped, Underflow],
    flags=[],
)




_round50 = dict.fromkeys(xrange(0, 25), (0, 0.0))
_round50.update(dict.fromkeys(xrange(25,75), (0, 0.50)))
_round50.update(dict.fromkeys(xrange(75,100), (1, 0.0)))



class Money(Decimal):

    def __new__(cls, value="0", context=MoneyContext):
        return super(Money,cls).__new__(cls, value, context)

    def round50(self, castka) :
        sign = castka < 0 and -1 or 1
        castka = abs(castka)
        x = str(castka).split('.')
        if len(x) == 1 :
            return castka
        i,r = x
        iadd, rem = _round50[int((r+'000')[:2])]
        i = int(i)
        return Money((i+iadd+rem) * sign)
