#include <sys/types.h>
#include <stdlib.h>
#include <limits.h>

#define PACL_DENY    0
#define PACL_ALLOW   1

#define PACL_DEFAULT_POLICY  0

/* typedef unsigned char bool; */

typedef unsigned char uchar;

typedef struct {
    uchar       is_group;
    uchar       is_policy;
    int         user; 
} pnAclUser;


typedef struct {
    uchar       is_granted;
    pnAclUser   u;
} pnAclItem;


typedef struct {
    int         role;
    int         item_num;
    int         first_item;
} pnAclRole;


typedef struct {
    int         _size;
    int         role_num;
    pnAclRole   roles[0];
} pnAcl;


typedef struct {
    void *      (*malloc) (size_t);
    void *      (*realloc) (void *, size_t);
    void        (*free) (void *);
    void        (*debug) (char *msg);
} pnAclCtx;


#define pnAclSize(roles,items)  (          sizeof(pnAcl) + \
                                 (roles) * sizeof(pnAclRole) + \
                                 (items) * sizeof(pnAclItem) \
                                )

extern pnAcl *  pnAclFromString(pnAclCtx *ctx, const char *s);
extern int      pnAclCheck(pnAclCtx *ctx, pnAcl *acl);

extern pnAcl *  pnAclJoin(pnAclCtx *ctx, pnAcl *base, pnAcl *join);

extern int      pnAclAllows(
                    pnAclCtx *ctx, pnAcl *acl,
                    int role, int user, int gnum, int *groups);


extern int      pnAclStrlen(pnAclCtx *ctx, pnAcl *acl);
extern char *   pnAclDumps(pnAclCtx *ctx, pnAcl *acl);
extern int      pnAclEq(pnAclCtx *ctx, pnAcl *l, pnAcl *r);


#define pnAclFirstItem(acl)         (   (pnAclItem *) ( \
                                            ((void *)(acl)) + \
                                            sizeof(pnAclRole)*acl->role_num \
                                        ) \
                                    )

#define pnAclOffset(acl,off)        ((pnAclItem *) (((void *)(acl)) + (off)))

#define pnAclGetItem(acl,role,i)    (pnAclOffset((acl),(role)->first_item)+(i))
