CREATE OR REPLACE FUNCTION rownacl_in(cstring)
RETURNS rownacl
AS '$libdir/pg_row_acl.so'
LANGUAGE 'C' IMMUTABLE STRICT;


CREATE OR REPLACE FUNCTION rownacl_out(rownacl)
RETURNS cstring
AS '$libdir/pg_row_acl.so'
LANGUAGE 'C' IMMUTABLE STRICT;


CREATE TYPE rownacl (
	INTERNALLENGTH = -1,
	INPUT = rownacl_in,
	OUTPUT = rownacl_out,
        STORAGE = extended
);


CREATE OR REPLACE FUNCTION allows(rownacl, int4, int4, _int4)
RETURNS BOOLEAN
AS '$libdir/pg_row_acl.so', 'rownacl_allows'
LANGUAGE 'c' IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION join(rownacl, rownacl)
RETURNS rownacl
AS '$libdir/pg_row_acl.so', 'rownacl_join'
LANGUAGE 'c' IMMUTABLE CALLED ON NULL INPUT;

CREATE OR REPLACE FUNCTION rownacl_eq(rownacl, rownacl)
RETURNS BOOLEAN
AS '$libdir/pg_row_acl.so', 'rownacl_eq'
LANGUAGE 'c' IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION rownacl_ne(rownacl, rownacl)
RETURNS BOOLEAN
AS '$libdir/pg_row_acl.so', 'rownacl_ne'
LANGUAGE 'c' IMMUTABLE STRICT;

CREATE OPERATOR = (
	LEFTARG = rownacl,
	RIGHTARG = rownacl,
	COMMUTATOR = =,
	NEGATOR = <>,
	PROCEDURE = rownacl_eq
);

CREATE OPERATOR <> (
	LEFTARG = rownacl,
	RIGHTARG = rownacl,
	NEGATOR = =,
	PROCEDURE = rownacl_ne
);

