import unittest
from adt4.byte_count import *

class TestByteCount(unittest.TestCase):

    def test1_Zero(self):
        self.assertEqual(str(ByteCount(0)), '0 B')
        self.assertEqual(unicode(ByteCount(0)), '0 B')

    def test2_Negative(self):
        self.assertRaises(ValueError, ByteCount, -1)

    def test3_Bytes(self):
        self.assertEqual(unicode(ByteCount(1)), '1 B')
        self.assertEqual(unicode(ByteCount(1023)), '1023 B')

    def test4_KiloBytes(self):
        self.assertEqual(unicode(ByteCount(10*1024)), '10.00 KB')

    def test4_MegaBytes(self):
        self.assertEqual(unicode(ByteCount(12131024)), '11.57 MB')

    def test5_GigaBytes(self):
        self.assertEqual(unicode(ByteCount(1213102400)), '1.13 GB')

def suite():
    theSuite = unittest.TestSuite()
    theSuite.addTest(unittest.makeSuite(TestByteCount))
    return theSuite

if __name__ == '__main__':
    unittest.main( defaultTest='suite' )
