#include <postgres.h>
#include <utils/date.h>
#include <utils/timestamp.h>


#define DATE_MIN -730119
#define DATE_MAX 2921939


typedef struct ValidityDate
{
    DateADT     from;
    DateADT     till;
} ValidityDate;



#define DatumGetValidityDateP(X)    ((ValidityDate *) DatumGetPointer(X))
#define ValidityDatePGetDatum(X)    PointerGetDatum(X)
#define PG_GETARG_VALIDITYDATE_P(n) DatumGetValidityDateP(PG_GETARG_DATUM(n))
#define PG_RETURN_VALIDITYDATE_P(x) return ValidityDatePGetDatum(x)



ValidityDate * validity_date_in(char *str);
char * validity_date_out(ValidityDate *val);

ValidityDate *validity_date_from_date(DateADT *d);
ValidityDate *validity_date_from_date2(DateADT *from, DateADT *till);

int4 validity_date_cmp(ValidityDate *a1, ValidityDate *a2);
bool validity_date_lt(ValidityDate *a1, ValidityDate *a2);
bool validity_date_le(ValidityDate *a1, ValidityDate *a2);
bool validity_date_eq(ValidityDate *a1, ValidityDate *a2);
bool validity_date_ge(ValidityDate *a1, ValidityDate *a2);
bool validity_date_gt(ValidityDate *a1, ValidityDate *a2);
bool validity_date_ne(ValidityDate *a1, ValidityDate *a2);

Datum validity_from_date(ValidityDate *val);
Datum validity_till_date(ValidityDate *val);






typedef struct ValidityTimestampTz
{
    TimestampTz     from;
    TimestampTz     till;
} ValidityTimestampTz;


ValidityTimestampTz * validity_timestamptz_in(char *str);
char * validity_timestamptz_out(ValidityTimestampTz *val);

ValidityTimestampTz *validity_timestamptz_from_timestamptz(TimestampTz *t);
ValidityTimestampTz *validity_timestamptz_from_timestamptz2(
                        TimestampTz *from, TimestampTz *till);

int4 validity_timestamptz_cmp(ValidityTimestampTz *a1, ValidityTimestampTz *a2);
bool validity_timestamptz_lt(ValidityTimestampTz *a1, ValidityTimestampTz *a2);
bool validity_timestamptz_le(ValidityTimestampTz *a1, ValidityTimestampTz *a2);
bool validity_timestamptz_eq(ValidityTimestampTz *a1, ValidityTimestampTz *a2);
bool validity_timestamptz_ge(ValidityTimestampTz *a1, ValidityTimestampTz *a2);
bool validity_timestamptz_gt(ValidityTimestampTz *a1, ValidityTimestampTz *a2);
bool validity_timestamptz_ne(ValidityTimestampTz *a1, ValidityTimestampTz *a2);

Datum validity_from_timestamptz(ValidityTimestampTz *val);
Datum validity_till_timestamptz(ValidityTimestampTz *val);

