# -*- coding: utf-8 -*-
from wm4.api import *
from xml4 import xhtml as xh
from xml4.templates import Domlet
from wm4.web.forms import api as forms

from entities import *

__all__ = ['renderPerm']

_ = i18n.MessageIDFactory('comp4.acl')



@dispatch.generic()
def renderPerm(perm, req, stack=()):
    pass

@renderPerm.when('perm in web._Or')
def render_or(perm, req, stack=()):
    u = xh.ul(klass='comp4-acl-operator-expr')
    for p in perm.perms:
        u.append(xh.li(
            renderPerm(p, req, stack+(perm,)), '\n'
        ))
    return xh.div(
        xh.span(
            _(u'One of the following conditions must be true'), 
            klass='comp4-acl-operator-name'), '\n',
        u, '\n',
        klass='comp4-acl-operator'
    )

@renderPerm.when('perm in web._And')
def render_and(perm, req, stack=()):
    u = xh.ul(klass='comp4-acl-operator-expr')
    for p in perm.perms:
        u.append(xh.li(
            renderPerm(p, req, stack+(perm,)), '\n'
        ))
    return xh.div(
        xh.span(
            _(u'All of the following conditions must be true'), 
            klass='comp4-acl-operator-name'), '\n',
        u, '\n',
        klass='comp4-acl-operator'
    )

@renderPerm.when('perm in web._Not')
def render_not(perm, req, stack=()):
    return renderPerm(perm.perm, req, stack+(perm,))

def isNot(stack):
    if stack and isinstance(stack[-1], web._Not):
        return True
    return False

@renderPerm.when('perm in web.Authenticated')
def render_auth(perm, req, stack=()):
    if isNot(stack):
        return xh.span(
            _(u'Uživatel není autentizovaný'),
            klass='comp4-acl-perm'
        )
    else:
        return xh.span(
            _(u'Uživatel je autentizovaný'),
            klass='comp4-acl-perm'
        )
    
@renderPerm.when('perm in web.UserName')
def render_user(perm, req, stack=()):
    if isNot(stack):
        msg = _(u'Uživatel nemá login $login') % perm.__dict__
    else:
        msg = _(u'Uživatel má login $login') % perm.__dict__
    return xh.span(web.render(req, msg), klass='comp4-acl-perm')
    
@renderPerm.when('perm in web.GroupName')
def render_group(perm, req, stack=()):
    if isNot(stack):
        msg = _(u'Uživatel není ve skupině $group') % perm.__dict__
    else:
        msg = _(u'Uživatel je ve skupině $group') % perm.__dict__
    return xh.span(web.render(req, msg), klass='comp4-acl-perm')
    
@renderPerm.when('perm in web.RemoteAddr')
def render_ip(perm, req, stack=()):
    if isNot(stack):
        msg = _(u'Remote address in range $ip') % perm.__dict__
    else:
        msg = _(u'Remote address not in range $ip') % perm.__dict__
    return xh.span(web.render(req, msg), klass='comp4-acl-perm')




class ACLEditorWidget(Domlet):
    pass
    
def expand(self, state, perm):
    req = state['req']
    for res in (
        'comp4.acl.static/style.css',
    ):
        web.getResource(res).render(req)
    d = xh.p(
        '\n', self.renderPerm(perm, req), '\n',
        klass='comp4-acl comp4-acl-edit'
    )
    for e in d.expand(state):
        yield e







class ACLWidget(Domlet):

    @dispatch.generic()
    def renderPerm(self, perm, req, stack=()):
        pass

    @renderPerm.when('perm in web._Or')
    def render_or(self, perm, req, stack=()):
        u = xh.ul(klass='comp4-acl-operator-expr')
        for p in perm.perms:
            u.append(xh.li(
                self.renderPerm(p, req, stack+(perm,)), '\n'
            ))
        return xh.div(
            xh.span(
                _(u'One of the following conditions must be true'), 
                klass='comp4-acl-operator-name'), '\n',
            u, '\n',
            klass='comp4-acl-operator'
        )

    @renderPerm.when('perm in web._And')
    def render_and(self, perm, req, stack=()):
        u = xh.ul(klass='comp4-acl-operator-expr')
        for p in perm.perms:
            u.append(xh.li(
                self.renderPerm(p, req, stack+(perm,)), '\n'
            ))
        return xh.div(
            xh.span(
                _(u'All of the following conditions must be true'), 
                klass='comp4-acl-operator-name'), '\n',
            u, '\n',
            klass='comp4-acl-operator'
        )

    @renderPerm.when('perm in web._Not')
    def render_not(self, perm, req, stack=()):
        return self.renderPerm(perm.perm, req, stack+(perm,))

    def isNot(self, stack):
        if stack and isinstance(stack[-1], web._Not):
            return True
        return False

    @renderPerm.when('perm in web.Authenticated')
    def render_auth(self, perm, req, stack=()):
        if self.isNot(stack):
            return xh.span(
                _(u'User is not authenticated'),
                klass='comp4-acl-perm'
            )
        else:
            return xh.span(
                _(u'User is authenticated'),
                klass='comp4-acl-perm'
            )
        
    @renderPerm.when('perm in web.UserName')
    def render_user(self, perm, req, stack=()):
        if self.isNot(stack):
            msg = _(u'User has not login $login') % perm.__dict__
        else:
            msg = _(u'User has $login') % perm.__dict__
        return xh.span(web.render(req, msg), klass='comp4-acl-perm')
        
    @renderPerm.when('perm in web.GroupName')
    def render_group(self, perm, req, stack=()):
        if self.isNot(stack):
            msg = _(u'User is not in group $group') % perm.__dict__
        else:
            msg = _(u'User is in group $group') % perm.__dict__
        return xh.span(web.render(req, msg), klass='comp4-acl-perm')
        
    @renderPerm.when('perm in web.RemoteAddr')
    def render_ip(self, perm, req, stack=()):
        if self.isNot(stack):
            msg = _(u'Remote address in range $ip') % perm.__dict__
        else:
            msg = _(u'Remote address not in range $ip') % perm.__dict__
        return xh.span(web.render(req, msg), klass='comp4-acl-perm')
        
        
    def expand(self, state, perm):
        req = state['req']
        for res in (
            'comp4.acl.static/style.css',
        ):
            web.getResource(res).render(req)
        d = xh.p(
            '\n', self.renderPerm(perm, req), '\n',
            klass='comp4-acl comp4-acl-view'
        )
        for e in d.expand(state):
            yield e





class ACLPermissionCtrl(forms.SequenceItemCtrl):
    
    klass = forms.ClientState()

    class negation(forms.SelectCtrl):
        selectOptions = [('not', _(u'Not'), 'not')]

    class permission(forms.InputCtrl):
        pass


class ACLOperatorCtrl(forms.SequenceCtrl, ACLPermissionCtrl):

    itemClass = binding.Constant(ACLPermissionCtrl)

    


class ACLHandler(web.Handler):
    
    domain = binding.Make(lambda s: s.req.params['domain'])
    role   = binding.Make(lambda s: s.req.params.get('role'))
    key    = binding.Make(lambda s: s.req.params.get('key'))

    aclComp = binding.Make(lambda s: s.workspace['acl'])

    def do_edit(self):
        req = self.req
        perm = self.aclComp.get(self.domain, self.key, self.role)
        tmpl = req.getResource(req.params['template'])
        return tmpl.handleHTTP(req, self=self, perm=perm)
        
