#!/usr/bin/env python
# -*- coding: utf-8 -*-


from wm4.api import *

__all__ = ['ActionLink', 
           'EditLink', 'ViewLink', 'ListLink', 'AddLink',
           'view_actions', 'edit_actions', 'add_actions', 'list_actions',
        ]

_ = i18n.MessageIDFactory('comp4.actionlink')

class ActionLink(web.Link):
    hndlr = binding.Require()
    req = obj = binding.Delegate('hndlr')
    action = binding.Require()
    url = binding.Make(lambda s: s.req.get_url(s.obj, s.action))

class EditLink(ActionLink):
    label = _(u'Edit')
    action = 'edit'

class ViewLink(ActionLink):
    label = _(u'View')
    action = 'view'

class ListLink(ActionLink):
    label = _(u'List')
    url = binding.Make(lambda s: s.req.get_url(s.hndlr.entity))

class AddLink(ActionLink):
    label = _(u'Add')
    url = binding.Make(lambda s: s.req.get_url(s.hndlr.entity, 'add'))

def view_actions(hndlr):
    if not hndlr.req.user:
        return ()
    return [ViewLink(hndlr=hndlr, selected=True),
            EditLink(hndlr=hndlr),
            ListLink(hndlr=hndlr),
            AddLink(hndlr=hndlr),
        ]

def edit_actions(hndlr):
    if not hndlr.req.user:
        return ()
    return [ViewLink(hndlr=hndlr),
            EditLink(hndlr=hndlr, selected=True),
            ListLink(hndlr=hndlr),
            AddLink(hndlr=hndlr),
        ]

def add_actions(hndlr):
    if not hndlr.req.user:
        return ()
    return [ListLink(hndlr=hndlr),
            AddLink(hndlr=hndlr, selected=True),
        ]

def list_actions(hndlr):
    if not hndlr.req.user:
        return ()
    return [ListLink(hndlr=hndlr, selected=True),
            AddLink(hndlr=hndlr),
        ]


