import sets
import re

from wm4.api import *
from wm4.web.forms import api as forms


_ = i18n.MessageIDFactory('comp4.forum')
word_spliter = re.compile('[-\t\n\r\f\v .,!?:@#$%^&*()\\\\+=<>/]').split

class StopwordFilter (object) :
    
    def __init__ (self, stopwords) :
        self.stopwords = sets.Set(
                    [unicode(word).lower() for word in stopwords])


    def __call__ (self, text) :
        if not text :
            return []
        else :
            swords = self.stopwords
            wspliter = word_spliter

            return [
                w.lower() for w in wspliter(unicode(text))
                           if w.lower() in swords
            ]




class StopWordsValidator(forms.InputCtrl):

    def get_stopwords(self):
        return []

    def get_text(self):
        return ''

    def commitChanges(self):
        self.newValue = NOT_GIVEN
        filter = StopwordFilter(self.get_stopwords())
        if filter(self.get_text()):
            self.ctrlError = schema.FeatureError('message', 
                                _(u'Comment contains blocked expressions.'))
            forms.OnErrorEvent(self, error=self.ctrlError)
            return False
        else:
            return True


