BEGIN;


CREATE TABLE banner_location(
    pkey            SERIAL NOT NULL,

    name            VARCHAR NOT NULL,

    max_width       INTEGER NOT NULL,
    max_height      INTEGER NOT NULL,

    domain          VARCHAR,

    PRIMARY KEY (pkey)
);

CREATE TABLE banner (
    pkey            SERIAL NOT NULL,
    server          VARCHAR NOT NULL,
    location        INTEGER NOT NULL,

    url             VARCHAR NOT NULL,
    alt             VARCHAR NOT NULL,
    description     VARCHAR,
    ordernum        INTEGER,

    max_impressions INTEGER,
    max_clicks      INTEGER,
    show_from       DATE,
    show_till       DATE,
    cnt_impressions INTEGER NOT NULL DEFAULT 0,
    cnt_clicks      INTEGER NOT NULL DEFAULT 0,

    "file"          INTEGER NOT NULL,

    PRIMARY KEY (pkey)
);

CREATE TABLE banner_file (
    "pkey"          SERIAL NOT NULL,
    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,

    PRIMARY KEY("pkey")
);


END;

