#!/usr/bin/env python
# -*- coding: utf-8 -*-


from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *


_ = i18n.MessageIDFactory('comp4.banner')


class BannerSitemap(Route):
    virtual = True
    match = 'banner/'

    mainMenuItems = Lazy(lambda s: [s/p for p in [
        'banner/', 'location/']])

    class banner(SitemapWithMainMenu):
        match = 'banner/'
        handler = Const('comp4.banner.web.BannerHandler')
        listingCtrl = Const('comp4.banner.controllers.BannerListing')
        clsObj = Const(Banner)
        asMainMenu = Param(lambda s: web.render(web.request(), _(u'Banner')))

        class obj(SitemapWithMainMenu.obj):
            class file(InstanceRoute): pass
            class show(InstanceRoute): pass
            class click(InstanceRoute): pass

        patch({
            'cls.list.template': Const('comp4.banner/banner_list.wt'),
            'cls.add.template': Const('comp4.banner/banner_form.wt'),
            'obj.view.template': Const('comp4.banner/banner_form.wt'),
            'obj.edit.template': Const('comp4.banner/banner_form.wt'),
            })



    class banner_location(SitemapWithMainMenu):
        match = 'location/'
        handler = Const('comp4.banner.web.BannerLocationHandler')
        listingCtrl = Const('comp4.banner.controllers.BannerLocationListing')
        clsObj = Const(BannerLocation)
        asMainMenu = Param(lambda s: web.render(web.request(), _(u'Location')))

        patch({
            'cls.list.template': Const('comp4.banner/location_list.wt'),
            'cls.add.template': Const('comp4.banner/location_form.wt'),
            'obj.view.template': Const('comp4.banner/location_form.wt'),
            'obj.edit.template': Const('comp4.banner/location_form.wt'),
            })
