#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms import api as forms
from wm4.web.forms.listings import *

from lib4.imports import importObject

from comp4.files.web import makeResponse

from entities import *
from controllers import *


__all__ = ['BannerHandler', 'BannerLocationHandler']



class ListingHandler(web.EntityHandler):
    def do_list(self):
        ctrl = importObject(self.req.params['listingCtrl'])
        lst = ctrl(self.req)
        lst()
        return self.render(listing=lst)




class BannerHandler(ListingHandler):
    entity = binding.Constant(Banner)
    formCtrl = binding.Constant(BannerForm)

    def do_file(self):
        if self.obj.file.content_type.startswith('image/'):
            return makeResponse(self.req, self.obj.file, disposition='inline')
        elif self.obj.file.content_type=='application/x-shockwave-flash':
            return makeResponse(self.req, self.obj.file, disposition='inline')

    def do_show(self):
        self.obj.cnt_impressions += 1
        return self.do_file()

    def do_click(self, req):
        self.obj.cnt_clicks += 1
        u = self.obj.url
        if u.startswith('/'):
            import os.path
            u = os.path.join(req.appURL, u[1:])
        raise web.SeeOther(u)



class BannerLocationHandler(ListingHandler):
    entity = binding.Constant(BannerLocation)
    formCtrl = binding.Constant(BannerLocationForm)


