# -*- coding: utf-8 -*-
from wm4.api import *
from wm4.web.forms.controllers import *
from wm4.web.forms.listings import *
from lib4.imports import importObject

from entities import Bookmark

__all__ = ["BookmarkForm", "BookmarkLst"]


class BookmarkForm(makeFormCtrl(Bookmark)):

    class abstract(TextAreaCtrl):
        pass

    class description(HtmlCtrl):
        pass


class BookmarkLst(ListingCtrl):

    baseQuery = '''[obj for obj in 'bookmarks/Bookmark']'''
    
    defaultOrder = '+title'

    class pkey(InputFilter):
        queryExpr = 'obj.pkey'
        ctrlLabel = u'pkey'

    class title(LikeFilter):
        queryExpr = 'obj.title'
        ctrlLabel = u'Title'
        
    class url(InputFilter):
        queryExpr = 'obj.url'
        ctrlLabel = u'URL'

    class fulltext(MulticolLikeFilter):
        filteredExpressions = 'obj.title', 'obj.abstract', 'obj.description'
