#!/usr/bin/env python

import sys
import os
import psycopg2
from xml4.utils import escape


con = psycopg2.connect(database=sys.argv[1])

cur = con.cursor()
cur.execute('SELECT DISTINCT partition FROM repository_node')
for partition, in cur.fetchall():
    sub = os.path.join('xml', partition)
    if not os.path.isdir(sub):
        os.makedirs(sub)

    cur.execute('''
        SELECT rn.inode, rn.parent_node, pv.changeset
          FROM repository_node rn
               INNER JOIN cms_public_version pv ON rn.inode = pv.inode
         WHERE CURRENT_DATE BETWEEN pv.pstart AND pv.pend
           AND pv.changeset BETWEEN rn.changeset_from AND rn.changeset_till
           AND rn.partition = '%s'
    ''' % partition)
    for inode, parent, changeset in cur.fetchall():
        fd = open(os.path.join(sub, '%d.xml' % inode), 'w')
        print partition, inode, parent, changeset
        fd.write('<?xml version="1.0" encoding="utf8"?>\n')
        fd.write('<doc inode="%d" changeset="%d"' % (inode, changeset))
        if parent is not None:
            fd.write(' parent="%d"' % parent)
        fd.write('\n')
        fd.write('     xmlns="http://windmill.cz/"\n')
        for k in ('cms', 'navig', 'property'):
            fd.write('     xmlns:%s="http://windmill.cz/%s"\n' % (k,k))
        fd.write('>\n')
        cur.execute('''
            SELECT e.eid, e.parent_id, e.kind, e.name, e.value
              FROM repository_element e
             WHERE e.inode = %d
               AND %d BETWEEN e.changeset_from AND e.changeset_till
             ORDER BY e.position
        ''' % (inode, changeset))
        elements = cur.fetchall()

        def render_elements(parent=None, indent='  '):
            for eid, par, kind, name, value in elements:
                if par != parent:
                    continue
                fd.write('%s<%s:%s>\n' % (indent, kind, name))
                if value:
                    val = escape(value.replace('\r\n', '\n'))
                    fd.write('%s  <val>%s</val>\n' %  (indent, val))
                render_elements(eid, indent+'  ')
                fd.write('%s</%s:%s>\n' % (indent, kind, name))
        render_elements()
        fd.write('</doc>\n')
        fd.close()
        #break
    #break
