# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.config.ini_files import ConfigReader
from comp4.cms.api import *
from comp4.cms.pagelets import *


RP = RootProperty
PNF = exceptions.PropertyNotFound

class TestRootConfig(TestCase):

    def setUp(self):
        self.exit_ = config.loadConfig(
            'pkgfile:wm4/core.ini',
            'pkgfile:wm4.web/web.ini',
            'pkgfile:comp4.cms/comp.ini',
        )
    
    def tearDown(self):
        self.exit_()

    def parse(self, lines):
        cr = ConfigReader()
        cr.readString(lines)

    def test10_IniFile(self):
        self.parse((
            '[CMS Root *]\n'
            'element_factory.cms.pagelet.rest = "Foo"\n'

            '[CMS Root bar.*]\n'
            'manager = "MGR"\n'
            'element_factory.cms.pagelet.rest = "Bar"\n'

            '[CMS Root bar.baz]\n'
            'element_factory.cms.pagelet.rest = 42\n'
        ))
        self.assertEqual(
            RP('foo','element_factory.cms.pagelet.abstract')(), Abstract)
        self.assertEqual(
            RP('foo','element_factory.cms.pagelet.rest')(), 'Foo')
        self.assertEqual(
            RP('bar.bar','element_factory.cms.pagelet.rest')(), 'Bar')
        self.assertEqual(
            RP('bar.baz','element_factory.cms.pagelet.rest')(), 42)

        self.assertRaises(PNF, RP('foo','neex'))



def suite():
    return TestSuite((
        makeSuite(TestRootConfig),
    ))

if __name__ == '__main__':
    main( defaultTest='suite' )
