# -*- coding: utf-8 -*-

import sys, cPickle
from wm4.api import *
from lib4.trees import AbstractTreeNode

config.loadConfig(
    'pkgfile:wm4/core.ini',
    'pkgfile:wm4.web/web.ini',
    'pkgfile:mestovalmez/app.ini'
)


ws = settings.workspace()
storage.begin()


COUNT = 100

class Node(AbstractTreeNode):
    
    #__slots__ = 'inode', 'parent', 'children'

    def __init__(self, inode):
        self.inode = inode
        self.parent = None
        self.children = ()

    def __repr__(self):
        return 'Node(%s)' % self.inode

if 0:
    for i in range(COUNT):
        branches = {}
        nodes = {}
        root = None
        for inode, parent in ws.connection('''
            SELECT DISTINCT ON (inode) inode, parent_node
              FROM repository_node
             WHERE partition = 'doc'
          ORDER BY inode, changeset_from DESC
        '''):
            node = nodes[inode] = Node(inode)
            children = branches.get(parent, NOT_FOUND)
            if children is NOT_FOUND:
                branches[parent] = [node]
            else:
                children.append(node)
        root, = branches.pop(None)
        for inode, children in branches.iteritems():
            node = nodes[inode]
            node.children = children
            for child in children:
                child.parent = node
        print 'ITER', len(nodes)

if 0:
    if 0:
        '''
        CREATE VIEW repository_node_children AS
        SELECT d AS partition,
               p AS parent,
               ARRAY_TO_STRING(ARRAY_ACCUM(i), ',') AS children
          FROM (SELECT DISTINCT ON (inode) inode, partition, parent_node
                  FROM repository_node
                 ORDER BY inode, changeset_from DESC) AS rn (i, d, p)
         GROUP BY p, d
         '''
    for i in range(COUNT):
        nodes = {}
        root = None
        for inode, children in ws.connection('''
            SELECT parent, children
              FROM repository_node_children
             WHERE partition = 'doc'
        '''):
            if inode is not None:
                inode = int(inode)
            node = nodes.get(inode)
            if node is None:
                nodes[inode] = node = Node(inode)
            if inode is None:
                root = node
            node.children = []; add = node.children.append
            for i in children.split(','):
                i = int(i)
                child = nodes.get(i)
                if child is None:
                    child = nodes[i] = Node(i)
                    child.parent = node
                add(child)
        print 'ITER', len(nodes)

if 0:
    if 0:
        '''    
        CREATE TABLE repository_node_branches AS
        SELECT d AS partition,
               p AS parent,
               ARRAY_TO_STRING(ARRAY_ACCUM(i), ',') AS children
          FROM (SELECT DISTINCT ON (inode) inode, partition, parent_node
                  FROM repository_node
                 ORDER BY inode, changeset_from DESC) AS rn (i, d, p)
         GROUP BY p, d
        '''
    for i in range(COUNT):
        nodes = {}
        root = None
        for inode, children in ws.connection('''
            SELECT parent, children
              FROM repository_node_branches
             WHERE partition = 'doc'
        '''):
            if inode is not None:
                inode = int(inode)
            node = nodes.get(inode)
            if node is None:
                nodes[inode] = node = Node(inode)
            if inode is None:
                root = node
            node.children = []; add = node.children.append
            for i in children.split(','):
                i = int(i)
                child = nodes.get(i)
                if child is None:
                    child = nodes[i] = Node(i)
                    child.parent = node
                add(child)
        print 'ITER', len(nodes)


if 0:
    if 0:
        cPickle.dump(root, open('tree','w'))
    for i in range(COUNT):
        root = cPickle.load(open('tree'))
        print 'ITER', root
    
if 1:
    for i in range(COUNT):
        q = '''
              SELECT DISTINCT ON (inode) inode, parent_node,
                     changeset_from, changeset_till
                FROM repository_node
               WHERE partition = 'doc'
            ORDER BY inode, changeset_from DESC
        '''
        branches = {}
        nodes = {}
        for inode, parent, cf, ct in ws.connection(q):
            if inode is not None:
                inode = int(inode)
            if parent is not None:
                parent = int(parent)
            nodes[inode] = (parent, cf, ct)
            branches.setdefault(parent, []).append(inode)
        print 'ITER', len(branches), len(nodes)
    print
    if 0:
        for part, root in roots.items():
            print part, root, branches.get(root, [])


sys.exit(0)
for n in root.iterDepthFirst():
    print '  ' * n.treeLevel, n.inode
