#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms.api import *
from wm4.web.forms.listings import *

from lib4.imports import importObject

from entities import *


_ = i18n.MessageIDFactory('comp4.event')


class EventTimeCtrl(makeFormCtrl(EventTime), SequenceItemCtrl):

    class interval(SelectCtrl):
        ctrlRequired = True
        selectOptions = [(i, unicode(i), i)
                         for i in range(1, 20)]

    class event(InputCtrl):
        ctrlType = Event
        ctrlRequired = True
        def defaultOutput(self):
            return self['../../..'].newValue


class EventForm(makeFormCtrl(Event)):
    featureCommiting = {
            '*': 'before',
            'times': 'after',
            }

    class description(TextAreaCtrl):
        cols = 60
        rows = 4

    class times(SequenceCtrl):
        itemClass = binding.Constant(EventTimeCtrl)

        def makeDefaultItems(self):
            return [self.makeItem(0)]

        def updateContainer(self, removed):
            ws = settings.workspace()
            for i in removed:
                ws.remove(self.oldValue[i])

    





class EventLst(ListingCtrl):
    baseQuery = '''[obj for obj in 'event/Event']'''

    class pkey(Column):
        queryExpr = 'obj.pkey'
        ctrlLabel = _(u'ID')

    class name(LikeFilter):
        queryExpr = 'obj.name'
        ctrlLabel = _(u'Name')


