#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.web.navigation import Link, actionLinks
from wm4.utils.clspatch import patch

from entities import *



_ = i18n.MessageIDFactory('comp4.event')


class EventSitemap(EntitySitemap):
    match = 'event/'
    clsObj = Const(Event)
    handler = Const('comp4.event.web.EventHandler')
    listingCtrl = Const('comp4.event.controllers.EventLst')

    class obj(EntitySitemap.obj):
        timeobj = Const(None)

        class view(EntitySitemap.obj.view):
            class time(Route):
                match = 'time/:timeoid/'
                timeoid = Param(lambda s: s.timeobj._oid)
                timeobj = Param(
                        lambda s: findEntity(s, EventTime, s.timeoid), 
                        typ=EventTime)
                signature = Signature('obj', 'timeobj')

    class cls(EntitySitemap.cls):

        class calendar(Route):
            match = 'calendar/'
            virtual = True
            permission = Param(lambda s: s.viewPerm, typ=object)

            class following(ClassRoute):
                template = Param(
                        lambda s: '%s/calendar_following.wt' % s.tmplmod)
                asAction = Lazy(Link.fromRoute)

            class month(ClassRoute): pass
            class week(ClassRoute): pass
            class day(ClassRoute): pass

