BEGIN;

CREATE TABLE feed_channel (
    pkey        SERIAL PRIMARY KEY,
    is_default  BOOLEAN NOT NULL DEFAULT False,
    title       TEXT NOT NULL,
    link        TEXT NOT NULL,
    description TEXT NOT NULL,
    max_posts   INTEGER NOT NULL,
    language    VARCHAR,
    editor      VARCHAR NOT NULL,
    webmaster   VARCHAR
);

CREATE TABLE feed_post (
    klass       VARCHAR NOT NULL,
    key         VARCHAR NOT NULL,

    title       TEXT NOT NULL,
    description TEXT NOT NULL,
    author      TEXT,
    published   TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT Now(),
    updated     TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT Now(),

    PRIMARY KEY (klass, key)
);

CREATE TABLE feed_post_channel (
    post_klass  VARCHAR NOT NULL,
    post_key    VARCHAR NOT NULL,
    channel     INTEGER NOT NULL,

    PRIMARY KEY (post_klass, post_key, channel)
);

END;
