#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *

__all__ = ['FeedSitemap']



class FeedSitemap(web.EntitySitemap):
    match = 'feed/'
    handler = Const('comp4.feed.web.FeedChannelHandler')
    clsObj = Const(FeedChannel)
    listingCtrl = Const('comp4.feed.web.FeedListing')
    
    class cls(web.EntitySitemap.cls):
        class rss2(ClassRoute):
            permission = Param(lambda s: s.viewPerm)
        class atom(ClassRoute):
            permission = Param(lambda s: s.viewPerm)
        class html(Route):
            match = 'html'
            action = Const('html')
            permission = Param(lambda s: s.viewPerm)
            signature = Signature('clsObj', 'action')

    class obj(web.EntitySitemap.obj):
        class rss2(InstanceRoute):
            permission = Param(lambda s: s.viewPerm)
        class atom(InstanceRoute):
            permission = Param(lambda s: s.viewPerm)
        class html(Route):
            match = 'html'
            action = Const('html')
            permission = Param(lambda s: s.viewPerm)
            signature = Signature('obj', 'action')

    patch({
        'cls.list.template'  : Const('comp4.feed/list.wt'),
        'cls.add.template'   : Const('comp4.feed/form.wt'),
        'cls.rss2.template'  : Const('comp4.feed/rss2.wt'),
        'cls.atom.template'  : Const('comp4.feed/atom.wt'),
        'cls.html.template'  : Const('comp4.feed/html.wt'),

        'obj.view.template'  : Const('comp4.feed/form.wt'),
        'obj.edit.template'  : Const('comp4.feed/form.wt'),
        'obj.rss2.template'  : Const('comp4.feed/rss2.wt'),
        'obj.atom.template'  : Const('comp4.feed/atom.wt'),
        'obj.html.template'  : Const('comp4.feed/html.wt'),
    })


