#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms.listings import *

from lib4.imports import importObject

from entities import *


__all__ = ['FeedChannelHandler']

_ = i18n.MessageIDFactory('comp4.feed')


class FeedListing(ListingCtrl):
    baseQuery = '''[obj for obj in 'feed/FeedChannel']'''

    class pkey(Column):
       queryExpr = 'obj.pkey'
       ctrlLabel = _(u'ID')

    class title(LikeFilter):
        queryExpr = 'obj.title'
        ctrlLabel = _(u'Title')

    class link(Column):
       queryExpr = 'obj.pkey'
       ctrlLabel = _(u'Link')

    class is_default(Column):
       queryExpr = 'obj.is_default'
       ctrlLabel = _(u'Default')




class FeedChannelHandler(web.EntityHandler):
    entity = binding.Constant(FeedChannel)

    def do_list(self):
        ctrl = importObject(self.req.params['listingCtrl'])
        lst = ctrl(self.req)
        lst()
        return self.render(listing=lst)

    def getObject(self):
        if self.req.params.has_key(self.oidParam):
            return super(FeedChannelHandler, self).getObject()
        return self.workspace['feed'].defaultFeed
    obj = binding.Make(getObject)

    def feed_render(self, mime, **kw):
        req = self.req
        tmpl = req.getResource(req.params['template'])
        resp = req.response
        enc = req.output_encoding
        output = tmpl.render(req, **kw).encode(enc)
        resp.addheader('Content-type', '%s;charset=%s' % (
                                    mime, req.output_encoding))
        resp.addheader('Content-Length', str(len(output)))
        resp.body = [output]
        return resp

    def do_rss2(self):
        return self.feed_render('application/rss+xml',
                           **self.viewNS(obj=self.obj, mode='view'))

    def do_atom(self):
        return self.feed_render('application/atom+xml',
                           **self.viewNS(obj=self.obj, mode='view'))

    def do_html(self):
        return self.do_view()
