BEGIN;

CREATE TABLE "file" (
    "pkey"          SERIAL NOT NULL,
    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,

    PRIMARY KEY("pkey")
);


CREATE TABLE "image" (
    "pkey"          SERIAL NOT NULL,
    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,
    "width"         INTEGER NOT NULL,
    "height"        INTEGER NOT NULL,

    PRIMARY KEY("pkey")
);



CREATE TABLE "photo" (
    "pkey"          SERIAL NOT NULL,
    "name"          VARCHAR NOT NULL,
    "author"        VARCHAR,
    "created"       DATE,
    "quality"       INTEGER NOT NULL DEFAULT 5,
    "kind"          VARCHAR NOT NULL,
    "description"   TEXT,

    PRIMARY KEY ("pkey")
);

CREATE TABLE "photo_res" (
    "photo"         INTEGER NOT NULL,
    "resolution"    VARCHAR NOT NULL,
    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,
    "width"         INTEGER NOT NULL,
    "height"        INTEGER NOT NULL,

    PRIMARY KEY("photo", "resolution")
);

END;

