# -*- coding: utf-8 -*-
from wm4.api import *
from wm4.web.forms.api import *

from entities import *

__all__ = ['PhotoWidget', 'PhotoCtrl']



class PhotoWidget(FormWidget):
    def edit(self, state, felem, req):
        id = req.get_new_id()
        return web.parseSrc('''<div>
            <?py
                 imgid = req.get_new_id()
                 src = form['src'].inputText or '/++res++/wm4.web.static/img/bg/grey.gif'
            ?>
            <input form:input="pkey"/>
            <input form:input="src"
                   onchange="$$('#$imgid').get(0).src=this.value;return true;"/>
            <a href="#" form:input="popup"><img id="$imgid"
                src="$src" width="60" height="60" /></a>
            <span form:errors="." />
        </div>''' % dict(id=id)
    )


class PhotoCtrl(InputCtrl):
    
    ctrlWidget = web.FORM_WIDGET('input.files.photo')

    resolution = 'thumb'

    class popup(PopupCtrl):
        popupMap = dict(
            pkey = '../pkey',
            src  = '../src',
        )
        def popupUrl(self):
            return self.ctrlReq.get_url(Photo, 'popup')
        popupUrl = binding.Make(popupUrl)

    class pkey(InputCtrl):
        ctrlVisibility = 'hidden'

    class src(InputCtrl):
        ctrlVisibility = 'hidden'
        def defaultInput(self):
            old = self['../pkey'].oldValue
            if old in (NOT_GIVEN, None):
                return ''
            photo = settings.workspace().get(Photo, old)
            return self.ctrlReq.get_url(photo, 'download', 'thumb')

    def defaultOutput(self):
        pk = self['pkey'].newValue
        ws = settings.workspace()
        try:
            return ws.get(Photo, pk)
        except:
            return None

