from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *

__all__ = ['PhotoSitemap']


class PhotoSitemap(EntitySitemap):
    match = 'photo/'
    handler = Const('comp4.files.web.PhotoHandler')
    clsObj = Const(Photo)

    class cls(EntitySitemap.cls):

        class popup(ClassRoute):
            template = Const('comp4.files/photo_popup.wt')

    class obj(EntitySitemap.obj):
        
        class download(InstanceRoute):
            resolution = Const('full')
            signature = Signature('obj','action') | \
                        Signature('obj','action', 'resolution')

            class _resolution(Route):
                match = '/:resolution'
                action = Const('download')
                resolution = Param(typ=str)
                signature = Signature('obj','action', 'resolution')

    patch({
        'cls.list.template': Const('comp4.files/photo_list.wt'),
    })
