from wm4.api import *
from wm4.web.forms import api as forms

from lib4.cgi import http_time
from lib4.timeutils import Datetime
from urllib import quote

from entities import *

__all__ = ['makeResponse', 'PhotoHandler']



def makeResponse(req, obj, disposition=None):
    if not obj:
        raise web.NotFound()

    resp = req.response
    env = req.environ

    #resp.addheader('X-Sendfile', '/var/app4/zlintip/blobs/110/3015790')
    #resp.addheader('Content-Type', obj.content_type)
    #resp.body = ['ahoj']
    #return resp

    if req.method not in ('GET','HEAD'):
        raise web.MethodNotAllowed(req.method)

    send_body = True
    objmod = obj.modified.replace(microsecond=0)
    try:
        lastm = Datetime(env.get('HTTP_IF_MODIFIED_SINCE', req).split(';')[0])
        if lastm == objmod:
            send_body = False
    except:
        pass

    etag = env.get('HTTP_IF_NONE_MATCH', NOT_FOUND)
    if etag is not NOT_FOUND:
        if etag != obj.etag:
            send_body = True

    if not send_body:
        raise web.NotModified()

    resp.addheader('Content-Length', str(obj.size))
    resp.addheader('Content-Type', obj.content_type)
    resp.addheader('ETag', obj.etag)
    resp.addheader('Last-Modified', http_time(obj.modified))
    if disposition:
        filename = obj.undir.encode('utf-8')
        if 'MSIE' in env.get('HTTP_USER_AGENT',''):
            filename = quote(filename)
        resp.addheader('Content-Disposition', '%s; filename="%s"' % (
            disposition, filename))
    try:
        obj.blob.open('rb')
    except IOError:
        raise web.NotFound()
    resp.body = [obj.blob.read()]
    obj.blob.close()
    return resp





class PhotoForm(forms.makeFormCtrl(Photo)):
    pass




class PhotoHandler(web.EntityHandler):
    entity = Photo
    formCtrl = binding.Constant(PhotoForm)

    def do_popup(self):
        return self.do_list()

    def do_download(self):
        req = self.req
        obj = req.params['obj']
        img = obj.resdict.get(req.params['resolution'], None)
        return makeResponse(req, img)
