BEGIN;

CREATE TABLE forum(
    pkey        SERIAL PRIMARY KEY,
    klass       VARCHAR,
    key         VARCHAR,
    name        VARCHAR NOT NULL,
    administrator   INTEGER,
    moderated   BOOLEAN NOT NULL,
    closed      BOOLEAN NOT NULL,
    created     TIMESTAMP WITH TIME ZONE DEFAULT NOW()
);


CREATE TABLE forum_comment (
    pkey        SERIAL,
    forum       INTEGER NOT NULL,
    sender      VARCHAR,
    email       VARCHAR,
    www         VARCHAR,
    ip          VARCHAR,
    created     TIMESTAMP WITH TIME ZONE DEFAULT NOW(),
    published   BOOLEAN NOT NULL DEFAULT True,
    deleted     BOOLEAN NOT NULL DEFAULT False,
    subject     VARCHAR,
    message     VARCHAR NOT NULL,
    parent      INTEGER,

    PRIMARY KEY(pkey)
);

CREATE TABLE forum_stopwords (
    pkey        SERIAL PRIMARY KEY,
    word        VARCHAR NOT NULL 
);

CREATE TABLE forum_blockedip (
    pkey        SERIAL PRIMARY KEY,
    ip          VARCHAR NOT NULL
);

END;
