#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *

__all__ = ['ForumSitemap']

_ = i18n.MessageIDFactory('comp4.forum')


# XXX
if 0:
    sm.url_for('o in Forum',
        lambda o,a='view',c='': '/forum/%d/' % o.pkey + (a != 'view' and a or '') + (c!='' and '#COMP4-FORUM-COMMENT-'+str(c) or ''))

def moderatorPerm(obj):
    if obj.administrator:
        return web.UserName(obj.administrator.login) | \
                web.GroupName('admin')
    else:
        return web.GroupName('admin')

class ForumSitemap(Route):
    virtual = True

    mainMenuItems = Lazy(lambda s: [s/p for p in [
        'forum/', 'stopwords/', 'blockedip/']])

    class forum(web.SitemapWithMainMenu):
        match = 'forum/'
        clsObj = Const(Forum)
        handler = Const('comp4.forum.web.ForumHandler')
        listingCtrl = Const('comp4.forum.web.ForumListing')
        asMainMenu = Param(lambda s: web.render(web.request(), _(u'Forum')))

        class obj(web.SitemapWithMainMenu.obj):
            class comment(InstanceRoute):
                permission = Param(lambda s: s.viewPerm)

        patch({
            'cls.list.template' : Const('comp4.forum/forum_list.wt'),
            'cls.add.template' : Const('comp4.forum/forum_form.wt'),
            'obj.view.template': Const('comp4.forum/forum_view.wt'),
            'obj.edit.template' : Const('comp4.forum/forum_form.wt'),
            'obj.edit.permission' : Param(lambda s: moderatorPerm(s.obj)),
            'obj.delete.permission' : Param(lambda s: moderatorPerm(s.obj)),
            'obj.comment.template': Const('comp4.forum/comment_add.wt'),
        })

    class forumcomment(web.EntitySitemap):
        match = 'forumcomment/'
        clsObj = Const(ForumComment)
        handler = Const('comp4.forum.web.ForumCommentHandler')

        patch({
            'obj.forum':  Param(lambda s: s.obj.forum),
            'obj.edit.permission': Param(lambda s: moderatorPerm(s.obj.forum)),
            'obj.edit.template': Const('comp4.forum/comment_form.wt'),
        })

    class stopwords(web.SitemapWithMainMenu):
        match = 'stopwords/'
        clsObj = Const(ForumStopwords)
        handler = Const('comp4.forum.web.ForumStopwordsHandler')
        listingCtrl = Const('comp4.forum.web.StopwordsListing')
        asMainMenu = Param(lambda s: web.render(web.request(), _(u'Stopwords')))
        viewPerm = Const(web.MemberOf('admin'))

        patch({
            'cls.list.template' : Const('comp4.forum/stopwords_list.wt'),
            'cls.add.template' : Const('comp4.forum/stopwords_form.wt'),
            'obj.view.template': Const('comp4.forum/stopwords_form.wt'),
            'obj.edit.template' : Const('comp4.forum/stopwords_form.wt'),
        })

    class blockedip(web.SitemapWithMainMenu):
        match = 'blockedip/'
        clsObj = Const(ForumBlockedip)
        handler = Const('comp4.forum.web.ForumBlockedipHandler')
        listingCtrl = Const('comp4.forum.web.BlockedipListing')
        asMainMenu = Param(
                lambda s: web.render(web.request(), _(u'Blocked IP addresses')))
        viewPerm = Const(web.MemberOf('admin'))

        patch({
            'cls.list.template' : Const('comp4.forum/blockedip_list.wt'),
            'cls.add.template' : Const('comp4.forum/blockedip_form.wt'),
            'obj.view.template': Const('comp4.forum/blockedip_form.wt'),
            'obj.edit.template' : Const('comp4.forum/blockedip_form.wt'),
        })
