# -*- coding: utf-8 -*-

from wm4.testing import *
from wm4.api import *
from comp4.fulltext.api import *
from comp4.fulltext.entities import TSVectorTypeDescriptor

TSV = TSVectorTypeDescriptor


V = """'test':12B 'testo':12B 'tlo':2A,7B,44B 'daj':38B 'funkce':42B 'mlad':22B 'vuka':31B 'vdec':23B 'kola':35B 'bohat':3B 'lidsk':1A 'pln':8B 'stavb':40B 'vhodnou':18B 'daj':10B 'kolit':35B 'genetika':55B 'kapitola':51B 'podv':36B 'vechny':21B 'lidskho':6B,43B 'chorobch':48B 'doplnn':11B 'praktickou':27B 'publikac':29B 'souasn':25B 'statistika':16B 'vnovan':53B 'zkladn':34B,37B 'doplkovou':28B 'jednoduch':15B 'pruka':19B 'samostatn':50B 'encyklopedie':5B 'ilustrovan':4B 'prodopis':32B 'vysvtlivka':13B 'zajmavch':9B"""

tsv = object.__new__(TSV)
tsv.enc = 'utf-8'

class TestTSVector(TestCase):
    
    def test30_FromSql(self):
        self.assertEqual(
            tsv.fromSql("").parts,
            ()
        )
        self.assertEqual(
            tsv.fromSql("'foo':1A,7B,304C ").parts, (
            (u'foo', u'A'), (u'foo', u'B'), (u'foo', u'C')
        ))
        self.assertEqual(
            tsv.fromSql("'foo':1A 'bar':2A").parts, (
            (u'foo', u'A'), (u'bar', u'A')
        ))



suite = Suite(TestTSVector)
if __name__ == '__main__':
    Main()
