# -*- coding: utf-8 -*-

import sys

from wm4.api import *
from wm4.web.forms.api import *
from wm4.web.forms.listings import *

from lib4.imports import importObject

from comp4.fulltext.entities import *


class FulltextListing(ListingCtrl):
    baseQuery = '''[obj for obj in 'fulltext/Fulltext']'''
    defaultOrder = '-tsrank'

    class term(InputCtrl, FilterMixin):

        def val(self):
            val = self.newValue
            if val in (NOT_GIVEN, None, ''):
                return None
            return u' & '.join([t.lower() for t in val.split()])
        val = binding.Make(val)

        def makeCond(self):
            if self.val:
                tsq = TSQuery('cs', self.val)
                yield self.parseSubexpr('TSMatch(obj.vector, tsq)')
            else:
                yield self.parseSubexpr("obj.klass=='xxxx'")

    class tsrank(Column):
        def parseSubexpr(self, expr):
            frame = sys._getframe(1)
            return self.listingCtrl.parsedQuery.parseSubexpr(expr, frame)

        def queryExpr(self):
            term = self['../term'].val
            if term:
                tsq = TSQuery('cs', term)
                return self.parseSubexpr('TSRank(obj.vector, tsq)')
            return None
        queryExpr = binding.Make(queryExpr)



class FulltextHandler(web.Handler):

    def do_list(self):
        ctrl = importObject(self.req.params['listingCtrl'])
        lst = ctrl(self.req)
        lst()
        return self.render(listing=lst, term=lst['term'].newValue)


