#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import os.path
import re

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from lib4.images import ImageConverter


__all__ = ['resize_for', 'ImageSizerSitemap']



def resize_for(req, *argv, **kwds):
    pi = req.route_for(*argv).pathInfo
    if pi.startswith('/'): pi = pi[1:]
    url = '/resize/%s/%d/%d/%s' % (
        kwds.get('ratio', 'keep'),
        int(kwds.get('width',sys.maxint)),
        int(kwds.get('height',sys.maxint)),
        pi,
    )
    return url


class ImageSizerSitemap(Route):
    virtual = True
    maxsize = Const(2000)
    include = Const([])
    exclude = Const([])

    class resize(Route):
        handler = Const('comp4.images.web.ResizeHandler')
        match = 'resize/:ratio/:width/:height/*imgurl'
        action = Const('img')
        ratio = Param(lambda s: str(s.converter.ratio), typ=str)
        width = Param(lambda s: int(s.converter.maxSize[0]), typ=int)
        height = Param(lambda s: int(s.converter.maxSize[1]), typ=int)
        imgurl = Param()
        appURL = Param(lambda s: web.request().appURL)

        def url(self):
            # include
            for r in self.include:
                if re.match(r, self.imgurl):
                    break
            else:
                raise Exception, web.NotFound()
            # exclude
            for r in self.exclude:
                if re.match(r, self.imgurl):
                    raise Exception, web.NotFound()
            url = os.path.join(self.appURL, self.imgurl)
            #XXX https?
            if url.startswith('https://'):
                url = 'http://' + url[8:]
            return url
        url = Param(url)

        converter = Param(lambda s: ImageConverter(
                                ratio=s.ratio, 
                                maxSize=(min(s.width, s.maxsize), 
                                         min(s.height, s.maxsize))))


