#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sha
import os, os.path
import pickle
import urllib2
from cStringIO import StringIO

from wm4.api import *
from lib4.imports import importObject
import lib4.images



class ResizeHandler(web.Handler):
    
    def do_img(self, req, converter, url):
        d = sha.new()
        d.update(url)
        d.update(converter.ratio)
        d.update(str(converter.maxSize))
        digest = d.hexdigest()

        pth = os.path.join(
                '/var/tmp/wm4.images.%s' % settings.application_name(),
                digest[0:2], digest[2:4])
        if not os.path.isdir(pth):
            os.makedirs(pth)
            os.chmod(pth, 0700)
        fname = os.path.join(pth, digest)
        fname_h = os.path.join(pth, digest + '.head')
        
        if os.path.isfile(fname) and os.path.isfile(fname_h):
            img_data = file(fname, 'rb').read()
            headers = pickle.load(file(fname_h, 'r'))
        else:
            img = converter(StringIO(urllib2.urlopen(url).read()))
            img_data = lib4.images.getImageData(img)
            file(fname, 'wb').write(img_data)
            headers = []
            headers.append(('Content-Length', str(len(img_data))))
            headers.append(('Content-Type', lib4.images.getMIME(img)))
            pickle.dump(headers, file(fname_h, 'w'))

        resp = req.response
        for (k, v) in headers:
            resp.addheader(k, v)
        resp.body = [img_data]
        return resp

