#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms.api import *
from wm4.web.forms.listings import *

from comp4.antispam.web import JSExprAntispamCtrl


_ = i18n.MessageIDFactory('comp4.mailform')

class Form_contact(FormCtrl):
    ctrlName = '_contactForm'
    ctrlLabel = _(u'Contact form')

    def ctrlInit(self, ctrlReq, ctrlName, ctrlParent, oldValue, kw):
        self.ctrlReq = ctrlReq
        #konstruktor nesmi prerazit default# self.ctrlName = ctrlName
        self.ctrlParent = ctrlParent
        if oldValue is not NOT_GIVEN:
            self.oldValue = oldValue
        binding.initAttrs(self, kw.items())

    class name(InputCtrl):
        ctrlLabel = _(u'Your name')

    class phone(InputCtrl):
        ctrlLabel = _(u'Telephone number')

    class email(InputCtrl):
        ctrlLabel = _(u'E-mail')
        def parseValue(self, val):
            val = InputCtrl.parseValue(self, val)
            from lib4.validators import checkEmail
            if not checkEmail(val):
                raise schema.FeatureSyntaxError(
                        self.ctrlName, value=val)
            return val

    class message(TextAreaCtrl):
        ctrlLabel = _(u'Your message')
        ctrlRequired = True
        rows = 10
        cols = 50

    class validator(JSExprAntispamCtrl): pass
