#!/usr/bin/env python
# -*- coding: utf-8 -*-

'''
using forms prepared in this module
===================================

in application/sitemap.py:
    class mailform(mailform.MailFormSitemap):pass

creating your own form
======================

in application/sitemap.py:

    class mailform(mailform.MailFormSitemap):
        class your_own_form(mailform.FormRoute):
            domain = Const('application')

in application/app.ini:

    [Plugin comp4.sendmail:mail_your_own_form]
    subject = u'Subject'
    message = sm4.Tempita(file='pkgfile:application/your_own_form.tt')
    sender = 'sender@domain.cz'
    recipients = ['recipient@domain.cz']


in application/controllers.py:

    class Form_your_own_form(FormCtrl):
        pass

create application/form_your_own_form.wt with template of your form
and application/your_own_form.tt with template of mail.
'''

from wm4.api import *
from wm4.web.routes import *
from wm4.utils.clspatch import patch


class FormRoute(Route):
    match = binding.classAttr(binding.Make(lambda c: '%s/' % c.__name__))
    handler = Const('comp4.mailform.web.MailFormHandler')
    action = Const('form')
    name = binding.classAttr(binding.Make(lambda c: Const(c.__name__)))
    template = Param(lambda s: '%s/form_%s.wt' % (s.domain, s.name))
    form = Param(lambda s: '%s.controllers.Form_%s' % (s.domain, s.name))
    signature = Signature('domain', 'name')

    class thanks(Route):
        match = 'thanks'
        action = Const('thanks')
        template = Param(lambda s: '%s/thanks.wt' % s.domain)
        signature = Signature('domain', 'name', 'action')


class MailFormSitemap(Route):
    virtual = True
    match = 'mailform/'
    domain = Const('comp4.mailform')

    class contact(FormRoute): pass

