#!/usr/bin/env python
# -*- coding: utf-8 -*-

from datetime import datetime

from wm4.api import *
from lib4.imports import importObject
from comp4.sendmail.api import sendmail, sendmail_comp

from controllers import *

_ = i18n.MessageIDFactory('comp4.mailform')

class MailFormHandler(web.Handler):

    def data_dict(self, form):
        d = dict([(f.ctrlName, 
                   (web.render(self.req, f.ctrlLabel), 
                    [f.newValue, ''][f.newValue in (None, NOT_GIVEN)]))
                     for f in form.ctrlIter()
                     if f.ctrlName not in (None, 'doSubmit')
                    ])

        env = self.req.environ
        ip = env['REMOTE_ADDR']
        if 'HTTP_X_FORWARDED_FOR' in env:
            ip = '%s/%s' % (ip, env['HTTP_X_FORWARDED_FOR'])
        d['_sender_ip'] = (web.render(self.req, _(u'IP address')), ip)
        d['_created'] = (web.render(self.req, _(u'created')), datetime.now())

        return d

    def sendmail(self, form):
        data = self.data_dict(form)
        name = self.req.params['name']
        subject = web.render(
                self.req, 
                sendmail_comp().params('mail_%s' % name).get('subject', ''))
        sendmail('mail_%s' % name, subject=subject, _data=data)

    def do_form(self):
        form = importObject(self.req.params['form'])(self.req)
        if form():
            self.sendmail(form)
            raise web.SeeOther(self.req.get_url(
                self.req.params['domain'], self.req.params['name'], 'thanks'))
        else:
            return self.render(form=form)

    def do_thanks(self):
        return self.render()
