#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *

from lib4 import images

from comp4.maps.entities import MapManager






def generuj_mapu(lt, rb, druh):
    """na vstupu levy horni, pravy dolni roh a druh mapy
       na vystupu obrazek
    """
    mapinfo = MapManager().getDruh(druh)
    center = ((lt[0]+rb[0])/2, (lt[1]+rb[1])/2)
    mapinfo.setCenter(x=center[0], y=center[1])

    out_w = int(abs(lt[0]-rb[0]) / mapinfo.mapa.worldfile[0])
    out_h = int(abs(lt[1]-rb[1]) / mapinfo.mapa.worldfile[0])

    mapinfo.out_w = mapinfo.mapa.out_w = out_w
    mapinfo.out_h = mapinfo.mapa.out_h = out_h

    image = mapinfo.mapa.image(center)
    image.format = 'PNG'

    return image


if __name__ == '__main__':
    config.loadConfig('pkgfile:wm4/core.ini', 'pkgfile:zlintip/nondist.ini')
    for (lt, rb, nazev) in [
                ((-559000, -1172997), (-547928, -1178984), 'korycany'),
                ((-543025, -1181012), (-532042, -1191936), 'slovacko'),
                ((-505063, -1168928), (-495993, -1181997), 'vysokepole'),
                ((-475737, -1153917), (-472028, -1158698), 'beskydy'),]:
        mapa = generuj_mapu(lt, rb, 'm50k.full')
        file('%s_mapa.png' % nazev, 'w').write(images.getImageData(mapa))

