#!/usr/bin/env python
# -*- coding: ISO-8859-2 -*-

import math

from wm4.api import *

from lib4 import maps
from lib4 import iterutils

class Mapa(object):
    pass

class MapManager(binding.Component):

    def druhy(self):
        return dict(
            (d.druh, d) for d in config.Property('maps.druh')()
        )
    druhy = binding.Make(druhy)

    def getDruh(self, d):
        try:
            return self.druhy[d]
        except:
            raise web.NotFound('Druh mapy nenalezen', d)

    def req2mapinfo(self, req, obj):
        druh = config.Property('maps.default_druh')()
        mapInfo = MapManager().getDruh(req.getValue('d', druh))
        mapInfo.setCenter(req=req, obj=obj)
        return mapInfo



class MapaDruh(binding.Component):

    druh = binding.Require()

    modified = binding.Make(
        lambda s: config.Property('maps.modified.%s' % s.druh)()\
    )

    format = binding.Make(
        lambda s: config.Property('maps.format.%s' % s.druh)()\
    )

    meritko = binding.Make(
        lambda s: config.Property('maps.meritko.%s' % s.druh)()
    )
    tiles_directory = binding.Make(
        lambda s: config.Property('maps.tiles_directory.%s' % s.druh)()
    )
    tile_filename_mask = binding.Make(
        lambda s: config.Property('maps.tile_filename_mask.%s' % s.druh)()
    )
    tile_w = binding.Make(
        lambda s: config.Property('maps.tile_w.%s' % s.druh)()
    )
    tile_h = binding.Make(
        lambda s: config.Property('maps.tile_h.%s' % s.druh)()
    )
    map_w = binding.Make(
        lambda s: config.Property('maps.map_w.%s' % s.druh)()
    )
    map_h = binding.Make(
        lambda s: config.Property('maps.map_h.%s' % s.druh)()
    )
    out_w = binding.Make(
        lambda s: config.Property('maps.out_w.%s' % s.druh)()
    )
    out_h = binding.Make(
        lambda s: config.Property('maps.out_h.%s' % s.druh)()
    )
    worldfile = binding.Make(
        lambda s: config.Property('maps.worldfile.%s' % s.druh)()
    )
    logo = binding.Make(
        lambda s: config.Property('maps.logo.%s' % s.druh)()
    )
    logo_position = binding.Make(
        lambda s: config.Property('maps.logo_position.%s' % s.druh)()
    )

    zoom_order = binding.Make(
        lambda s: config.Property('maps.zoom_order')()
    )
    tiles_root = binding.Make(
        lambda s: config.Property('maps.tiles_root')()
    )
    tiles_url_root = binding.Make(
        lambda s: config.Property('maps.tiles_url_root')()
    )

    mapa = binding.Make(
        lambda s: maps.MapInfo(meritko=s.meritko,
                               tiles_root=s.tiles_root,
                               tiles_directory=s.tiles_directory,
                               tiles_url_root=s.tiles_url_root,
                               tile_filename_mask=s.tile_filename_mask,
                               tile_w=s.tile_w,
                               tile_h=s.tile_h,
                               map_w=s.map_w,
                               map_h=s.map_h,
                               out_w=s.out_w,
                               out_h=s.out_h,
                               worldfile=s.worldfile)
    )


    def etag(self, center, proj):
        c = self.mapa.convertCoords(center, proj)
        return str('"MAP-%s-%s-%s"' % (c[0], c[1], proj))

    
    x = y = ''
    def setCenter(self, **kw):
        if 'req' in kw and 'obj' in kw:
            if 'x' in kw['req'] and 'y' in kw['req']:
                (self.x, self.y) = (float(kw['req'].getValue('x')), 
                                    float(kw['req'].getValue('y')))
            else:
                try:
                    (self.x, self.y) = kw['obj'].souradnice
                except:
                    pass
        elif 'x' in kw and 'y' in kw:
            self.x = float(kw['x'])
            self.y = float(kw['y'])

    # metody vracejici souradnice po posunuti mapy do 
    # jednotlivych svetovych stran
    moveratio = 2
    def moveNorth(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x, y-(self.out_h/self.moveratio)))
    def moveSouth(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x, y+(self.out_h/self.moveratio)))
    def moveEast(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x+(self.out_w/self.moveratio), y))
    def moveWest(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x-(self.out_w/self.moveratio), y))
    def moveNorthWest(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x-(self.out_w/self.moveratio), 
                                   y-(self.out_h/self.moveratio)))
    def moveNorthEast(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x+(self.out_w/self.moveratio), 
                                   y-(self.out_h/self.moveratio)))
    def moveSouthWest(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x-(self.out_w/self.moveratio), 
                                   y+(self.out_h/self.moveratio)))
    def moveSouthEast(self, sjtsk):
        (x, y) = self.mapa.sjtsk2xy(sjtsk)
        return self.mapa.xy2sjtsk((x+(self.out_w/self.moveratio), 
                                   y+(self.out_h/self.moveratio)))

    def zoomIn(self):
        '''vrati nasledujici mapu v poradi'''
        try:
            i = self.zoom_order.index(self.druh)
            if i == 0:
                return None
            return self.zoom_order[i-1]
        except: 
            return None
    zoomIn = binding.Make(zoomIn, suggestParent=False)
        
    def zoomOut(self):
        '''vrati nasledujici mapu v poradi'''
        try:
            i = self.zoom_order.index(self.druh)
            return self.zoom_order[i+1]
        except: 
            return None
    zoomOut = binding.Make(zoomOut, suggestParent=False)
        

    def mapaBox(self):
        (l,t,r,b) = self.mapa.box(*self.mapa.sjtsk2xy((self.x, self.y)))
        (l,t) = self.mapa.xy2sjtsk((l,t))
        (r,b) = self.mapa.xy2sjtsk((r,b))
        return (l,t,r,b)




class IconBox(object):

    def __init__(self, mapInfo, cil, tag, iconsize=(19, 19)):
        # umisteni iconboxu v pixelovych souradnicich cele mapy
        self._left = None
        self._top = None
        
        self.mapInfo = mapInfo
        
        # velikost jedne ikonky
        self.icon_w = iconsize[0]
        self.icon_h = iconsize[1]

        # ikonbox obsahuje ikonu pro typ cile, po touto ikonou jsou
        # pak skryte vsechny cile tohoto typu
        self.ikony = {tag: [cil]}
       
        # (l,r,t,b) souradnice zobrazeneho vyrezu mapy
        self.mapa_box = self.mapInfo.mapa.box(*self.mapInfo.mapa.sjtsk2xy(
                                            (self.mapInfo.x, self.mapInfo.y)))

        # inicialni umisteni se pocita ze souradnic cile
        (cil_l, cil_t) = self.mapInfo.mapa.sjtsk2xy(
                                                (cil.sourad_x, cil.sourad_y))
        self.left = cil_l-self.icon_w/2
        self.top = cil_t-self.icon_h/2


    def get_rad(self):
        '''ikony v ikonboxu se radi do matice. tato fce vraci jeji rad'''
        return int(math.ceil(math.sqrt(len(self.ikony.keys()))))
    rad = property(get_rad)




    # velikost boxu v pixelech
    def get_width(self):
        '''sirka tohoto ikonboxu'''
        return self.rad * (self.icon_w+2)
    width = property(get_width)

    def get_height(self):
        '''vyska ikonboxu'''
        return int(math.ceil(float(len(self.ikony.keys()))/self.rad)) * \
                                                            (self.icon_h+2)
    height = property(get_height)



    # souradnice boxu v ramci cele mapy
    def get_left(self):
        '''levy okraj ikonboxu'''
        return self._left
    def set_left(self, value):
        self._left = max(min(self.mapa_box[2]-self.width, 
                             value),
                         self.mapa_box[0])
    left = property(get_left, set_left)
    
    def get_right(self):
        '''pravy okraj ikonboxu'''
        return self.left + self.width
    right = property(get_right)

    def get_top(self):
        '''horni okraj ikonboxu'''
        return self._top
    def set_top(self, value):
        self._top = max(min(self.mapa_box[3]-self.height,
                            value),
                        self.mapa_box[1])
    top = property(get_top, set_top)

    def get_bottom(self):
        '''dolni okraj ikonboxu'''
        return self.top + self.height
    bottom = property(get_bottom)


    # souradnice v ramci obrazku se zobrazenym vyrezem
    def get_img_position(self):
        return (self.left - self.mapa_box[0],
                self.top - self.mapa_box[1])
    img_position = property(get_img_position)


    def merge(self, other):
        '''slouci se s druhym ikonboxem'''
        # sloucit ikony
        for (tag, cile) in other.ikony.iteritems():
            self.ikony.setdefault(tag, []).extend(cile)
        self.left = (self.left+other.right)/2 - self.width/2
        self.top = (self.top+other.bottom)/2 - self.height/2



        
