BEGIN;


CREATE TABLE media (
    pkey            SERIAL NOT NULL,

    name            VARCHAR NOT NULL,
    description     VARCHAR,
    "type"          VARCHAR NOT NULL,

    parameters      VARCHAR,

    PRIMARY KEY (pkey)
);


CREATE TABLE media_file (
    pkey            SERIAL NOT NULL,
    media           INTEGER NOT NULL,
    "type"          VARCHAR NOT NULL,

    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,

    PRIMARY KEY (pkey)
);

CREATE TABLE media_image (
    pkey            SERIAL NOT NULL,
    media           INTEGER NOT NULL,
    "type"          VARCHAR NOT NULL,
    PRIMARY KEY (pkey)
);

CREATE TABLE media_image_res (
    pkey            SERIAL NOT NULL,
    image           INTEGER NOT NULL,
    resolution      VARCHAR NOT NULL,

    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,
    "width"         INTEGER NOT NULL,
    "height"        INTEGER NOT NULL,

    PRIMARY KEY (pkey)
);


END;

