#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

import entities

__all__ = ['MediaSitemap']



def Tmpl(filename):
    return Const('comp4.media.templates/%s' % filename)

def Ctrl(name):
    return Const('comp4.media.controllers.%s' % name)

class MediaSitemap(Route):
    match = 'media/'
    virtual = True

    class RMedia(EntitySitemap):
        match = ''
        clsObj = Const(entities.Media)
        handler = Const('comp4.media.web.MediaHandler')

        patch({
            'cls.list.controller': Ctrl('MediaListing'),
            'cls.list.template': Tmpl('media_list.wt'),
            'cls.add.controller': Ctrl('MediaForm'),
            'cls.add.template': Tmpl('media_type.wt'),
            'obj.controller': Ctrl('mediaFormFactory'),
            'obj.view.template': Tmpl('media_view.wt'),
            'obj.edit.template': Tmpl('media_form.wt'),
            })

        class cls(EntitySitemap.cls):
            class add(EntitySitemap.cls.add):
                type = Const(None)
                class add(Route):
                    match = '/:typeid'
                    typeid = Param(lambda s: s.type.name)
                    type = Param(lambda s: entities.MediaType[s.typeid],
                                    typ=entities.MediaType)
                    template = Tmpl('media_form.wt')
                    signature = Signature('clsObj', 'action', 'type')

    class RFile(EntitySitemap):
        match = 'file/'
        clsObj = Const(entities.MediaFile)
        handler = Const('comp4.media.web.FileHandler')
        class obj(EntitySitemap.obj):
            class view(EntitySitemap.obj.view):
                class viewfname(Route):
                    match = 'fname/*fname'
                    fname = Param(lambda s: '')

    class RImageRes(EntitySitemap):
        match = 'image/'
        clsObj = Const(entities.MediaImageRes)
        handler = Const('comp4.media.web.ImageHandler')


