#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms import api as forms
from wm4.web.forms.listings import *

from lib4.imports import importObject
from lib4.iterutils import iterDecorator

from comp4.files.web import makeResponse

from entities import *
from controllers import *


__all__ = ['MediaHandler', ]




class MediaHandler(web.BaseHandler):
    
    def do_add(self, req, clsObj, controller, action, type):
        if type is None:
            return self.render(clsObj=clsObj)
        else:
            form = importObject('%s_%s' % (controller, type.name))(ctrlReq=req)
            if form():
                url = req.get_url(form.newValue)
                storage.commit()
                storage.begin()
                raise web.SeeOther(url)
            else:
                if form.formErrors:
                    storage.abort()
                    storage.begin()
                return self.render(
                    form=form, clsObj=clsObj, obj=None, action=action
                )


class FileHandler(web.EntityHandler):
    entity = MediaFile
    def do_view(self):
        return makeResponse(self.req, self.req.params['obj'], 'attachment')


class ImageHandler(web.EntityHandler):
    entity = MediaImage
    def do_view(self):
        return makeResponse(self.req, self.req.params['obj'], 'inline')



