from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *

__all__ = ['NewsSitemap']

class NewsSitemap(web.EntitySitemap):
    match = 'news/'
    handler = Const('comp4.news.web.NewsHandler')
    listingCtrl = Const('comp4.news.web.NewsListing')
    clsObj = Const(News)

    class cls(web.EntitySitemap.cls):
        class icons(ClassRoute):
            permission = Param(lambda s: s.viewPerm)
        class rss(ClassRoute):
            permission = Param(lambda s: s.viewPerm)
            template = Const('comp4.news/rss.wt')
            controller = Const('comp4.news.web.NewsListing')
            handler = Const('comp4.news.web.NewsRssHandler')

        class section(Route):
            match = 'section/:section/'
            action = Const('section')
            section = Param('section')
            signature = Signature('clsObj', 'action', 'section')
            template = Const('comp4.news/fragment.wt')

    patch({
        'cls.list.template'  : Const('comp4.news/list.wt'),
        'cls.add.template'   : Const('comp4.news/form.wt'),
        'cls.icons.template' : Const('comp4.news/icons.wt'),
        'obj.view.template'  : Const('comp4.news/form.wt'),
        'obj.edit.template'  : Const('comp4.news/form.wt'),
    })
