#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms.api import *
from wm4.web.forms.listings import *

from xml4 import xhtml as xh
from lib4.imports import importObject

from comp4.dbgettext.web import DBGettextCtrl, DBGettextHtmlCtrl

from entities import *

_ = i18n.MessageIDFactory('comp4.noticeboard')



class NoticeboardForm(makeFormCtrl(Noticeboard)):
    featureCommiting = {
            '*': 'before',
            }

    class section(SelectCtrl):
        ctrlRequired = True
        ctrlLabel = _(u'Section')
        def selectOptions(self):
            return [
                (unicode(n), unicode(l), unicode(n)) 
                for n, l in section_names()
                ]
        selectOptions = binding.Make(selectOptions)

    class content(HtmlCtrl):
        cols = 60
        rows = 10

    class _name(DBGettextCtrl):
        set_on_change = '../name'

    class _content(DBGettextHtmlCtrl):
        ctrlWidget = web.FORM_WIDGET('input.noticeboard.html')
        set_on_change = '../content'
        toolbarSet = 'BasicUpload'
        fckUploadId = 'fckup'


    





class NoticeboardLst(ListingCtrl):
    baseQuery = '''[obj for obj in 'noticeboard/Noticeboard']'''

    class pkey(Column):
        queryExpr = 'obj.pkey'
        ctrlLabel = _(u'ID')

    class name(LikeFilter):
        queryExpr = 'obj.name'
        ctrlLabel = _(u'Name')

    class section(NoticeboardForm.section, FilterMixin):
        ctrlRequired = False
        queryExpr = 'obj.section'


