#!/usr/bin/env python
# -*- coding: utf-8 -*-

from xml4.elements import Literal

from wm4.api import *
from wm4.schema.api import *

from adt4.serial import Serial

import comp4.dbgettext.api as dbgettext


section_names = config.Property('comp4.noticeboard.section_names')


class Noticeboard(Entity):
    pkey = Attribute(Serial)

    section = Attribute(unicode)
    ident = Attribute(unicode)
    name = Attribute(unicode, Required)
    _name = dbgettext.Translations('name')
    content = Attribute(unicode)
    _content = dbgettext.Translations('content', useDefault=False)

    html = binding.Make(lambda s: Literal(s._content or ''))

    binding.metadata(PrimaryKey('pkey'))




class NoticeboardComponent(schema.SchemaComponent):

    txnAttrs = ('idents',)

    def listForSection(self, section):
        return list(settings.workspace()("""[
            p for p in Noticeboard
               if p.section==section
              and query.OrderBy(query.Desc(p._oid))
            ]"""))

    def idents(self):
        self.joinedTxn
        ws = settings.workspace()
        return dict(ws(
            '[(o.ident, o) for o in Noticeboard if o.ident is not None]'))
    idents = binding.Make(idents)



