BEGIN;

CREATE TABLE "photo" (
    "pkey"          SERIAL NOT NULL,
    "name"          VARCHAR NOT NULL,
    "author"        VARCHAR,
    "created"       DATE,
    "quality"       INTEGER NOT NULL DEFAULT 5,
    "kind"          VARCHAR NOT NULL,
    "description"   TEXT,

    PRIMARY KEY ("pkey")
);

CREATE TABLE "photo_res" (
    "photo"         INTEGER NOT NULL,
    "resolution"    VARCHAR NOT NULL,
    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,
    "width"         INTEGER NOT NULL,
    "height"        INTEGER NOT NULL,

    PRIMARY KEY("photo", "resolution")
);



CREATE TABLE photogallery (
    pkey            SERIAL NOT NULL,
    section         VARCHAR,
    ident           VARCHAR,

    name            VARCHAR NOT NULL,
    description     TEXT,

    PRIMARY KEY ("pkey")
);


CREATE TABLE photogallery_photo (
    pkey            SERIAL NOT NULL,

    photogallery    INTEGER NOT NULL,
    photo           INTEGER NOT NULL,

    ordernum        INTEGER NOT NULL,

    PRIMARY KEY ("pkey")
);
CREATE INDEX idx_photogallery_photo_gal ON photogallery_photo(photogallery);

END;
