#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.forms.api import *
from wm4.web.forms.listings import *
from wm4.utils.clspatch import patch

from lib4.imports import importObject

from entities import *


_ = i18n.MessageIDFactory('comp4.poll')


section_names = config.Property(
    'comp4.poll.section_names', [])


class PollForm(makeFormCtrl(Poll)):

    featureCommiting = {
            '*': 'before',
            'options': 'after',
            }

    class options(SequenceCtrl):
        ctrlLabel = _(u'Options')

        class itemClass(makeFormCtrl(PollOption), SequenceItemCtrl):

            class poll(InputCtrl):
                ctrlType = Poll
                ctrlRequired = True
                ctrlVisibility = binding.Constant('hidden')
                def defaultOutput(self):
                    return self['../../../'].newValue

            class ordernum(InputCtrl):
                ctrlType = int
                ctrlRequired = True
                ctrlVisibility = binding.Constant('hidden')
                def defaultOutput(self):
                    return self.ctrlParent.itemPosition

            patch({
                'option.ctrlLabel': _(u'Option'),
                })

        def updateContainer(self, removed):
            ws = settings.workspace()
            for i in removed:
                ws.remove(self.oldValue[i])

    class key(SelectCtrl):
        ctrlRequired = True
        ctrlLabel = _(u'Section')
        def selectOptions(self):
            return [
                (unicode(n), unicode(l), unicode(n)) 
                for n,l in section_names()
            ]
        selectOptions = binding.Make(selectOptions)

    patch({
        'question.ctrlLabel': _(u'Question'),
        'closed.defaultInput': lambda s: False,
        'published.defaultInput': lambda s: True,
        })

    

    

class PollListing(ListingCtrl):
    baseQuery = '''[obj for obj in 'poll/Poll']'''

    class pkey(Column):
        queryExpr = 'obj.pkey'
        ctrlLabel = _(u'ID')

    class question(LikeFilter):
        queryExpr = 'obj.question'
        ctrlLabel = _(u'Question')

    class published(Column):
        queryExpr = 'obj.published'
        ctrlLabel = _(u'Published')

    class closed(Column):
        queryExpr = 'obj.closed'
        ctrlLabel = _(u'Closed')





