#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *

__all__ = ['PollSitemap']



class PollSitemap(web.EntitySitemap):
    match = 'poll/'
    handler = Const('comp4.poll.web.PollHandler')
    clsObj = Const(Poll)
    listingCtrl = Const('comp4.poll.controllers.PollListing')

    class obj(web.EntitySitemap.obj):
        actionLinks = Lazy(lambda s: web.actionLinks(
                s, '',
                './export_csv',
                './edit', './delete', web.DELIMITER,
                '../', '../add',
            ))

        class export_csv(InstanceRoute):
            permission = Param(lambda s: s.editPerm)
            asAction = Lazy(lambda s: web.Link.fromRoute(
                                s, label=u'Seznam hlasujících'))

        class vote(InstanceRoute):
            permission = Param(lambda s: s.viewPerm)

    patch({
        'cls.list.template': Const('comp4.poll/poll_list.wt'),
        'cls.add.template' : Const('comp4.poll/poll_form.wt'),
        'obj.view.template': Const('comp4.poll/poll_view.wt'),
        'obj.edit.template': Const('comp4.poll/poll_form.wt'),
    })
