#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os.path
import lxml.etree as ET
import httplib2

from wm4.api import *
from wm4.schema.api import *



class PrevioAPI(object):

    def dict2et(self, et, d):
        for k, v in d.iteritems():
            if type(v)==dict:
                sub = ET.SubElement(et, k)
                self.dict2et(sub, v)
            else:
                ET.SubElement(et, k).text = unicode(v)

    def request(self, **params):
        req = ET.Element('request')
        self.dict2et(req, params)
        return ET.tostring(req, 
                encoding='utf-8', xml_declaration=True, pretty_print=True)


    def command(self, command, **params):
        '''
        command - operace z API previa (napr. System.getZips
        params - dictionary s potrebnymi parametry
        login a password se doplni automaticky z konfigurace
        '''
        base_url = config.Property('previo.base_url')()
        if not 'login' in params:
            params['login'] = config.Property('previo.login')()
        if not 'password' in params:
            params['password'] = config.Property('previo.password')()
        
        url = command.replace('.', '/')
        url = url[0].lower() + url[1:]
        url = os.path.join(base_url, url)

        req = self.request(**params)

        http = httplib2.Http()
        response, content = http.request(url, 'POST', body=req)

        return response, content

