from wm4.api import *
from wm4.running import commands, options
import comp4.registration.api as registration
from lib4 import timeutils

__all__ = ['CleanUnverified', 'Remind']



class CleanUnverified(commands.ConfiguredCommandLineApp):
    
    usage = 'Clear unverified registration periodically'

    timeout = binding.Constant(2*86400,
        options.Set('--timeout', type=int, help="Timeout in seconds"))

    workspace = binding.Make(lambda: settings.workspace())

    def main(self):
        super(ClearUnverified, self).main()
        storage.begin()
        timeout = timeutils.Now() - timeutils.timedelta(seconds=self.timeout)

        q = '''[query.Delete(e) for e in registration.RegisteredUser
                 if e.verified is None and e.created < timeout]'''
        self.workspace(q)

        q = '''[query.Delete(e) for e in registration.RegisteredEmailChange
                 if e.verified is None and e.created < timeout]'''
        self.workspace(q)

        storage.commit()


class Remind(commands.ConfiguredCommandLineApp):
    
    def main(self):
        super(ClearUnverified, self).main()
        raise NotImplementedError



if __name__ == '__main__':
    cmd = CleanUnverified()
    cmd.run()
