BEGIN;

CREATE TABLE registered_user (
    "uid"            SERIAL NOT NULL,
    "login"          VARCHAR NOT NULL,
    "password"       VARCHAR,
    "email"          VARCHAR NOT NULL,
    "name"           VARCHAR NOT NULL,
    "company"        VARCHAR,
    "phone"          VARCHAR,
    "mobile"         VARCHAR,
    "skype"          VARCHAR,
    "web"            VARCHAR,

    "created"        TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT NOW(),
    "key"            VARCHAR NOT NULL,
    "verified"       TIMESTAMP WITH TIME ZONE,

    "active"         BOOLEAN NOT NULL DEFAULT True,
    "approved"       TIMESTAMP WITH TIME ZONE,
    "home"           VARCHAR,

    PRIMARY KEY("uid"),
    UNIQUE("login"),
    UNIQUE("key"),
    UNIQUE("home")
);

CREATE TABLE registered_user_preferences (
    "pkey"           SERIAL NOT NULL,
    "user"           INTEGER NOT NULL,
    "pref"           VARCHAR NOT NULL,
    "value"          VARCHAR,

    PRIMARY KEY("pkey")
);

CREATE INDEX registered_user_preferences_idx
    ON registered_user_preferences ("user", "pref");


CREATE TABLE registered_user_param (
    "pkey"           SERIAL NOT NULL,
    "user"           INTEGER NOT NULL,
    "param"          VARCHAR NOT NULL,
    "value"          VARCHAR,

    PRIMARY KEY("pkey")
);

CREATE TABLE registered_email_change (
    "user"           INTEGER NOT NULL,
    "email"          VARCHAR NOT NULL,

    "created"        TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT NOW(),
    "key"            VARCHAR NOT NULL,
    "verified"       TIMESTAMP WITH TIME ZONE,

    PRIMARY KEY("user"),
    UNIQUE("key")
);

CREATE TABLE registered_sendmail (
    "sent"          TIMESTAMP WITH TIME ZONE NOT NULL,
    "sender"        VARCHAR,
    "recipients"    VARCHAR,
    "subject"       VARCHAR,
    "message"       VARCHAR,

    PRIMARY KEY("sent")
);

END;
