# -*- coding: utf-8 -*-

from unittest import *
from wm4.api import *
from comp4.registration.api import *
from wm4.schema.tests.utils import *

class TestBase(TestCase):
    
    def setUp(self):
        self.exit_ = config.loadConfig(
            'pkgfile:comp4.registration/comp.ini',
            'pkgfile:comp4.registration.tests/test.ini',
        )

    def tearDown(self):
        self.exit_()



class TestSMTP(TestBase):

    def XXXtest(self):
        settings.language('cs')
        msg = i18n.MessageID(
                u'Registration Verification',
                domain = 'comp4.registration',
            )
        t = settings.translation_service().translate(msg, lang='cs')
        print (msg, t)
        msg = config.Property('comp4.registration.verification.subject')()
        t = settings.translation_service().translate(msg, lang='cs')
        print (msg, t)
        reg = Registration()
        r = reg.sendMail('verification', (u'Testovič', 'test@uh.cz'), {})


class TestKeyGeneration(MockWorkspaceCase):
    
    def _unique_key(self, sql):
        assert sql.startswith(
            "SELECT key FROM registered_user WHERE key = '")
        return []

    def _nonunique_key(self, sql):
        assert sql.startswith(
            "SELECT key FROM registered_user WHERE key = '")
        return [('foo',)]

    def test01_GenKeyUnique(self):
        self.expects(transaction='begin')
        self.expects(sql=self._unique_key)
        self.expects(transaction='commit')

        storage.begin()
        reg = Registration()
        key = reg.genKey(RegisteredUser, 'key')
        self.assertEqual(len(key), reg.key_length)
        storage.commit()
    
    def test02_GenKeyNonunique(self):
        self.expects(transaction='begin')
        self.expects(sql=self._nonunique_key)
        self.expects(sql=self._unique_key)
        self.expects(transaction='commit')

        storage.begin()
        reg = Registration()
        key = reg.genKey(RegisteredUser, 'key')
        self.assertEqual(len(key), reg.key_length)
        storage.commit()
    
    
def suite():
    return TestSuite((
        makeSuite(TestSMTP),
        makeSuite(TestKeyGeneration),
        #makeSuite(TestRegistration),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
