BEGIN;

CREATE TABLE relation(
  pkey       SERIAL NOT NULL,
  src_cls    VARCHAR NOT NULL,
  src_key    VARCHAR,
  kind       VARCHAR,
  dst_cls    VARCHAR NOT NULL,
  dst_key    VARCHAR,
  weight     FLOAT NOT NULL DEFAULT 0,
  position   INTEGER NOT NULL DEFAULT 0,
  note       TEXT,

  PRIMARY KEY(pkey)
);

CREATE INDEX relation_idx ON relation (src_cls, src_key);
CREATE INDEX relation_dst_idx ON relation (dst_cls, dst_key);



CREATE VIEW relation_maxweightbydst AS
    SELECT r1.* 
    FROM (SELECT dst_cls, dst_key, max(weight) AS weight 
            FROM relation 
            GROUP BY dst_cls, dst_key) AS r2 
         JOIN relation AS r1 USING (dst_cls, dst_key, weight);

CREATE VIEW relation_maxweightbysrc AS
    SELECT r1.* 
    FROM (SELECT src_cls, src_key, max(weight) AS weight 
            FROM relation 
            GROUP BY src_cls, src_key) AS r2 
         JOIN relation AS r1 USING (src_cls, src_key, weight);

END;


