from wm4.api import *
from comp4.cms.config import RootProperty
from comp4.cms.pagelets import Pagelet
from comp4.cms.controllers import PageletCtrl
from comp4.cms.widgets import PageletWidget
import wm4.web.forms.api as forms

from web import RelationsCtrl

_ = i18n.MessageIDFactory('comp4.relations')


class RelationsPagelet(Pagelet):
    plName = _(u'Relations')

    def rel_comp(self):
        return settings.workspace()['relations']
    rel_comp = binding.Make(rel_comp)

    relations = binding.Make(
        lambda s: s.rel_comp._forSrc('cms/PublicElement',s.eid))


class RelationsPageletCtrl(PageletCtrl):
    
    featureCommiting = {'*':'before', 'relations':'after'}

    class value(forms.InputCtrl):
        ctrlLabel = _(u'Title')
        def defaultInput(self):
            return u'Relations'
        
    class relations(RelationsCtrl):
        ctrlLabel = _(u'Objects')
        src_cls = 'cms/PublicElement'
        src_key = binding.Make(lambda s: s['..'].newValue.eid)
        popupUrl = binding.Make(lambda s: RootProperty(
            s.ctrlParent.partition, 'relations.popup_factory')()(s)
        )



class RelationsPageletWidget(PageletWidget):
    
    def view(self, state, felem, req):
        return web.parseSrc(
            '''<div class="%s">
                    <h3 form:input="value" />
                    <div form:input="relations" />
               </div>'''
        )

    def edit(self, state, felem, req):
        return web.parseSrc('''
            <div>
                <div>
                    <label form:label="value" />
                    <input form:input="value" />
                    <span form:errors="value" />
                </div>
                <div>
                    <label form:label="relations" />
                    <input form:input="relations" />
                    <span form:errors="relations" />
                </div>
            </div>
        ''')
            
