# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.schema.tests.utils import *
from comp4.relations.api import *


class X(schema.Entity):
    pkey = schema.Attribute(int)
    name = schema.Attribute(unicode)
    binding.metadata(schema.PrimaryKey('pkey'))

class Y(schema.Entity):
    pkey = schema.Attribute(str)
    name = schema.Attribute(unicode)
    binding.metadata(schema.PrimaryKey('pkey'))


INI = '''
[Schema Elements]
test/X = "%(mod)s.X"
test/Y = "%(mod)s.Y"
''' % dict(mod=__name__)

class TestRelations(MockWorkspaceCase):
    
    @with_ini(INI)
    def test01_DefaultValues(self):
        self.expects(transaction='begin')
        #self.expects(sql=(
        #        'INSERT INTO "relation" (uid, name, login, mtime) '
        #        'VALUES (1, NULL, \'foo\', NULL)'
        #))
        self.expects(sql=(
            "INSERT INTO relation (pkey, src_cls, src_key, kind, dst_cls, "
            "dst_key, weight, position, note) VALUES (-1, 'test/X', '2', "
            "NULL, 'test/Y', '3', 1.0, 0, NULL)"
        ))
        self.expects(transaction='commit')

        storage.begin()
        x2 = self.ws.preload(X(pkey=2, name='foo'))
        y3 = self.ws.preload(Y(pkey=3, name='bar'))
        r = self.ws.new(Relation, pkey=-1, src=x2, dst=y3)

        self.assertEqual(r.src_cls, 'test/X')
        self.assertEqual(r.src_key, '2')
        self.assertEqual(r.dst_cls, 'test/Y')
        self.assertEqual(r.dst_key, '3')

        storage.commit()



def suite():
    return TestSuite((
        makeSuite(TestRelations),
    ))

if __name__ == '__main__':
    main( defaultTest='suite' )
