import time
import datetime
import dateutil
import urlparse

from xml4 import xhtml as xh
from xml4.templates import Domlet, DynamicElement
from xml4.utils import dynamic_attrs
from xml4.const import *

from wm4.api import *
from wm4.web.html import HtmlInputDate


class HtmlRRDImage(Domlet):

    def expand(self, state):
        req = state['req']
        for res in (
            'wm4.web.static/jquery/jquery.js',
            'wm4.web.static/jquery/ui.datepicker.js',
            'wm4.web.static/jquery/ui.datepicker-cs.js',
            'wm4.web.static/jquery/ui.datepicker.css',
        ):
            web.getResource(res).render(req)

        tag = self._tag
        attrs = self._attrs.expand(state)

        id = attrs.get('id')
        if id is None:
            id = 'RRD-%d' % req.get_new_id()
        interval = req.getValue('interval', '24hour')

        hid_name = '%s-date' % id
        td = datetime.date.today()
        value = req.getValue(hid_name, td.strftime('%d.%m.%Y'))
        try:
            st = dateutil.parser.parse(value, dayfirst=True)
        except:
            st = td
            value = td.strftime('%d.%m.%Y')
        di = HtmlInputDate('h:input.date', "'od'", globals(), 'input', 
                attrs=dynamic_attrs([('class', 'rrd-date'),
                                     ('id', hid_name)]))
        for e in di.expand(state, autofill=hid_name, value=value):
            yield e

        en = int(time.mktime((st+datetime.timedelta(days=1)).timetuple()))
        st = int(time.mktime(st.timetuple()))

        src = attrs.get('src').split('?')[0]
        width = attrs.get('width')
        height = attrs.get('height')
        src += '?width=%s&height=%s&size=outer&start=%s&end=%s' % (
                width, height, st, en)
        for e in xh.div(
            xh.img(src=src, id=id, width=width, height=height),
            _class='rrd'
        ).expand(state):
            yield e

        for e in xh.script(
            """$(document).ready(function(){$('#%s').change(function(){$(this).closest("form").submit();})});""" % hid_name,
            type="text/javascript",
        ).expand(state):
            yield e

