import sys, pgdb, csv, optparse, encodings.utf_8
from wm4.api import *
from comp4.shop.api import *


def get_opts():
    usage = 'usage: %prog [options] APPLICATION'
    parser = optparse.OptionParser(usage=usage)
    parser.add_option('--encoding', default='utf-8')
    opts, args = parser.parse_args()
    if len(args) != 1:
        parser.error('application name needed')

    opts.app_name = args[0]
    config.setupApp(opts.app_name)

    opts.con = settings.storage_connection()
    opts.ws = settings.workspace()
    opts.shop = opts.ws['shop']

    return opts


opts = get_opts()
#print opts
#sys.exit(0)
storage.begin()


q = '''[obj for obj in ShopCategory if query.OrderBy(obj.name)]'''

header = ['pkey', 'parent', 'name', 'description']

w = csv.writer(sys.stdout)
w.writerow(header)
for c in opts.ws(q):
    w.writerow([
        c.pkey,
        c.parent and str(c.parent.pkey) or '',
        c.name.encode(opts.encoding),
        (c.description or '').encode(opts.encoding),
    ])
