#!/usr/bin/python

# XXX obrazky http://www.sckn.cz/ceskeknihy/html/titul_detail.php?id=12149

import sys, pgdb, re, time
from sql4.utils import sql_escape, sql_name
from itertools import izip
from urllib2 import urlopen
from urlparse import urljoin
from lib4.htmlproc import *
from ClientForm import ParseResponse
from elementtree.ElementTree import ElementTree
from elementtree.HTMLTreeBuilder import HTMLTreeBuilder
from StringIO import StringIO

SEARCH_URL = 'http://www.sckn.cz/ceskeknihy/html/vyhledavani.php'
ISBN_REGEX = re.compile('^[-0-9]{8,30}$')

def esc(val):
    if val is None:
        return 'NULL'
    if isinstance(val, basestring):
        val = val.encode('utf-8')
    else:
        val = str(val)
    return "'%s'" % sql_escape(val)

def parseResult(html):
    et = ElementTree().parse(StringIO(html), HTMLTreeBuilder())
    vtab = None
    for t in et.findall('.//table'):
        if t.get('class') == 'vypisTable1':
            vtab = t
            break
    if vtab is None:
        return {}

    res = {}
    for tr in vtab.findall('./tr'):
        tdi = iter(tr.findall('./td'))
        for p,v in izip(tdi, tdi):
            pt = sql_name(u' '.join((p.findtext('.//*') or ' ').strip().split())[:-1]).replace('.','')
            if not pt:
                continue
            vt = u' '.join((v.findtext('.//*') or ' ').strip().split())
            if not vt:
                continue
            res[pt] = vt
    return res

def searchISBN(isbn):
    response = urlopen(SEARCH_URL)
    forms = ParseResponse(response, backwards_compat=False)
    form = forms[0]
    form["isbn"] = isbn
    req = form.click()
    surl = req.get_full_url()
    res = urlopen(req)
    html = tidyHTML(html2unicode(res.read()))
    et = ElementTree().parse(StringIO(html), HTMLTreeBuilder())

    durl = None
    for a in et.findall('.//a'):
        h = a.get('href')
        if h and h.startswith('titul_detail.php?id='):
            durl = urljoin(surl, h)
            break
    if durl is None:
        return {}

    res = urlopen(durl)
    html = tidyHTML(html2unicode(res.read()))
    return parseResult(html)


con = pgdb.connect(database='portaluh')
cur = con.cursor()
Q = """SELECT  goods, value FROM goods_param
        WHERE param='isbn' AND goods NOT IN (
            SElECT goods FROM goods_param
             WHERE param = 'sckn.result')
        ORDER BY value"""
cur.execute(Q)
isbn_map = {}
for g,i in cur.fetchall():
    if not ISBN_REGEX.match(i):
        continue
    isbn_map.setdefault(i, []).append(g)

isbn_count = len(isbn_map)

for idx, (isbn, glst) in enumerate(sorted(isbn_map.items())):
    print "%d/%d %s: %s" % (idx+1, isbn_count, isbn, ','.join([str(g) for g in glst]))
    res = searchISBN(isbn)
    cur = con.cursor()
    if not res:
        for g in glst:
             cur.execute("INSERT INTO goods_param (goods,param,value) VALUES (%s,'sckn.result','not found')" % g)
    else:
        for k,v in sorted(res.items()):
            print '    %-20s %s' % (k, v[:50])
        for g in glst:
             cur.execute("INSERT INTO goods_param (goods,param,value) VALUES (%s,'sckn.result','found')" % g)
             for p,v in res.items():
                v = v.strip()
                if not v:
                    continue
                cur.execute("INSERT INTO goods_param (goods,param,value) VALUES (%s,'sckn.%s',%s)" % (g,p,esc(v)))
    if idx % 10 == 9:
        con.commit()
        print 'commit'
        time.sleep(3)
con.commit()
