-- deletes duplicates in shop_goods_param

BEGIN;

-- temporary table with all duplicates
CREATE TEMPORARY TABLE shop_goods_param_dupl AS
SELECT p.*
  FROM shop_goods_param AS p
 INNER JOIN (
            SELECT goods, param
              FROM shop_goods_param
             GROUP BY goods, param
            HAVING count(*) > 1
        ) AS d (goods, param) ON (p.goods = d.goods AND p.param = d.param)
;

-- parameter with latest pkey is removed from temporary table
DELETE FROM shop_goods_param_dupl WHERE pkey IN (
    SELECT DISTINCT ON (goods, param) pkey
      FROM shop_goods_param_dupl ORDER BY goods, param, pkey DESC
);

-- all remaining parameters are deleted in original table
DELETE FROM shop_goods_param WHERE pkey IN (
    SELECT pkey FROM shop_goods_param_dupl
);



DROP TABLE shop_goods_param_dupl;

END;
