BEGIN;

CREATE TABLE shop_manufacturer_duplicate AS
SELECT d.head AS orig, d.pkey AS dupl
  FROM (SELECT m.pkey, d.head, ARRAY_ITER(d.tail)
          FROM shop_manufacturer m 
               INNER JOIN (
                    SELECT LOWER(name),
                           COUNT(*),
                           (ARRAY_ACCUM(pkey))[1],
                           (ARRAY_ACCUM(pkey))[2:100]
                      FROM shop_manufacturer
                     GROUP BY LOWER(name)
                    HAVING COUNT(*) > 1
               ) AS d(name, count, head, tail) ON (LOWER(m.name) = d.name)
       ) AS d(pkey, head, ai)
 WHERE pkey = (ai).n
 ORDER BY d.head, d.pkey
;

SELECT g.pkey, g.manufacturer, d.orig
  FROM shop_goods g INNER JOIN
       shop_manufacturer_duplicate d ON (g.manufacturer = d.dupl)
;


UPDATE shop_goods 
   SET manufacturer = d.orig
  FROM shop_manufacturer_duplicate d
 WHERE shop_goods.manufacturer = d.dupl
;

DELETE FROM shop_manufacturer WHERE pkey IN (
    SELECT m.pkey
      FROM shop_manufacturer m LEFT JOIN
           shop_goods g ON (g.manufacturer = m.pkey)
     GROUP BY m.pkey
    HAVING COUNT(g) < 1
);

DROP TABLE shop_manufacturer_duplicate;

END;
