BEGIN;

CREATE TABLE shop_person_dupl AS
SELECT head AS pkey, (ARRAY_ITER(tail)).n AS dupl, pid
  FROM (
            SELECT LOWER(pid),
                   (ARRAY_ACCUM(pkey))[1],
                   (ARRAY_ACCUM(pkey))[2:100]
              FROM (
                        SELECT pkey, name, CASE WHEN birth_year NOTNULL THEN name || ' (' || birth_year::text || ')' ELSE name END AS pid
                          FROM shop_person
                   ) AS p (pkey, name, pid)
             GROUP BY LOWER(pid)
            HAVING COUNT(*) > 1
       ) AS d (pid, head, tail)
;

SELECT * FROM shop_person_dupl ORDER BY pkey, dupl;

UPDATE shop_goods_person
   SET person = d.pkey
  FROM shop_person_dupl d
 WHERE shop_goods_person.person = d.dupl
;



DELETE FROM shop_person WHERE pkey IN (
    SELECT dupl FROM shop_person_dupl
);

DROP TABLE shop_person_dupl;

END;
