BEGIN;

CREATE OR REPLACE FUNCTION replace_sro(n text)
RETURNS text AS
$BODY$
    import re
    n = args[0]
    for p in [
        r'spol\.\s*s\.?\s*r\.\s*o\.',
        r's\.?\s*r\.\s*o\.?',
        r'a\.\s*s\.',
        r'o\.\s*p\.\s*s\.',
        r'v\.\s*o\.\s*s\.',
    ]:
        p = re.compile(p, re.I)
        n = re.sub(p, '', n, ).strip().rstrip(',').replace('  ', ' ').replace('  ', ' ')
    return n
$BODY$ LANGUAGE 'plpythonu' IMMUTABLE STRICT
;

SELECT name, replace_sro(name)
  FROM shop_manufacturer
 WHERE name LIKE '%.%' AND name != replace_sro(name)
 ORDER BY name
;


UPDATE shop_manufacturer
   SET name = replace_sro(name)
 WHERE name LIKE '%.%' AND name != replace_sro(name)
;

DROP FUNCTION replace_sro(n text);

END;
