from wm4.api import *
from dispatch.strategy import default

def getVector(obj):
    from comp4.fulltext import api
    vector = []

    ws = obj._workspace

    for (attr, weight) in [('name', 'A'), ('description', 'C')]:
        v = getattr(obj, attr, None)
        if not v:
            continue
        vector.append((v.lower(), weight))

    for n, p in ws['shop'].goodsParams:
        if p.fulltext:
            v = getattr(obj.params, n)
            if not v:
                continue
            v = unicode(v)
            vector.append((v.lower(), p.fulltext))

    for p in obj._persons:
        vector.append((p.person.name.lower(), 'B'))

    if obj.manufacturer:
        vector.append((obj.manufacturer.name.lower(), 'C'))
        
        
    plain = ' '.join(t for t,w in vector)
    #print obj, vector
    vector = api.TSVector('cs', *vector)
    return (vector, plain)


def updateFulltext(obj):
    ws = obj._workspace
    if obj.hidden or obj.deleted:
        ws['fulltext'].removeVector(ws.getPath(obj.__class__), obj._oid)
        return None
    else:
        gv = config.Property('comp4.shop.goods.fulltext.getVector')()
        vector, plain = gv(obj)
        f = ws['fulltext'].updateVector(
            ws.getPath(obj.__class__),
            obj._oid, vector, plain
        )
        ws.flush(f)


def updateFulltextOnEdit(evt):
    updateFulltext(evt.obj)

def updateFulltextOnRemove(evt):
    ws = evt.obj._workspace
    ws['fulltext'].removeVector(ws.getPath(evt.obj.__class__), evt.obj._oid)

