# -*- coding: utf-8 -*-
from wm4.api import *
from wm4.web.forms.api import FormWidget
from xml4 import xhtml as xh

__all__ = [
    'GoodsWidget',
    'CategoryWidget', 'CategoriesWidget', 'MultiparamWidget',
    'FirstLetterWidget' 'NamePopupWidget',
]


_ = i18n.MessageIDFactory('comp4.shop')

class GoodsWidget(FormWidget):
    def edit(self, state, felem, req):
        return web.parseSrc('''<div>
            <input form:input="pkey"/>
            <input form:input="name" />
            <a href="#" form:input="popup"
                ><span form:input="../name/span" /></a>
            <span form:errors="." />
        </div>''')

class CategoryWidget(FormWidget):
    def edit(self, state, felem, req):
        return web.parseSrc('''<div>
            <input form:input="pkey"/>
            <input form:input="path" />
            <a href="#" form:input="popup"
                ><span form:input="../path/span" /></a>
            <span form:errors="." />
        </div>''')

class CategoriesWidget(FormWidget):
    
    def edit(self, state, felem, req):
        return web.parseSrc('''<div>
            <table>
                <tr form:repeat="">
                    <td>
                        <input form:input="category"/>
                    </td>
                    <td>
                       <img form:button="removeItem"
                            src="/++res++/wm4.web.static/img/forms/remove.png"
                       />
                    </td>
                </tr>
                <tr>
                    <td colspan="3" style="text-align: right">
                        <input form:button="addItem"/>
                    </td>
                </tr>
            </table>
        </div>''')
        
class MultiparamWidget(FormWidget):
    
    def edit(self, state, felem, req):
        return web.parseSrc('''<div>
            <table>
                <tr form:repeat="">
                    <td>
                        <input form:input="."/>
                    </td>
                    <td>
                       <img form:button="removeItem"
                            src="/++res++/wm4.web.static/img/forms/remove.png"
                       />
                    </td>
                </tr>
                <tr>
                    <td colspan="2" style="text-align: right">
                        <input form:button="addItem"/>
                    </td>
                </tr>
            </table>
        </div>''')
        

class FirstLetterWidget(FormWidget):
    
    def edit(self, state, felem, req):
        x = xh.span()
        n = felem.ctrlId
        c = req.getValue(n)
        for l in felem.letters:
            u = felem.listingCtrl.baseUrl % {n:l}
            if l == c:
                x.append(xh.a(l, href=u, klass='selected'))
            else:
                x.append(xh.a(l, href=u))
            x.append('\n')
        return x

class NamePopupWidget(FormWidget):

    def edit(self, state, felem, req):
        return web.parseSrc('''<div>
            <input form:input="pkey"/>
            <input form:input="name" />
            <a href="#" form:input="popup"
                ><span form:input="../name/span" /></a>
            <span form:errors="." />
        </div>''')


class PersonsWidget(FormWidget):

    def edit(self, state, felem, req):
        return web.parseSrc('''<div>
            <table>
                <tr form:repeat="">
                    <td>
                        <input form:input="person"/>
                    </td>
                    <td>
                        <input form:input="role"/>
                    </td>
                    <td>
                       <img form:button="removeItem"
                            src="/++res++/wm4.web.static/img/forms/remove.png"
                       />
                    </td>
                </tr>
                <tr>
                    <td colspan="3" style="text-align: right">
                        <input form:button="addItem"/>
                    </td>
                </tr>
            </table>
        </div>''')
