#!/usr/bin/env python
# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.running import commands, options

from entities import *

__all__ = ['AcquireData',]





class AcquireData(commands.ConfiguredCommandLineApp):
    '''
        $ wm4 comp4.snowreport.commands.AcquireData --ini='pkgfile:myapp/app.ini'
    '''
    
    dry_run = binding.Constant(False,   
        options.Set('--dry-run', '-n', value=True, help='Rollback transaction'))

    def main(self):
        super(AcquireData, self).main()

        ws = settings.workspace()
        storage.begin()
        ws['snow'].acquireData()
        if self.dry_run:
            storage.abort()
        else:
            storage.commit()




