#!/usr/bin/env python
# -*- coding: utf-8 -*-


from wm4.api import *
from wm4.web.forms.api import *
from wm4.web.forms.listings import *

from entities import *


_ = i18n.MessageIDFactory('comp4.tags')



class TagForm(makeFormCtrl(Tag)):

    class parent(SelectCtrl):
        def selectOptions(self):
            return [
                (o._oid, o.name, o)
                for o in settings.workspace()('[o for o in Tag]')
            ]
        selectOptions = binding.Make(selectOptions)







class TagsListing(ListingCtrl):
    baseQuery = '''[obj for obj in 'tags/Tag']'''
    
    class name(LikeFilter):
        queryExpr = 'obj.name'
        ctrlLabel = _(u'Name')




class TagSelectCtrl(makeFormCtrl(TagObject)):

    class tag(SelectCtrl):
        def filter_roots(self, r):
            return True

        def selectOptions(self):
            ws = settings.workspace()
            opts = []
            for root in ws['tags'].roots:
                if self.filter_roots(root):
                    opts.extend(root.iterDepthFirst())
            return [(t.pkey, '%s%s%s' % ('..'*t.treeLevel,
                                         t.treeLevel and ' ' or '',
                                         t.name),
                     t)
                    for t in opts]

            return [(o._oid, o.name, o) 
                    for o in settings.workspace()('[o for o in Tag]')
                    ]
        selectOptions = binding.Make(selectOptions)

    class klass(InputCtrl):
        ctrlVisibility = 'hidden'
        def defaultOutput(self):
            return settings.workspace().getPath(self['/'].newValue.__class__)

    class key(InputCtrl):
        ctrlVisibility = 'hidden'
        def defaultOutput(self):
            return self['/'].newValue._oid


class TagsWidget(FormWidget):

    def edit(self, state, felem, req):
        return web.parseSrc('''<fieldset form:fieldset="">
            <title>%s</title>
            <table>
                <tr form:repeat="">
                    <td>
                        <input form:input="tag" />
                        <input form:errors="tag" />
                    </td>
                    <td>
                        <div class="wm4-form-fieldset-actions">
                            <input form:input="removeItem"
                                class="button-remove-item" />
                        </div>
                    </td>
                </tr>
            </table>
            <input form:input="addItem" />
        </fieldset>''' % web.render(req, _(u'Tags')).encode('utf-8'))

    def view(self, state, felem, req):
        return web.parseSrc('''<ul>
                <li form:repeat=""><input form:input="tag" /></li>
            </ul>''')

class TagsCtrl(SequenceCtrl):
    ctrlWidget = web.FORM_WIDGET('input.comp4.tags')
    class itemClass(TagSelectCtrl, SequenceItemCtrl): pass

    def updateContainer(self, removed):
        ws = settings.workspace()
        for i in removed:
            ws.remove(self.oldValue[i])


