BEGIN;

CREATE TABLE "user" (
    "uid"            SERIAL NOT NULL,
    "login"          VARCHAR(32) NOT NULL,
    "nick"           VARCHAR(32),
    "password"       VARCHAR,
    "name"           VARCHAR NOT NULL,
    "email"          VARCHAR NOT NULL,
    "phone"          VARCHAR,
    "mobil"          VARCHAR,
    "skype"          VARCHAR,
    "workplace"      VARCHAR,
    "occupation"     VARCHAR,

    "note"           TEXT,
    "kind"           VARCHAR NOT NULL DEFAULT 'user',
    "active"         BOOLEAN NOT NULL DEFAULT 't',
    "hidden"         BOOLEAN NOT NULL DEFAULT 'f',
    "photo"          INTEGER,

    PRIMARY KEY("uid"),
    UNIQUE("login"), UNIQUE("nick"),
    CHECK("uid" >= 0)
    -- CHECK("login" ~* '^[a-z][_a-z0-9]{1,31}$'),
    -- CHECK("nick" ~* '^[a-z][_a-z0-9]{1,31}$')
);


CREATE TABLE "user_photo" (
    "pkey"          SERIAL NOT NULL,
    "blob"          OID NOT NULL,
    "size"          INTEGER NOT NULL,
    "content_type"  VARCHAR NOT NULL DEFAULT 'application/octet-stream',
    "filename"      VARCHAR,
    "modified"      TIMESTAMP WITH TIME ZONE NOT NULL,
    "width"         INTEGER NOT NULL,
    "height"        INTEGER NOT NULL,

    PRIMARY KEY("pkey")
);


CREATE TABLE "group" (
    "gid"           SERIAL NOT NULL,
    "name"          VARCHAR(32) NOT NULL,
    "description"   TEXT,
    "kind"          VARCHAR NOT NULL DEFAULT 'user',
    "active"        BOOLEAN NOT NULL DEFAULT 't',
    "hidden"        BOOLEAN NOT NULL DEFAULT 'f',

    PRIMARY KEY("gid"),
    UNIQUE("name"),
    CHECK("gid" >= 0)
    -- CHECK("name" ~* '^[a-z][_a-z0-9]{1,31}$')
);


CREATE TABLE "user_group" (
    "user"          INTEGER NOT NULL,
    "group"         INTEGER NOT NULL,

    PRIMARY KEY("user", "group")
);

-- default user

INSERT INTO "user" ("login", "name", "email", "password") VALUES ('comp4', 'Comp 4', 'comp4@windmill.cz', 'ahoj');
INSERT INTO "group" ("name") VALUES ('admin');
INSERT INTO "user_group" SELECT 
    (SELECT "uid" FROM "user" WHERE "login" = 'comp4') AS "user",
    (SELECT "gid" FROM "group" WHERE "name" = 'admin') AS "group"
;


END;
