# -*- coding: utf-8 -*-

from wm4.api import *
from wm4.web.routes import *
from wm4.web.sitemaps import *
from wm4.utils.clspatch import patch

from entities import *


__all__ = ['UsersSitemap']


_ = i18n.MessageIDFactory('comp4.users')


class UsersSitemap(Route):
    virtual = True

    viewPerm = Const(web.Authenticated())
    editPerm = Const(web.MemberOf('admin'))
    sendmailPerm = Const(web.MemberOf('admin'))

    mainMenuItems = Lazy(lambda s: [s/p for p in [
                            'user/', 'group/', 'user/sendmail']])
    
    class user(web.SitemapWithMainMenu):
        match = 'user/'
        clsObj = Const(User)
        handler = Const('comp4.users.web.UserHandler')
        listingCtrl = Const('comp4.users.web.UserListing')
        asMainMenu = Param(lambda s: web.render(web.request(), _(u'Users')))

        viewPerm = Acquire('../viewPerm')
        editPerm = Acquire('../editPerm')

        class cls(web.SitemapWithMainMenu.cls):

            class sendmail(ClassRoute):
                asAction = Lazy(
                    lambda s: web.Link.fromRoute(s, label=_(u'Send mail')))
                asMainMenu = Param(
                        lambda s: web.render(web.request(), _(u'Send mail')))
                actionLinks = Lazy(lambda s: web.actionLinks(
                        s, '', './add', web.DELIMITER, s.mainMenu(s)))


            class update(ClassRoute):
                asAction = Lazy(web.Link.fromRoute)
                

        class obj(web.SitemapWithMainMenu.obj):
            class photo(InstanceRoute):
                pass
        
        patch({
            'cls.list.template': Const('comp4.users/user_list.wt'),
            'cls.sendmail.template': Const('comp4.users/sendmail.wt'),
            'cls.update.template': Const('comp4.users/self_form.wt'),
            'cls.add.template' : Const('comp4.users/user_form.wt'),
            'obj.view.template': Const('comp4.users/user_form.wt'),
            'obj.edit.template': Const('comp4.users/user_form.wt'),
        })

    class group(web.SitemapWithMainMenu):
        match = 'group/'
        clsObj = Const(Group)
        handler = Const('comp4.users.web.GroupHandler')
        listingCtrl = Const('comp4.users.web.GroupListing')
        asMainMenu = Param(lambda s: web.render(web.request(), _(u'Groups')))

        viewPerm = Acquire('../viewPerm')
        editPerm = Acquire('../editPerm')

        patch({
            'cls.list.template': Const('comp4.users/group_list.wt'),
            'cls.add.template' : Const('comp4.users/group_form.wt'),
            'obj.view.template': Const('comp4.users/group_form.wt'),
            'obj.edit.template': Const('comp4.users/group_form.wt'),
        })

