# From ASPN Python Cookbook
# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/310791
#
# Generated by
# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/310790
#
# Compiler2 based on _ast.* in Python2.5
# http://mail.python.org/pipermail/python-dev/2006-October/069589.html

import parser, symbol, token, sys

def pprint_ast(st, indent=[], stream=sys.stdout):
    indent = [{'+-':'  ','|-':'| '}.get(i,i) for i in indent[:-1]] + indent[-1:]

    if isinstance(st, (tuple,list)):
        code = st[0]
        rest = st[1:]
    else:
        code = st
        rest = []

        #print >>stream, ''.join(indent) + name, st[1:]

    name = symbol.sym_name.get(code)
    if name is None:
        name = token.tok_name[code]
        print >>stream, ''.join(indent) + name + '(%s)' % code, st[1:]
    else:
        print >>stream, ''.join(indent) + name + '(%s)' % code
        last = len(rest) - 1
        for i,r in enumerate(rest):
            if i == last:
                pprint_ast(r, indent+['+-'], stream)
            else:
                pprint_ast(r, indent+['|-'], stream)


if __name__ == '__main__':
    pprint_ast(parser.expr(sys.argv[1]).totuple(1))
