# http://www.python.org/peps/pep-0326.html
# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/325394
# http://www.ics.uci.edu/~jcarlson/pep326/extremes.py

__all__ = ['Min', 'Any', 'Max']

class _Compare(object):

    def __init__(self, eq, rep):
        self._eq = eq
        self._rep = rep
    def __cmp__(self, other):
        return self._eq
    def __eq__(self, other):
        return self._eq == 0
    def __ne__(self, other):
        return self._eq != 0
    def __gt__(self, other):
        return self._eq > 0
    def __ge__(self, other):
        return self._eq >= 0
    def __lt__(self, other):
        return self._eq < 0
    def __le__(self, other):
        return self._eq <= 0
    def __repr__(self):
        return self._rep

Min = _Compare(-1, 'Min')
Any = _Compare(0, 'Any')
Max = _Compare(1, 'Max')
