from imports import importString
import unittest, sys, new


__all__ = ['Record', 'TestAll', 'Main', 'timeIt', 'ctest']


class Record(object):
    def __init__(self, **kw):
        self.__dict__.update(kw)
    def __eq__(self, other):
        if self.__class__ != other.__class__:
            return False
        return self.__dict__ == other.__dict__
    def __ne__(self, other):
        return not self == other
    def copy(self):
        return self.__class__(**self.__dict__)
    def __repr__(self):
        return 'Record(%s)' % ','.join(
            '%s=%r' % (a,v) for a,v in self.__dict__.iteritems()
        )

class TestAll :

    def __init__ (self, *modules) :
        self.modules = modules
        mod = sys._getframe(1).f_globals['__name__']
        self.globals = sys.modules[mod].__dict__

    def __call__ (self) :
        return unittest.TestSuite(
            [importString(m, self.globals).suite() for m in self.modules]
        )



def Main (defaultTest='suite') :
    unittest.main(defaultTest='suite')


def timeIt(count, meth, *args, **kw):
    import time
    start = time.clock()
    for i in xrange(count):
        r = meth(*args, **kw)
    t = time.clock() - start
    return count/t, r



class ctest(object):
    class __metaclass__(type):
        def __get__(klass, caseInst, caseCls):
            if caseInst is None:
                return new.instancemethod(klass, None, klass)
            else:
                return klass(case=caseInst)

    def __init__(self, case):
        self.case = case

    def __call__(self):
        self.do(self.case)

    def do(self, case):
        raise NotImplementedError
