import sys, linecache, os.path, inspect

class tracer :

    def __init__ (self, stream=sys.stderr) :
        self.stream = stream
        self.indent = -2
        self.last_file = None

    def __call__ (self, frame, event, arg) :

        fc = frame.f_code
        #print dir(frame)
        filename = os.path.abspath(fc.co_filename)
        #lno = fc.co_firstlineno
        lno = frame.f_lineno
        line = linecache.getline(filename, lno).rstrip().expandtabs()
        cind = len(line) - len(line.lstrip())

        e = event[:3]
        if event == "call" :

            #if fc.co_name == 'e' : return None
            self.indent += 2
            print
            if filename != self.last_file :
                print "%s%s" % (" " * self.indent, filename)
                print
            #print fc.co_varnames[:fc.co_argcount]
            #print inspect.getargspec(fc)

            p,v,k,d = inspect.getargvalues(frame)
            a = ["%s=%r" % (x, d[x]) for x in p]
            if v :
                a.append("*%s=%r" % (v, d[v]))
            if k :
                a.append("**%s=%r" % (k, d[k]))
            a = "(%s)" % (",".join(a))

            print "%s%s:%s %s %s" % (" " * self.indent, e, lno, line, a)

        elif event == "return" :
            if filename != self.last_file :
                print "%s%s" % (" " * self.indent, filename)
                print
            print "%s%s:%s %s%s" % (" " * self.indent, e, lno, " " * cind, arg)
            print
            self.indent -= 2

        else :
            if filename != self.last_file :
                print "%s%s" % (" " * self.indent, filename)
                print
            print "%s%s:%s %s" % (" " * self.indent, e, lno, line)
        self.last_file = filename

        return self



if __name__ == '__main__' :

    def e (x) :
        try :
            x/0
        except :
            pass
    def f (a) :
        f = str(a * 3)
        #f = os.path.abspath(f)
        e(f)
        return f

    def m (a=None, *x, **kw) :
        a = f(2)
        return a


    t = tracer(sys.stdout)
    sys.settrace(t)
    m(12, 33, ahoj=123, cau="zdar")
