"""Nasledujici trida slouzi pro kontrolu pristupu k ruznym objektum.
   Skupiny a uzivatele se zadavaji jako seznamy nebo jako n-tice.
   Priklady:

   * Uzivatel musi patrit do jedne ze skupin:

       allow_groups = ['g1', 'g2']

   * Uzivatel musi byt ve vsech skupinach:

       allow_groups = ('g1', 'g2')

   * Uzivatel musi byt ve skupine admin nebo v obou skupinach g1, g2:

       allow_groups = ['admin', ('g1','g2') ]

   * Uzivatel musi patrit do jedne ze skupin, ale nesmi to byt
     uzivatel joe nebo bill:

       allow_groups = ['g1', 'g2']
       deny_login = ['joe', 'bill']

   Pozn: U paramtru *_login nema vyznam tvar podminky v kulatych
   zavorkach. Uzivatel nemuze mit vic jmen.
"""
class authorization :

    keywords = [ 'allow_login', 'deny_login',
                 'allow_groups', 'deny_groups',
                 'allow_ip', 'deny_ip',
                 ]

    def __init__ ( self, **kw ) :
        for k in self.keywords :
            if kw.has_key(k) : setattr( self, k, kw[k] )
            else : setattr( self, k, None )

    def proces_cond ( self, data, cond ) :
        if not data : return 0
        if type(cond) == type('') :
            if type(data) != type('') :
                if cond in data :
                    return 1
                else :
                    return 0
            else :
                if data == cond : return 1
                else : return 0
        m = []
        for c in cond :
            m.append( self.proces_cond( data, c ) )
        if type(cond) == type([]) :
            if m.count(1) > 0 :
                return 1
            else :
                return 0
        else :
            if len(m) == m.count(1) :
                return 1
            else :
                return 0

    def authorize ( self, u ) :
        if not u : return 0
        allow = None
        if self.deny_groups :
            if self.proces_cond( u.groups, self.deny_groups ) :
                return 0
        if self.deny_login :
            if self.proces_cond( u.login, self.deny_login ) :
                return 0
        if self.allow_groups :
            allow = 0
            if self.proces_cond( u.groups, self.allow_groups ) :
                allow = allow + 1
        if self.allow_login :
            if allow == None : allow = 0
            if self.proces_cond( u.login, self.allow_login ) :
                allow = allow + 1
        if allow == None or allow > 0 : return 1
        else : return 0

class user :
    login = None
    groups = None
    password = None

    def __init__ (self, **kw) :
        self.__dict__.update(kw)
    def __repr__ (self) :
        return 'user(%s)' % ", ".join([
            "%s=%r" % (k,v) for k,v in self.__dict__.iteritems()
        ])

if __name__ == '__main__' :

    u = user()
    u.login = 'radekk'
    u.groups = ['uh']

    a = authorization(
        #allow_groups = ['admin', ('uh','akce'), ('bv','sluzba')],
        allow_groups = ['uh', 'deal1'],
        #deny_groups = ['kakce'],
        #deny_login = ['radekk'],
        allow_login = ['radekk'],
        )
    print a.authorize( u )
