import bsddb3.db, time, pickle

class Cache :

    def __init__ ( self, file = '/tmp/wm3cache.db', dir = '/tmp', timeout = 180 ) :
        """Otevreni db databaze, kde lze kesovat jakakoliv data.
        """
        self.env = bsddb3.db.DbEnv()
        self.env.set_lk_detect( bsddb3.db.DB_LOCK_DEFAULT )
        self.env.open( dir, bsddb3.db.DB_CREATE | \
            bsddb3.db.DB_INIT_MPOOL | bsddb3.db.DB_INIT_LOCK )
        self.db = bsddb3.db.Db( self.env )
        self.db.open( file, bsddb3.db.DB_BTREE, bsddb3.db.DB_CREATE )

    def __del__ ( self ) :
        """Pri ruseni objektu Session je treba korektne zavrit
           databazi, aby ji mohly cist ostatni procesy.
        """
        self.db.sync()
        del self.db
        del self.env

    def __getitem__ ( self, i ) :
        v = self.db[i]
        return pickle.loads( v )

    def __setitem__ ( self, i, v ) :
        self.db[i] = pickle.dumps( v )

    def __delitem__ ( self, i ) :
        del self.db[i]

    def has_key ( self, i ) :
        return self.db.has_key( i )

    def keys ( self ) :
        return self.db.keys()
