import string, wm3.pgdb_result, wm3.pgdb_record, messages, sys
from wm3.fields import *
from wm3.utils import *

class Form :
    database = 'db'
    table = None
    fields = None
    method = 'post'
    multipart = None
    mode = 'insert'
    submit_insert_label = messages.SQLFORM_INSERT
    submit_update_label = messages.SQLFORM_UPDATE
    legend_asterisk = messages.SQLFORM_LEGEND_ASTERISK
    form_name = None
    record = None
    action = None
    color_column1 =  "#EEEEEE"
    color_column2 = "#FFFFFF"
    color_error = "#AA0000"
    color_background = "#CCCCCC"

    def __init__ ( self, **kw ) :
        for k,v in kw.items() :
            setattr( self, k, v )
        self.initialized = None

    def real_init ( self, req ) :
        if self.initialized : return
        if not self.fields :
            raise error, 'No fields specified'
        db = getattr( req.glob, self.database )
        for i in range(len(self.fields)) :
            f = self.fields[i]
            if type(f) == type('') and f[:1] != '@' :
                self.fields[i] = field( fieldname = f )
        if not self.form_name : self.form_name = req.object_id
        if self.multipart : self.method = 'post'
        req.data.form_object = self
        self.initialized = 1

    def get_rec ( self, req, err=wm3.pgdb_result.result() ) :
        self.real_init( req )
        rec = []
        for f in self.fields :
            if type(f) == type('') : continue
            try :
                for k,v in f.param2python ( req ).items() :
                    rec.append( (k,v) )
            except ValueError, x :
                err.AddErr(f.fieldname, str(sys.exc_value))
        if self.record :
            return self.record(rec), err
        else :
            return wm3.pgdb_record.record(rec), err

    def if_submit ( self, req, mode = None ) :
        if not mode : mode = self.mode
        self.real_init( req )
        if mode == 'update' :
            sl = self.submit_update_label
        else :
            sl = self.submit_insert_label
        sk = '_' + mode + '_'
        if req.param.has_key( sk ) :
            s = req.param[ sk ].value
            return 1
        return 0

    def form ( self, req, rec, err=None, mode = None ) :
        if err == None : err =  wm3.pgdb_result.result()
        if not mode : mode = self.mode
        self.real_init(req)
        if mode == 'update' : sl = self.submit_update_label
        else : sl = self.submit_insert_label
        s = ''
        if self.action :
            url = self.action
        else :
            url = Url(req.url, kw = req.kw)
            url.kw( 'se', req.session_token )
        s = s + '<form name="%s" action="%s" method="%s"' % (
                self.form_name, url, self.method)
        if self.multipart : s = s + ' enctype="multipart/form-data">\n'
        else : s = s + '>\n'
        for f in self.fields :
            if type(f) == type('') : continue
            if 'E' in f.hidden :
                s = s + f.python2form( req, rec, err,
                    color_column1=self.color_column1,
                    color_column2=self.color_column2,
                    color_error=self.color_error )
        s = s + '<table border="0" cellspacing="0" cellpadding="0">\n'
        s = s + '<tr><td bgcolor="%s">\n' % self.color_background
        s = s + '<table border="0" cellspacing="1" cellpadding="3">\n'
        for f in self.fields :
            if type(f) == type('') :
                s = s + '<tr><td colspan="2" bgcolor="%s">' % \
                            self.color_background
                s = s + str(f[1:]) + '</td></tr>\n'
            else :
                if 'E' in f.hidden : continue
                s = s + f.python2form( req, rec, err,
                    color_column1=self.color_column1,
                    color_column2=self.color_column2,
                    color_error=self.color_error )
        s = s + '<tr><td colspan="2" align="left" bgcolor="%s">' %\
                    self.color_background
        s = s + '<i>%s</i><br><center>' % self.legend_asterisk
        s = s + '<input type="submit" name="_%s_" value="%s">' % (mode, sl)
        s = s + '</center></td></tr>\n'
        s = s + '</table>\n'
        s = s + '</td></tr>\n'
        s = s + '</table>\n'
        s = s + '</form>\n'
        sel = []
        if err.GetErr(None) :
            sel = sel +  err.GetErr(None)
            err.DelErr(None)
        for f in err.keys() :
            sel = sel + map(lambda x, f=f : "[%s] %s" % (f,x), err.GetErr(f))
            err.DelErr(f)
        if len(sel) > 0 :
            se = '<div><font color="#AA000">\n'
            se = se + string.join(sel, '<br>\n')
            se = se + '</font></div>\n'
        else :
            se = ''
        return se + s
