#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <sys/types.h>

#include "date.h"

/***********************************************************
 *                                                         *
 *                    Global variables                     *
 *                                                         *
 ***********************************************************/

int G_TZ_Offset ;

int year_days[2][13] = {
    { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365 },
    { 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366 }
};

int month_days[2][13] = {
    { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
    { 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
};

char *month_names[13] = {
	"Error", "Januray", "February", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December"
};

char *month_shortcuts[13] = {
	"Err", "Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

char *weekday_names[7] = {
	"Sunday", "Monday", "Tuesday", "Wednesday",
	"Thursday", "Friday", "Saturday"
} ;

char *weekday_shortcuts[7] = {
	"Sun", "Mon", "Tue", "Wed",
	"Thu", "Fri", "Sat"
} ;

zone_struct zone_map[] = {
	{ "GMT",     0,   0},	/* 	Greenwich Mean  */
	{ "UT",	     0,   0},	/* 	Universal  */
	{ "UTC",     0,   0},	/* 	Universal Coordinated  */
	{ "CUT",     0,   0},	/* 	Coordinated Universal  */
	{ "Z",	     0,   0},	/* 	Greenwich Mean  */
	{ "WET",     0,   0},	/* 	Western European  */
	{ "BST",     0,  60},	/* 	British Summer  */
	{ "NST",  -210,   0},	/* 	Newfoundland Standard  */
	{ "NDT",  -210,  60},	/* 	Newfoundland Daylight  */
	{ "AST",  -240,   0},	/* 	Atlantic Standard  */
	{ "ADT",  -240,  60},	/* 	Atlantic Daylight  */
	{ "EST",  -300,   0},	/* 	Eastern Standard  */
	{ "EDT",  -300,  60},	/* 	Eastern Daylight  */
	{ "CST",  -360,   0},	/* 	Central Standard  */
	{ "CDT",  -360,  60},	/* 	Central Daylight  */
	{ "MST",  -420,   0},	/* 	Mountain Standard  */
	{ "MDT",  -420,  60},	/* 	Mountain Daylight  */
	{ "PST",  -480,   0},	/* 	Pacific Standard  */
	{ "PDT",  -480,  60},	/* 	Pacific Daylight  */
	{ "YST",  -540,   0},	/* 	Yukon Standard  */
	{ "YDT",  -540,  60},	/* 	Yukon Daylight  */
	{ "AKST", -540,   0},	/* 	Alaska Standard  */
	{ "AKDT", -540,  60},	/* 	Alaska Daylight  */
	{ "HST",  -600,   0},	/* 	Hawaii Standard  */
	{ "HAST", -600,   0},	/* 	Hawaii-Aleutian Standard  */
	{ "HADT", -600,  60},	/* 	Hawaii-Aleutian Daylight  */
	{ "CES",    60,  60},	/* 	Central European Summer  */
	{ "CEST",   60,  60},	/* 	Central European Summer  */
	{ "MEZ",    60,   0},	/* 	Middle European  */
	{ "MEZT",   60,  60},	/* 	Middle European Summer  */
	{ "CET",    60,   0},	/* 	Central European  */
	{ "MET",    60,   0},	/* 	Middle European  */
	{ "EET",   120,   0},	/* 	Eastern Europe  */
	{ "MSK",   180,   0},	/* 	Moscow Winter  */
	{ "MSD",   180,  60},	/* 	Moscow Summer  */
	{ "WAST",  480,   0},	/* 	West Australian Standard  */
	{ "WADT",  480,  60},	/* 	West Australian Daylight  */
	{ "HKT",   480,   0},	/* 	Hong Kong  */
	{ "CCT",   480,   0},	/* 	China Coast  */
	{ "JST",   540,   0},	/* 	Japan Standard  */
	{ "KST",   540,   0},	/* 	Korean Standard  */
	{ "KDT",   540,   0},	/* 	Korean Daylight  */
	{ "CAST",  570,   0},	/* 	Central Australian Standard  */
	{ "CADT",  570,  60},	/* 	Central Australian Daylight  */
	{ "EAST",  600,   0},	/* 	Eastern Australian Standard  */
	{ "EADT",  600,  60},	/* 	Eastern Australian Daylight  */
	{ "NZST",  720,   0},	/* 	New Zealand Standard  */
	{ "NZDT",  720,  60},	/* 	New Zealand Daylight */
	{ NULL,      0,   0}	/* 	END */
} ;
