#include "date.h"

char *code2err(err_t *et, int c)
{
	int	i;
	for(i = 0; et[i].ec < 0; i++)
		if(et[i].ec == c) return et[i].err;
	return "Unknown error code";
}

/* dateaux.c: from -100 to -200 */
err_t err_sdn2date[] = {
	{ -100,  "SDN must be greater than 1." },
	{ -101,  "SDN must be less than 536838577." },
	{ 0,  NULL },
};

err_t err_date2sdn[] = {
	{ -100,  "Invalid year range." },
	{ -101,  "Invalid month range." },
	{ -102,  "Invalid day range." },
	{ -103,  "Invalid day in month." },
	{ -104,  "Minimal date is November 26, 4714 BC" },
	{ 0,  NULL },
};

/* dateattr.c: from -500 to -600 */
err_t err_dta2datetime[] = {
	{ -500,  "Invalid year range." },
	{ -501,  "Invalid month range." },
	{ -502,  "Invalid day range." },
	{ -503,  "Invalid day in month." },
	{ -504,  "Minimal date is November 26, 4714 BC" },
	{ -505,  "Invalid hour range." },
	{ -506,  "Invalid minute range." },
	{ -507,  "Invalid second range." },
	{ -508,  "Invalid microsecond range." },
	{ -509,  "System error in dta2datetime:local2gmt_fix." },
	{ 0,  NULL },
};

err_t err_ita2interval[] = {
	{ -500,  "Invalid hour range." },
	{ -501,  "Invalid minute range." },
	{ -502,  "Invalid second range." },
	{ -503,  "Invalid microsecond range." },
	{ 0,  NULL },
};
