# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.binding.api import *
from itertools import count

counter = count().next


class A(Annotation):
    count = binding.Make(lambda: counter())

class B(A):
    pass


class myobject(object): pass


class TestAnnotations(TestCase):

    def test01_CachingInComponentClass(self):
        class C(binding.Component): pass
        a1 = A(C)
        a2 = A(C)
        assert a1 is a2

    def test02_CachingInObjectClass(self):
        a1 = A(myobject)
        a2 = A(myobject)
        assert a1 is a2

    def test03_CachingInClassicClass(self):
        class C:
            x = 1
        a1 = A(C)
        a2 = A(C)
        assert a1 is a2

    def test04_Parametrized(self):
        a = A(myobject)
        a1 = A(myobject,1)
        a2 = A(myobject,2)
        assert a is not a1 is not a2

    def test05_AnnotationsKey(self):
        a = A(myobject)
        b = B(myobject)
        assert a is not b
        assert a.count != b.count

    def test10_AnnotationIsActiveClass(self):
        class C(binding.Component): pass
        c = A(C).count
        self.assertEqual(A(C).count, c)


def suite():
    return TestSuite((
        makeSuite(TestAnnotations),
    ))


if __name__ == '__main__':
    main(defaultTest='suite')
