# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.binding.api import *
from itertools import count

x = config.Setting('x')

class C(Configured):

    @with_config
    def getX(self):
        return x()

class TestConfiguredComponent(TestCase):

    def test1_DefaultConfig(self):
        c = C()
        self.assertEqual(c.getX(), None)

    def test2_BoundConfig(self):
        cfg = config.Config()
        c = config.with_(cfg, C)
        config.with_(cfg, x, 42)
        self.assertEqual(c.getX(), 42)
        self.assertEqual(x(), None)

def suite():
    return TestSuite((
        makeSuite(TestConfiguredComponent)
    ))


if __name__ == '__main__':
    main(defaultTest='suite')
