# -*- coding: utf-8 -*-

from protocols import Interface, Attribute



class InvalidationManager(Interface):

    def subscribe(component):
        pass

    def unsubscribe(component):
        pass

    def send(invalidation_message):
        pass



class InvalidationMessage(Interface):
    pass





class BaseCache(Interface):

    def add(key, value, timeout=None, invalidation=None):
        pass

    def get(key):
        pass

    def remove(key):
        pass


class IdentityCache(BaseCache):
    """L1 cache"""

class Cache(BaseCache):
    """L2 cache"""

class PersistentCache(BaseCache):
    """L3 cache"""
