from interfaces import *
from context import *

def parseConfig(*iniFiles, **add_globals):
    from ini_files import ConfigReader
    from utils import getStreamFactory

    parser = ConfigReader(add_globals=add_globals)
    for source in iniFiles:
        stream = getStreamFactory(source)
        parser.readStream(stream.open(), getattr(stream, 'address', None))


def loadConfig(*iniFiles, **add_globals):
    exit1 = enter_(Config())
    exit2 = enter_(ResourceArea())

    parseConfig(*iniFiles, **add_globals)

    def exit():
        exit2()
        exit1()

    return exit



def setupApp(
    app_name,
    core_files = ('pkgfile:wm4/core.ini', 'pkgfile:wm4.web/web.ini'),
    app_files = ('pkgfile:%s/nondist.ini', 'pkgfile:%s/app.ini'),
):
    from os.path import exists
    from wm4.api import naming

    ini_files = list(core_files)

    for ini in app_files:
        ini_file = naming.lookup(ini % app_name).address
        if exists(ini_file):
            ini_files.append(ini_file)
            break
    return loadConfig(*ini_files)
