from protocols import Interface, Attribute
from lib4.symbols import NOT_GIVEN

__all__ = ['IVariable', 'IProperty', 'IResourceFactory']


class IScope(Interface):

    def __getitem__(var):
        '''Returns value for var IVariable'''

    def __setitem__(var, rule):
        '''Sets rule computing value for var IVariable'''



class IVariable(Interface):

    def __call__(value=NOT_GIVEN):
        '''Gets or sets value of this key

           If value is NOT_GIVEN, returns value bound to this config key
           or sets given value otherwise.
        '''

class IFactory(Interface):
    pass




class IResourceFactory(Interface):

    '''Rule to compute a property value for a target object'''

    def __call__():
        '''Property was looked up under `lookProp' Property
           and was found under `foundProp' Property name.
        '''





class IProperty(IVariable):

    fallback = Attribute('Default config key or None')


class IRule(Interface):

    def __call__(var, fallback):
        '''Computes value for given var IVariable or its fallback'''
