from wm4.config.api import *
from wm4.config.ini_files import ConfigReader
from os import path
from time import clock
import sys

test_resource = Resource('test_resource', lambda:'DEFAULT_RESOURCE')
test_setting  = Setting('test_setting', 'DEFAULT_SETTING')


# repeated reading of one property
cfg1 = Config()
cfg2 = Config(cfg1)
Property('a.*', lambda l,f: 53)
prop = Property('a.b')
exit_ = enter_(cfg2)
start = clock()
cycles = 1
cycles = 10000*1000
for i in xrange(cycles):
    p = prop()
assert p == 53
print 'property read: %d cycles took %.2f seconds' % (cycles, clock()-start)
exit_()

# reading many properties once
[Property('a%d.*' % i, lambda l,f: 42) for i in range(100)]
properties = [Property('a%d.x' % i, lambda l,f: 42) for i in range(100)]
start = clock()
cycles = 1 * 1000
for c in xrange(cycles):
    for p in properties:
        v = p()
assert v == 42
print 'property read: %d*100 cycles took %.2f seconds' % (cycles, clock()-start)

# parsing config file
iniFile = path.join(path.split(__file__)[0], 'prof.ini')
def main():
    loadConfig(iniFile)

start = clock()
cycles = 1*1000
for i in xrange(cycles):
    s = snapshot()
    main()
    swap(s)
print 'parsing ini file: %d cycles took %.2f seconds' % (cycles, clock()-start)
