# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.config.utils import *
from wm4.naming.openable import *
from os.path import join, dirname, abspath, normcase
import os

THIS_DIR = normcase(abspath(dirname(__file__)))

class TestStreamFactory(TestCase):

    def test10_StreamFactoryFromFactory(self):
        ff = naming.lookup('file:/some/dir')
        sf = getStreamFactory(ff)
        self.failUnless(ff is sf)
        self.assertEqual(sf.__class__, FileFactory)
        self.assertEqual(sf.address, os.sep.join(['','some','dir']))
        self.failIf(sf.exists())

    def test20_StreamFactoryFromAddress(self):
        url = naming.toName('file:/some/dir')
        sf = getStreamFactory(url)
        self.assertEqual(sf.__class__, FileFactory)
        self.assertEqual(sf.address, os.sep.join(['','some','dir']))
        self.failIf(sf.exists())

    def test30_StreamFactoryFromString(self):
        filename = join(THIS_DIR, 'prof.ini')
        sf = getStreamFactory(filename)
        self.assertEqual(sf.__class__, FileFactory)
        self.assertEqual(normcase(sf.address), normcase(filename))
        self.failUnless(sf.exists())
        fd = sf.open()
        self.failUnless(isinstance(fd, file))

def suite():
    return TestSuite((
        makeSuite(TestStreamFactory),
    ))


if __name__ == '__main__':
    main(defaultTest='suite')
