from wm4.api import *

from wm4.naming.interfaces import IAddress, IStreamFactory

__all__ = ['getStreamFactory']


@dispatch.on('src')
def getStreamFactory(src):
    '''Returns naming.IStreamFactory for given source'''


@getStreamFactory.when([str,unicode])
def get_stream_factory_from_string(src):
    from wm4.naming.openable import FileURL
    try:
        url = FileURL.fromFilename(src)
    except exceptions.InvalidName:
        url = naming.toName(src)
    return naming.IStreamFactory(naming.lookup(url))


@getStreamFactory.when(IAddress)
def get_stream_factory_from_address(src):
    return naming.IStreamFactory(naming.lookup(src))

@getStreamFactory.when(IStreamFactory)
def get_stream_factory_from_factory(src):
    return src
