# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.events.api import *
from wm4.schema.tests.utils import with_ini


class FooEvent(Event):
    __slots__ = ['obj']
class FooCls:
    def __init__(self):
        self.log = []
def FooHandler(evt):
    evt.obj.log.append('FOO')

class BarEvent(FooEvent):
    pass
class BarCls(FooCls):
    pass
class BazCls(FooCls):
    pass
def Bar1Handler(evt):
    evt.obj.log.append('BAR1')
def Bar2Handler(evt):
    evt.obj.log.append('BAR2')



class TestHandlerConfiguration(TestCase):

    def setUp(self):
        self.state = config.snapshot()
        config.loadConfig('pkgfile:wm4/core.ini')

    def tearDown(self):
        config.swap(self.state)

    @with_ini((
        '[Event Handler %(mod)s.FooEvent]\n'
        '%(mod)s.FooCls = "%(mod)s.FooHandler"\n'
        '[Event Handler %(mod)s.BarEvent]\n'
        '%(mod)s.BarCls = "%(mod)s.Bar1Handler"\n'
        '%(mod)s.BarCls = "%(mod)s.Bar2Handler"\n'
    ) % dict(mod=__name__))
    def test1(self):
        foo = FooCls()
        bar = BarCls()
        baz = BazCls()
        FooEvent(FooCls, obj=foo)
        BarEvent(BarCls, obj=bar)
        BarEvent(BazCls, obj=bar)
        self.assertEqual(foo.log, ['FOO'])
        self.assertEqual(sorted(bar.log), ['BAR1', 'BAR2'])
        self.assertEqual(baz.log, [])

def suite():
    return TestSuite((
        makeSuite(TestHandlerConfiguration),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
