# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
import datetime

_ = i18n.MessageIDFactory('wm4.i18n.tests')

class TestMessageID(TestCase):

    def test20_AsDict(self):
        m = _(u'no $no') % dict(no=42)
        self.assertEqual(m.mapping, {'no':42})


class TestMisc(TestCase):

    def setUp(self):
        self.state = config.snapshot()
        config.loadConfig()
        self.ts = settings.translation_service()

    def tearDown(self):
        config.swap(self.state)

    def test01_TypeName(self):
        tn = i18n.typeName(int)
        self.failUnless(isinstance(tn, i18n.MessageID))
        self.assertEqual(unicode(tn), 'TypeName of __builtin__.int')
        self.assertEqual(tn.default, 'int')
        self.assertEqual(tn.domain, 'wm4')
        self.assertEqual(tn.mapping, {})





def suite():
    return TestSuite((
        makeSuite(TestMisc),
        makeSuite(TestMessageID),
    ))


if __name__ == '__main__':
    main(defaultTest='suite')
