# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.running import options, commands

class MyApp(commands.CommandLineApp):
    verbose = binding.Constant(False,
        options.Set('-v', '--verbose', value=True, help="Be verbose"))

class TestCommandWithOptions(TestCase):

    def test10_DefaultValues(self):
        myapp = MyApp(argv=[])
        self.assertEqual(myapp.parsed_args, [])
        self.assertEqual(myapp.verbose, False)

    def test20_ExplicitValues(self):
        myapp = MyApp(argv=['myapp', '--verbose', 'a1', 'a2'])
        self.assertEqual(myapp.parsed_args, ['a1', 'a2'])
        self.assertEqual(myapp.verbose, True)


def suite():
    return TestSuite((
        makeSuite(TestCommandWithOptions),
    ))


if __name__ == '__main__':
    main(defaultTest='suite')
