# -*- coding: ISO-8859-2 -*-

from wm4.testing import *
from wm4.api import *
from wm4.running.logs import *
import sys



class TestLogging(ConfiguredTestCase):

    def test10_DefaultLogger(self):
        l = naming.lookup('logger:foo.bar')
        self.assertEqual(len(l.handlers), 1)
        assert isinstance(l.handlers[0], Stream)
        self.assertEqual(l.handlers[0].stream, sys.stderr)
        self.assertEqual(l.handlers[0].level, WARNING)
        self.assertEqual(l.getEffectiveLevel(), WARNING)

    def test12_LoggerCaching(self):
        l1 = naming.lookup('logger:foo.bar')
        l2 = naming.lookup('logger:foo.bar')
        assert l1 is l2

    def test14_WithResourceArea(self):
        l0 = naming.lookup('logger:foo.bar')
        e = config.loadConfig()
        try:
            l = naming.lookup('logger:foo.bar')
        finally:
            e()
        #assert l0 is not l ???
        self.assertEqual(len(l.handlers), 1)
        assert isinstance(l.handlers[0], Stream)
        self.assertEqual(l.handlers[0].stream, sys.stderr)
        self.assertEqual(l.handlers[0].level, WARNING)
        self.assertEqual(l.getEffectiveLevel(), WARNING)

    @with_ini(
    'wm4.logs.foo.bar = logs.File("/tmp/test.log"), '
    '                   logs.Stream(level=logs.DEBUG)\n')
    def test30_HandlerList(self):
        l = naming.lookup('logger:foo.bar')
        self.assertEqual(len(l.handlers), 2)
        assert isinstance(l.handlers[0], File)
        self.assertEqual(l.handlers[0].baseFilename, '/tmp/test.log')
        self.assertEqual(l.handlers[0].level, WARNING)
        assert isinstance(l.handlers[1], Stream)
        self.assertEqual(l.handlers[1].stream, sys.stderr)
        self.assertEqual(l.handlers[1].level, DEBUG)
        self.assertEqual(l.getEffectiveLevel(), DEBUG)


suite = Suite(TestLogging)

if __name__ == '__main__':
    Main()
