# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.schema.api import *

from utils import *

class X: pass
class X2(X): pass

class TestTypeRef(TestCase):

    def test01_StringRef(self):
        r = TypeRef(__name__+'.X')
        self.assertEqual(r(), X)

    def test02_ClassRef(self):
        self.assertEqual(TypeRef(X)(), X)

    def test03_InvalidClassRef(self):
        class Y: pass
        self.assertRaises(TypeError, TypeRef, Y)

    def test04_TypeRefRedefinition(self):
        exit_ = config.enter_(config.Config())
        try:
            r = TypeRef(__name__+'.X')
            r(X2)
            self.assertEqual(r(), X2)
        finally:
            exit_()
        self.assertEqual(r(), X)









class C1(SchemaComponent):
    pass

class C2(SchemaComponent):

    class C21(SchemaComponent):
        pass

class C3(SchemaComponent):
    pass



class TestSchemaElements(MockWorkspaceCase):

    cfgURLs = ('pkgfile:wm4/core.ini',)

    @with_ini((
        '[Schema Elements]\n'
        'c1 = "%(mod)s.C1"\n'

        '[Schema Elements m2]\n'
        'c2 = "%(mod)s.C2"\n'

        '[Schema Elements]\n'
        'm3/c3 = "%(mod)s.C3"\n'
    ) % {'mod':__name__})
    def test10_ElementFactory(self):
        ws = self.ws
        assert isinstance(ws['c1'], C1)
        assert isinstance(ws['m2/c2'], C2)
        assert isinstance(ws['m3/c3'], C3)












def suite():
    return TestSuite((
        makeSuite(TestTypeRef),
        makeSuite(TestSchemaElements),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
