from wm4.api import *
from types import SliceType

__all__ = ['SortedFeatureDict']

class SortedFeatureDict(object):

    __slots__ = '_list', '_dict'

    def __init__(self, items):
        self._list = tuple(items)
        self._dict = dict(self._list)

    def __iter__(self):
        return iter(self._list)

    def __contains__(self, key):
        return key in self._dict

    def __getitem__(self, key):
        return self._dict[key]

    def __len__(self):
        return len(self._list)

    def get(self, key, default=None):
        return self._dict.get(key, default)

    def has_key(self, key):
        return self._dict.has_key(key)

    def keys(self):
        return [a for a,v in self._list]

    def iterkeys(self):
        for a,v in self._list:
            yield a

    def values(self):
        return [v for a,v in self._list]

    def itervalues(self):
        for a,v in self._list:
            yield v

    def items(self):
        return self._list

    def iteritems(self):
        return iter(self._list)
