import sys, os
from config.context import Resource, Setting, Global

__all__ = [
    'stdin', 'stdout', 'stderr', 'envrion', 'argv',
    'translation_service', 'language', 'time_service',
    'transaction_service', 'storage_url', 'storage_connection',
    'blob_manager', 'workspace', 'current_user_factory',
    'secret', 'pythonmode',
]

stdin   = Global('stdout', sys.stdin)
stdout  = Global('stdout', sys.stdout)
stderr  = Global('stdout', sys.stderr)
environ = Global('environ', os.environ)
argv    = Global('argv', getattr(sys, 'argv', ())) # PyISAPI has no argv

application_name = Setting('application_name')

translation_service = Resource(
    'translation_service', 'wm4.i18n.translators.TranslationService')

language = Setting(
    'language', default='en')

time_service = Resource(
    'time_service', 'lib4.timeutils.TimeService',)

transaction_service = Resource(
    'transaction_service', 'wm4.storage.transactions.TransactionService')

storage_url = Setting(
    'storage_url')

storage_connection = Resource(
    'storage_connection', 'wm4.storage.connection.connectionFromURL')

blob_manager = Resource(
    'blob_manager', 'wm4.storage.blobs.PGBlobDM') #XXX

workspace = Resource(
    'workspace', 'wm4.schema.workspace.Workspace')

current_user_factory = Global(
    'current_user_factory', default=lambda: None)


secret = Setting('secret')

# http://www.zetadev.com/software/mode.py/
pythonmode = Setting(
    'pythonmode', os.environ.get('PYTHONMODE', 'production').lower(),
    doc='debugging/development/staging/production',
)
