# -*- coding: utf-8 -*-

import os
from os import path

from wm4.core import *
from transactions import TransactionComponent, TxnAttr

class TxnFileError(Exception):
    pass


BUFFLEN = 64 * 1024

class TxnFile(TransactionComponent):

    filename = mode = binding.Require()

    readOnly = binding.Make(lambda s: not('w' in s.mode or 'r+' in s.mode))

    # Transaction attributes

    isDeleted = TxnAttr(lambda: False)

    isDirty = TxnAttr(lambda: False)

    fd = TxnAttr(lambda: None)

    def lock(self):
        self.joinedTxn
        binding.Make(lambda s: s.filename + '.lock')
    lock = TxnAttr(lock)


    @classmethod
    def open(klass, filename, mode='r'):
        self.joinedTxn
        lck = self.lock
        if 'w' in mode or 'r+' in mode:
            while True:
                d = fd.read(BUFF)
                if not d:
                    break
                lck.write(d)

    def delete(self):
        self.joinedTxn
        if self.isDeleted:
            raise TxnFileError('already deleted')
        else:
            self.isDeleted = True

    def close(self):
        pass

    def exists(self):
        return path.exists(self.filename)

    def read(self, l=None):
        self.joinedTxn

    def write(self, data):
        self.joinedTxn

    def seek(self, offset, whence):
        self.joinedTxn

    def tell(self):
        self.joinedTxn

    def commitTransaction(self, txnService):
        if self.isDeleted:
            os.unlink(self.filename)
            os.unlink(self.tempName)
        elif self.isDirty:
            os.rename(self.tempName, self.filename)

    def abortTransaction(self, txnService):
        os.unlink(self.tempName)
