from protocols import Interface, Attribute

__all__ = ['IFileInfo', 'IImageInfo']


class IFileInfo(Interface):

    filename = Attribute('file name as unicode string')
    size = Attribute('file size')
    content_type = Attribute('mime type with additional parameters as charset')
    modified = Attribute('last modification timestamp')

    def open(mode='r'):
        '''Returns IFile object.'''

    def getPath():
        '''Returns file system path or None if this
           is not file system object.'''


class IImageInfo(IFileInfo):
    width = Attribute('image width in pixels')
    height = Attribute('image height in pixels')
