from wm4.core import *
from lib4.imports import importObject

from interfaces import MiddlewareRegistry, NSDomletProperty


def wsgiMiddleware(parser, section, name, value, lineInfo):
    for middleware in section.split()[2:]:
        MiddlewareRegistry(middleware).setFactory(
            str(name),
            lambda: eval(value, parser.globalDict)
        )


def domletsForNamespace(parser, section, name, value, lineInfo):
    for ns in section.split()[3:]:
        prop = NSDomletProperty(ns, name)
        prop(config.ExpressionRule(value, parser.globalDict))



class NullMiddleware:

    def __init__(self, application, **params):
        self.application = application
        self.__dict__.update(params)

    def __call__(self, environ, start_response):
        return self.application(environ, start_response)



def app_factory(global_config, **settings):
    app_name = settings.get('app_name')
    return _app_factory(app_name)

def _app_factory(app_name):
    from wm4.api import config, naming, web
    from lib4.imports import importString
    from os.path import isfile

    __import__(app_name)
    anurl = naming.data_url(
        '[Global Settings]\n' +
        'wm4.settings.application_name = "%s"\n' % app_name)
    ini_files = ['pkgfile:wm4/core.ini', 'pkgfile:wm4.web/web.ini', anurl]
    for ini in ('nondist.ini', 'app.ini'):
        iniFile = naming.lookup('pkgfile:%s/%s' % (app_name, ini)).address
        if isfile(iniFile):
            ini_files.append(iniFile)
            break
    config.loadConfig(*ini_files)
    return web.makeApp()

