# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/498265

from publishing import render
from templates import JSResource

__all__ = ['JSModule', 'JSMethod', 'JSCall', 'x_core', 'wm_drag', 'wm_popup']

class JSModule(object):

    __resource__ = None
    __dependencies__ = ()

    def __init__(self, dependencies, **methods):
        self.src = src
        self.dependencies = dependencies
        self.methods = methods

    def __getattr__(self, attr):
        return self.methods[attr]


class JSMethod(object):
    __js_name__ = None

    def __init__(self, module):
        self.module = module

    def __call__(self, *args, **kw):
        return JSCall(self.jsname, args)


class JSCall(object):

    def __init__(self, method, args):
        self.method = method
        self.args = args


#@render.when('ob in JSCall')
#def render_js_call(req, ob):
#    raise NotImplementedError


class xCore(JSModule):
    __resource__ =  'wm4.web.static/js/x_core.js'

    class xVisibility(JSMethod): pass

class xEvent(JSModule):
    __resource__ =  'wm4.web.static/js/x_event.js'

    class xVisibility(JSMethod): pass


class wmDrag(JSModule):
    __resource__ =  'wm4.web.static/js/wm_drag.js'
    __dependencies__ = (xCore, xEvent)

    class wmDragAndDrop(JSMethod): pass
