/*
 * Prekryje obrazovku prusvitnym divem. Lze nastavit pruhlednost,
 * barvu a z-index.
 *
 * Priklad:
 *
 *    <button onclick="wm4.overlay().show()">overlay</button>
 */

if (typeof wm4 == 'undefined') { wm4 = {}; }

wm4.overlay = function (options) {
    options = jQuery.extend({
            'z-index': 100,
            'opacity': 40,
            'background-color':'black',
            'display': 'none'
        }, options);

    var ie = false;
    if (typeof document.body.style.maxHeight === "undefined") {
        // IE 6
        $("body","html").css({height: "100%", width: "100%"});
        $("html").css("overflow","hidden");
        ie = true;
    }
    $("body").append("<div id='WM4-UI-OVERLAY'></div>");

    var over = $("#WM4-UI-OVERLAY");

    over.click(function() {over.hide()});

    var opacity = options['opacity'];
    var style = {
        'display': options['display'],
        'z-index': options['z-index'],
        'top': '0px',
        'left': '0px',
        'background-color': options['background-color'],
        'width': '100%',
        'height': '100%',
        'opacity': opacity / 100.0,
        'filter': 'alpha(opacity=' + opacity + ')',
        '-moz-opacity': opacity / 100.0
    };
    if (ie) {
        style['position'] = 'absolute';
        style['height'] = (document.body.scrollHeight > document.body.offsetHeight ? document.body.scrollHeight : document.body.offsetHeight) + 'px';
    } else {
        style['position'] = 'fixed';
    }
    over.css(style);
    return over;
}
