/*

Popup window stays open until mouse left trigger or popup itself.

Depends on:

    - x_core.js
      xGetElementById, xDisplay

Usage:
    
    <script type="text/javascript">
        toggler = new DelayedDisplayToggler('POPUP_ID')
    </script>
    <div id="POPUP_ID" style="display: none;"
         onMouseOver="toggler.showPopup()" 
         onMouseOut="toggler.hidePopup()">
        popup
    </div>
    <a href="#" onMouseOver="toggler.showPopup()"
                onMouseOut="toggler.hidePopup()">
        trigger
    </a>

*/

function DelayedDisplayToggler(id) {
    this.id = id;
    this.timeout = null;

    this.showPopup = function() {
        var e = xGetElementById(this.id);
        clearTimeout(this.timeout);
        if(xDisplay(e) == 'none'){
            this.timeout = setTimeout(function(){xDisplay(e, '');},200);                }
    }
    this.hidePopup = function() {
        var e = xGetElementById(this.id);
        if(xDisplay(e) == 'none'){
            clearTimeout(this.timeout);
        }else{
            this.timeout = setTimeout(function(){xDisplay(e, 'none');},300);
        }
    }
}


