/*

Depends on:

    - x_core.js
      xDisplay, xPageX, xPageY, xMoveTo, xWidth, xHeight

    - x_event.js
      xEvent

Usage:
    
    In form:

        <script type="text/javascript">
            function set_i2(popup, data) {
                document.forms['F1']['i2'].value=data;
            }
            i2p = new wmPopupIframe(
                'http://example.com/select-i2-value.html', set_i2,
                300, 200,
            );
        </script>
        <input name="i2" id="I2" />
        <input type="button" value="..." onclick="i2p.toggle(event)" />

    In popup source (http://example.com/select-i2-value.html):

        <a href="" onclick="return wmPopupHide(event)">close</a>

        <input type="button" value="Foo" onclick="wmPopupCallback('Foo')" />

        <a href="" onclick="return wmPopupCallback('Bar')">Bar</a>


*/


function wmCalcPopupPosition(ref, popupWidth, popupHeight, margin){

    ref = xGetElementById(ref);
    if(margin == undefined) {
        margin = 30;
    }

    var linkPositionX = xPageX(ref);
    var linkPositionY = xPageY(ref);
    var linkWidth     = xWidth(ref);
    var linkHeight    = xHeight(ref);
    var windowWidth   = xClientWidth();//nacte sirku okna
    var windowHeight  = xClientHeight();//nacte vysku okna
    var centerX       = linkWidth / 2;
    var centerY       = linkHeight / 2;
    var startX        = linkPositionX + centerX - popupWidth / 2;
    var startXmax     = startX + popupWidth;
    var startY        = linkPositionY + linkHeight;
    var startYmax     = startY + popupHeight;
    var scrolL        = xScrollLeft();
    var scrolT        = xScrollTop();

	if ((popupWidth+2*margin) > windowWidth){
		popupWidth=windowWidth-2*margin;
//	alert("zmensuje se sirka");
	}

	if ((popupHeight+2*margin) > windowHeight){
		popupHeight=windowHeight-2*margin;
//	alert("zmensuje se vyska");
	}

    if ((scrolL+windowWidth) < startXmax) {
        if ((scrolL+windowWidth) > (linkPositionX+linkWidth))
        {
            //posunuti smer X <-----
//		alert('posunuti X <---------');
            var moveX = scrolL + windowWidth - startX - popupWidth - margin;
            if ((moveX*-1) > startX) {
                moveX = 0;
            }
            startX = startX + moveX;
        }
    } else {

        if (scrolL + margin > startX) {

	    //posunutu smer X --->
//		alert('posunuti X --------->');
            var moveX = scrolL-startX;
            if (moveX > centerX+startX) {
                    moveX=0;
            }
            startX = startX+moveX+margin;
	}
    }
    if (scrolT+windowHeight < startYmax) {
	if ((startY-scrolT-margin) > (popupHeight+linkHeight)) {
//	alert('posunuti nahoru');
	    //posun nahoru
            startY = startY - popupHeight - linkHeight;
	} else {
	        //prekryti
		if ((windowHeight-2*margin)>popupHeight){
//		alert('prekryti');
                var moveY = linkPositionY - scrolT + linkHeight-margin;
                startY = startY - moveY;
		}
		else{
			var moveY = linkPositionY - scrolT + linkHeight-margin;
                	startY = startY - moveY;
		}
        }
    }

    if (startX < 10) {startX = 10;}
    if (startY < 10) {startY = 10;}

    var pos = new Array();
    pos[0] = popupWidth;
    pos[1] = popupHeight;
    pos[2] = startX;
    pos[3] = startY
    return pos
}







wm_popup_counter = 0;
wm_popup_registry = new Array();

function wmPopupIframe(url, callback, width, height) {
    wm_popup_registry.push(this);
    this.width = width;
    this.height = height;
    this.url = url;
    this.elem = null;
    this.opened = false;
    this.refElement = null;
    this.callback = callback;
}

wmPopupIframe.prototype.createPopup = function() {
    var elem = document.createElement('IFRAME');
    this.elem = elem;

    xDisplay(elem, 'none');
    xWidth(elem, this.width);
    xHeight(elem, this.height);

    wm_popup_counter = wm_popup_counter + 1;
    elem.name = '_wm_popup_' + wm_popup_counter;
    elem.style.position = 'absolute';
    elem.style.zIndex = '100';
    elem.src = this.url;

    document.body.appendChild(elem);
}

wmPopupIframe.prototype.setPosition = function(evt) {
    var ref = this.refElement;
    if(!ref) ref = evt.target;
    var pos = wmCalcPopupPosition(ref, this.width, this.height);
    /* alert('this.width=' + this.width + ', this.height=' + this.height + ', w=' + pos[0] + ', h=' + pos[1] + ', x=' + pos[2] + ', y='  + pos[3]); */

    xMoveTo(this.elem, pos[2], pos[3]);
    xResizeTo(this.elem, pos[0], pos[1]);
}

wmPopupIframe.prototype.show = function(_evt) {
    if(this.opened) {return; }
    var evt = new xEvent(_evt);
    if(!this.elem) {this.createPopup();}
    this.setPosition(evt);
    xDisplay(this.elem, 'block');
    this.opened = true;
}

wmPopupIframe.prototype.hide = function(_evt) {
    xDisplay(this.elem, 'none');
    this.opened = false;
}

wmPopupIframe.prototype.toggle = function(_evt) {
    if(this.opened) return this.hide(_evt)
    else return this.show(_evt);
}



function strDct(dct) {
    var s = '';
    for(var a in dct) {
        s = s + a + '=' + dct[a] + '\n';
    }
    return s;
}

function wmPopupFormIframe(url, width, height) {

    wmPopupIframe.call(this, url, null, width, height);

    this.map = new Array();
    this.frm = null;

    for(var i=3; i<arguments.length; i=i+2) {
        this.map[arguments[i]] = arguments[i+1];
    }

    this.callback = function(popup, data) {
        if(popup.frm == null) {
            return false;
        }
        var e, v, m;
        for(var a in popup.map) {
            m = popup.map[a];
            e = popup.frm[m];
            v = data[a];
            if(typeof e != 'undefined') {
                e.value = v || '';
                // trigger onchange event on this input element
                if (typeof e.fireEvent != 'undefined') {
                    // IE
                    e.fireEvent('onchange');
                } else {
                    // Gecko, Konqueror, Opera
                    var evt = document.createEvent("HTMLEvents");
                    evt.initEvent("change", true, true);
                    e.dispatchEvent(evt);
                }
            }
            /*
            } else {
                m = 'inp:' + m;
                var s = popup.frm.getElementsByTagName('span');
                for (var i = s.length-1; i>=0 ; --i) {
                    e = s[i];
                    if (e.className == m) {
                        e.innerHTML = v || '';
                    }
                }
            }
            */
        }
        return false;
    }
}

wmPopupFormIframe.prototype = new wmPopupIframe();

wmPopupFormIframe.prototype.show = function(_evt) {
    // Find form element
    var e = new xEvent(_evt);
    if(this.frm == null) {
        var frm = e.target;
        while(frm) {
            if(frm.tagName.toLowerCase() == 'form') {
                break;
            }
            frm = frm.parentNode;
        }
        this.frm = frm;
    }
    return wmPopupIframe.prototype.show.call(this, _evt);
}







/* Functions called from popup source */

function wmPopupFindInstance() {
    var popup;
    for(var i in window.parent.wm_popup_registry) {
        popup = window.parent.wm_popup_registry[i];
        if(!popup.elem) continue;
        if(popup.elem.contentWindow == window) return popup;
    }
}

function wmPopupCallback(data) {
    var popup = wmPopupFindInstance();
    popup.callback(popup, data);
    popup.hide();
    return false;
}

function wmPopupCallbackDict() {
    var v; var a;
    var d = new Array(arguments.length/2);
    for(var i=0; i<arguments.length/2; ++i) {
        a = arguments[i*2];
        v = arguments[i*2+1];
        d[a] = v;
    }
    return wmPopupCallback(d);
}

function wmPopupHide(evt) {
    var popup = wmPopupFindInstance();
    popup.hide();
    return false;
}
