/*
    http://sublog.subimage.com/articles/2006/01/01/subModal
    http://dev.iceburg.net/jquery/jqModal/
    http://dev.iceburg.net/jquery/jqDnR/
    http://interface.eyecon.ro/docs/resizable

   TODO

    - Pokud mam dve okna a pri premistovani jednoho mne
      kurzor vyjede z listy do iframu druheho, prestane
      presunovani prvniho fungovat. To same bude platit
      pro resize.

*/

function wmLog(msg) {
    var t = jQuery('#XLOG').get(0);
    if (t) { t.value = msg + '\n' + t.value; }
};


function wmPopup(elem, options) {
    var e = jQuery(elem);
    var i = e.attr('winId');
    var p;
    if (i == undefined) {
        p = new wmWindow(options);
        i = p.winId;
        e.attr('winId', i);
        wmWindow.winRegistry[i] = p;
    } else {
        p = wmWindow.winRegistry[i];
        p.toggle();
    }
    return false;
};


function wmWindow(options) {
    options = options || {};
    this.winIndex = wmWindow.idCounter + 1;
    wmWindow.idCounter = this.winIndex;
    this.winId = 'WMWIN' + this.winIndex;
    this.src = options.src || 'iframe1.html';
    this.width = options.width || 500;
    this.height = options.height || 400;
    this.minWidth = options.minWidth || 100;
    this.minHeight = options.minHeight || 100;
    this.top = options.top || 100;
    this.left = options.left || 200;
    this.windowElement = this.createWindow();
};

wmWindow.prototype.toString = function() {
    return 'wmWindow(id=' + this.winId + ' src=' + this.src + ')';
};

wmWindow.idCounter = 0;

wmWindow.winRegistry = new Array();

wmWindow.getForIframe = function() {
    var win;
    var reg = window.parent.wmWindow.winRegistry;
    for (var id in reg) {
        win = reg[id];
        if (win.frameWindow == window) {
            return win;
        }
    };
    return undefined;
};

/* !!! wm4-window-content musi mit z-index vetsi nez wm4-window-frame,
   aby zachytaval udalosti z mysi a tyto se neutopily v iframu.
 */
wmWindow.prototype.createWindow = function() {
    var w = jQuery(
        '<div id="' + this.winId + '" class="wm4-window">'
       +  '<div class="wm4-window-head">'
       +    '<a href="#" class="wm4-window-close">x</a>'
       +    '<span>HEAD</span>'
       +  '</div>'
       +  '<div class="wm4-window-content">'
       +    '<iframe src="' + this.src + '" class="wm4-window-frame"></iframe>'
       +  '</div>'
       +  '<div class="wm4-window-foot">'
       +    '<a href="#" class="wm4-window-resize">+</a>'
       +  '</div>'
       +'</div>'
    );
    w.appendTo("body");
    w.height(this.height);
    w.width(this.width);
    w.css('position', 'absolute');
    w.css('top', this.top);
    w.css('left', this.left);
    var me = this;
    jQuery('.wm4-window-head',w).mousedown(function (evt) {
            return wmWindow.move.init(me, evt);
    });
    jQuery('.wm4-window-resize',w).mousedown(function (evt) {
            return wmWindow.resize.init(me, evt);
    });
    jQuery('.wm4-window-close',w).click(function (evt) {
            return me.toggle();
    });
    this.frameWindow = jQuery('.wm4-window-frame', w).get(0).contentWindow;
    return w;
};

wmWindow.move = {ctx: false};

wmWindow.move.init = function (win, evt) {
                wmLog('move init');
                var w = win.windowElement;
                wmWindow.move.ctx = {
                    'oX': parseInt(w.css('left')),
                    'oY': parseInt(w.css('top')),
                    'pX': evt.pageX,
                    'pY': evt.pageY,
                    'win': win,
                };
                jQuery()
                    .bind('mousemove', {}, wmWindow.move.cont)
                    .bind('mouseup', {w:wmWindow}, wmWindow.move.ostop);
                jQuery(win.frameWindow)
                    .bind('mouseover',{w:wmWindow},wmWindow.move.fover)
                    .bind('mouseup',{w:wmWindow},wmWindow.move.ostop);
                return false;
};
wmWindow.move.cont = function (evt) {
                var c = wmWindow.move.ctx;
                c.win.windowElement.css({
                    'left': c.oX + evt.pageX - c.pX,
                    'top' : c.oY + evt.pageY - c.pY,
                });
                return false;
};
wmWindow.move.fover = function (evt) {
                var c = evt.data.w.move.ctx;
                var f = jQuery('.wm4-window-frame', c.win.windowElement).get(0);
                var e = c.win.windowElement.get(0);
                var pX = evt.pageX + f.offsetLeft + e.offsetLeft;
                var pY = evt.pageY + f.offsetTop + e.offsetTop;
                wmLog('top ' + pY + ' ' + pX + ' ');
                c.win.windowElement.css({
                    left: c.oX + pX - c.pX,
                    top : c.oY + pY - c.pY,
                });
                return false;
};
wmWindow.move.ostop = function (evt) {
                var wmWindow = evt.data.w;
                wmLog('move ostop');
                jQuery().unbind('mousemove', wmWindow.move.cont)
                   .unbind('mouseup', wmWindow.move.ostop);
                jQuery(wmWindow.move.ctx.win.frameWindow)
                    .unbind('mouseover', wmWindow.move.fover)
                    .unbind('mouseout', wmWindow.move.ostop);
                wmWindow.move.ctx = false;
                return false;
};


wmWindow.resize = {ctx: false};
wmWindow.resize.init = function (win, evt) {
                wmLog('resize init');
                var w = win.windowElement;
                wmWindow.resize.ctx = {
                    oW: w.width(),
                    oH: w.height(),
                    pX: evt.pageX,
                    pY: evt.pageY,
                    win: win,
                };
                jQuery().mousemove(wmWindow.resize.cont)
                   .mouseup(wmWindow.resize.ostop);
                return false;
};
wmWindow.resize.cont = function (evt) {
                var c = wmWindow.resize.ctx;
                var w = c.win.windowElement;
                w.width(Math.max(evt.pageX - c.pX + c.oW, c.win.minWidth));
                w.height(Math.max(evt.pageY - c.pY + c.oH, c.win.minHeight));
                return false;
};
wmWindow.resize.ostop = function (evt) {
                wmLog('resize ostop');
                wmWindow.resize.ctx = false;
                jQuery().unbind('mousemove', wmWindow.resize.cont)
                   .unbind('mouseup', wmWindow.resize.ostop);
};


wmWindow.prototype.hide = function () { this.windowElement.hide(); };
wmWindow.prototype.show = function () { this.windowElement.show(); };
wmWindow.prototype.toggle = function () { this.windowElement.toggle(); };
