(function($){

    /* String interpolation  $.strfmt('a{0}b{1}c',['-', 12]) -> 'a-b12c' */
    $.strfmt = function(source, params){
        if(arguments.length == 1) 
            return function(){
                var args = $.makeArray(arguments);
                args.unshift(source);
                return $.strfmt.apply(this, args);
            };
        $.each(params, function(i,n){
            source = source.replace(new RegExp("\\{" + i + "\\}", "g"), n);
        });
        return source;
    };

    /* $.strjoin([1,2,3], ' + ') -> '1 + 2 + 3' */
    $.strjoin = function(list, joinstr){
        var r = '';
        for(var i=0; i<list.length; i++){
            if(i>0) r = r + joinstr;
            r = r + list[i];
        }
        return r;
    };

    /* something like python repr() */
    $.fn.repr = function(){return $.repr(this);};
    $.repr = function(obj){
        var e;
        try {
            var t = typeof obj;
            if(t=='string') {
                return '"'+obj+'"';
            } else if(t=='number' || t=='boolean') {
                return ''+obj;
            } else if(t=='function') {
                return 'function(' + obj.length + ' args)';
            } else if(obj instanceof Array){
                /* Object.prototype.toString.apply(val) === '[object Array]' */
                return '[' + $.strjoin($.map(obj, $.repr), ', ') + ']';
            } else {
                var r = [];
                for(var prop in obj) {
                    r.push(prop + ':' + $.repr(obj[prop]));
                }
                return '{' + $.strjoin(r,', ') + '}';
            }
        } catch (e) {
            return '<ERROR>';
        }
    };

    /* logging into firebug console */
    $.log = function() {
        if (top.window.console && top.window.console.log)
            top.window.console.log($.strjoin(arguments, ' '));
    };


})(jQuery);
