from wm4.api import *
from wm4.web.api import *
from optparse import OptionParser
from lib4.testing import timeIt
from utils import Record

def getOpts():
    usage= 'usage: %prog [options] module'
    parser = OptionParser(usage=usage)
    parser.add_option(
        '-c', '--count', metavar='COUNT', type='int', default=None
    )
    opts, args = parser.parse_args()
    if len(args) < 1:
        parser.error('no module given')
    opts.modules = []
    for m in args:
        opts.modules.append(globals()['prof_'+m])
    return opts






def prof_routes(opts):

    from wm4.web.routes import Route, Const, Param, Signature

    class User(Record):
        pass

    U1, U2, U3 = User(uid=1), User(uid=2), User(uid=3)
    UserDB = {1: U1, 2:U2, 3:U3}

    class UserSitemap(Route):

        handler = Const('UserHandler')
        entity = Const(User)

        class list(Route):
            match = ''
            action = Const('list')
            signature = Signature('entity') | Signature('entity','action')

        class add(Route):
            match = 'add'
            action = Const('add')
            signature = Signature('entity','action')

        class user(Route):
            match = ':oid/'
            oid = Param(lambda s: str(s.obj.uid))
            obj = Param(lambda s: UserDB[int(s.oid)], typ=User)

            class view(Route):
                match = ''
                action = Const('view')
                signature = Signature('obj') | Signature('obj','action')

            class edit(Route):
                match = 'edit'
                action = Const('edit')
                signature = Signature('obj','action')

    ps, res = timeIt(opts.count or 100000, UserSitemap.traverse, '1/edit')
    print '%.2f traversals per second, result=%r' % (ps, res)

opts = getOpts()
for m in opts.modules:
    m(opts)
