# -*- coding: utf-8 -*-

from unittest import *
from wm4.api import *

from utils import *

class TestEnviroment(WebCase):

    @with_ini((
        '[WSGI Middleware environment]\n'
        'set_env = dict(foo="FOO", SERVER_PROTOCOL="SMTP/0.9")\n'
        'default_env = dict(bar="BAR", SERVER_NAME="wmserver")\n'
    ))
    def test01_SetEnv(self):
        e = {}
        def test(env, start_response):
            e.update(env)
            start_response('200', [])
            return ['ok']
        app = self.mkapp('environment', funcMiddleware(test))
        self.handle(app, self.env())
        self.assertEqual(e['foo'], 'FOO')
        self.assertEqual(e['SERVER_PROTOCOL'], 'SMTP/0.9')
        self.assertEqual(e['bar'], 'BAR')
        self.assertEqual(e['SERVER_NAME'], 'localhost')


def suite():
    return TestSuite((
        makeSuite(TestEnviroment),
    ))


if __name__ == '__main__':
    main(defaultTest='suite')
