# -*- coding: ISO-8859-2 -*-

from unittest import *
from wm4.api import *
from wm4.web.forms.api import *

from utils import *

class SF(InstanceCtrl, FormCtrl):
    valueType = Record
    class a(InputCtrl):
        ctrlLabel = 'Field A'
        valueType = int
    class b(InputCtrl):
        ctrlLabel = 'Field B'
        def defaultInput(self):
            return u'bDefault'
    class s(InstanceCtrl):
        valueType = Record
        class sa(InputCtrl):
            valueType = int
        class sb(InputCtrl):
            valueType = str



SW = (
    '<body>\n'
      '<form form:form="" id="TEST">\n'
       '<div form:errors="" />\n'
        '<label form:label="a"/> <input form:input="a" class="AClass" />\n'
        '<div form:errors="a" />\n'
        '<label form:label="b"/> <input form:input.int="b" />\n'
        '<div form:errors="b" />\n'
        '<input form:submit="" />\n'
      '</form>\n'
    '</body>'
)

class TestFormWidgets(WebCase):

    def form(self, klass, oldValue=NOT_GIVEN, ctrlReadOnly=False, post={}):
        f = klass(
            ctrlReq      = self.req(post=post),
            ctrlReadOnly = ctrlReadOnly,
            oldValue     = oldValue,
        )
        f.res = f()
        return f

    def test10_View(self):
        f = self.form(SF, ctrlReadOnly=True, oldValue=Record(a=12, b='Bee'))
        o = self.parse(SW).render(f.ctrlReq, form=f)
        self.assertEqualXML(o,
         u'<body>\n'
         u'<div id="TEST" class="wm4-form wm4-form-readonly">\n'
         u'<div class="wm4-form-top"><div class="wm4-form-top-right-corner"> </div></div>\n'
         u'<div class="wm4-form-in">\n'
         u'\n'
         u'<span class="wm4-form-label">Field A</span> '
         u'<span class="AClass">12</span>\n'
         u'\n'
         u'<span class="wm4-form-label">Field B</span> '
         u'<span>Bee</span>\n'
         u'\n'
         u'\n'
         u'\n'
         u'</div>\n'
         u'<div class="wm4-form-bottom"><div class="wm4-form-bottom-right-corner"> </div></div>\n'
         u'</div>\n'
         u'</body>\n'
        )

    def test20_Add(self):
        tmpl = self.parse(SW)
        f = self.form(SF)
        f.formErrors['b'] = schema.RequiredError('b')
        f.formErrors['c'] = schema.RequiredError('c')
        f.formErrors['d'] = schema.RequiredError('d')
        o = tmpl.render(f.ctrlReq, form=f)
        self.assertEqualXML(o,
         u'<body>\n'
         u'<form class="wm4-form wm4-form-editable" accept-charset="utf-8" '
            'action="http://localhost/" method="post" id="TEST" '
            'enctype="application/x-www-form-urlencoded">\n'
         u'<div class="wm4-form-top"><div class="wm4-form-top-right-corner"> </div></div>\n'
         u'<div class="wm4-form-in">\n'
         u'<ul class="wm4-form-error"><li>c: Attribute must have value</li>'
         u'<li>d: Attribute must have value</li></ul>\n'
         u'<label class="wm4-form-label" for="a">Field A</label> '
         u'<input type="text" name="a" value="" class="AClass" />\n'
         u'\n'
         u'<label class="wm4-form-label" for="b">Field B</label> '
         u'<input type="text" name="b" value="bDefault" />\n'
         u'<ul class="wm4-form-error"><li>Attribute must have value</li></ul>\n'
         u'<input type="submit" name="doSubmit" value="Save" />\n'
         u'\n'
         u'</div>\n'
         u'<div class="wm4-form-bottom"><div class="wm4-form-bottom-right-corner"> </div></div>\n'
         u'</form>\n'
         u'</body>\n'
        )

def suite():
    return TestSuite((
        makeSuite(TestFormWidgets),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
