from wm4.api import *


VARIABLE = 'wsgi.transaction'


class TransactionMiddleware:

    def __init__(self, application):
        self.application = application
        self.logger = logs.getLogger('web')

    def __call__(self, environ, start_response):
        ts = settings.transaction_service()
        if ts.isActive():
            self.logger.error('Aborting unfinished transaction: %r', ts.state)
            ts.abort()
        ts.begin(
            REMOTE_ADDR = environ.get('REMOTE_ADDR'),
            REQUEST_URI = environ.get('REQUEST_URI'),
            REMOTE_USER = environ.get('REMOTE_USER'),
        )
        try:
            resp = self.application(environ, start_response)
        except:
            if ts.isActive():
                ts.abort()
            raise
        else:
            if ts.isActive():
                ts.commit()
            return resp
