from wm4.api import web
import dispatch


__all__ = ['render_js_value', 'mime2css', 'parse_accepts']

@dispatch.generic()
def render_js_value(req, val):
    pass


@render_js_value.when('val in basestring')
def render_unicode(req, val):
    return "'%s'" % web.render(req, val
        ).replace("'", "\\'"
        ).replace('\n', '\\n'
        ).replace('\r', '\\r')


def mime2css(ct):
    global _mime2css
    try:
        return _mime2css('-', ct.split(';')[0]).lower()
    except NameError:
        import re
        _mime2css = re.compile('[^a-zA-Z0-9]+').sub
        return _mime2css('-', ct.split(';')[0]).lower()


def parse_accepts(accept):
    '''Parses client preferences as value of HTTP_ACCEPT_CHARSET'''
    alist = []
    accept = accept.strip()
    if not accept:
        return alist
    for aitem in accept.split(','):
        try:
            if ';' in aitem:
                value, quality = aitem.split(';')
                if not quality.startswith('q='):
                    quality = 1.0
                else:
                    quality = float(quality[2:])
            else:
                value = aitem
                quality = 1.0
            # byla uz videna takovato hlavicka:
            #HTTP_ACCEPT_LANGUAGE: '\xc4\x8de\xc5\xa1tina,cs-CZ;q=0.7,sk-SK;q=0.3',
            # ktera zbridi dbgettext. Da se to obejit prekodovanim do unicode:
            #alist.append((quality,unicode(value, 'utf-8')))
            alist.append((quality,value.strip()))
        except:
            pass
    alist.sort()
    alist.reverse()
    return alist
