from elements import DocType

NS_XML = u'http://www.w3.org/XML/1998/namespace'
NS_XHTML = u'http://www.w3.org/1999/xhtml'
NS_RDF = u'http://www.w3.org/1999/02/22-rdf-syntax-ns#'
NS_RSS = u'http://purl.org/rss/1.0/'
NS_ATOM = u'http://purl.org/atom/ns#'
NS_XSLT = u'http://www.w3.org/1999/XSL/Transform'
NS_XML4_TMPL = u'http://windmill.cz/xml4/py'

NS = {
    'xml'   : NS_XML,
    'xhtml' : NS_XHTML,
    'rdf'   : NS_RDF,
    'rss'   : NS_RSS,
    'atom'  : NS_ATOM,
    'xslt'  : NS_XSLT,
    'py'    : NS_XML4_TMPL,
}



# <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
#                       "http://www.w3.org/TR/html4/strict.dtd">
DT_HTML4_STRICT = DocType(
    u'HTML',
    u'http://www.w3.org/TR/html4/strict.dtd',
    u'-//W3C//DTD HTML 4.01//EN',
)

# <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
#                       "http://www.w3.org/TR/html4/loose.dtd">
DT_HTML4_TRANS = DocType(
    u'HTML',
    u'http://www.w3.org/TR/html4/loose.dtd',
    u'-//W3C//DTD HTML 4.01 Transitional//EN',
)

# <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN"
#                       "http://www.w3.org/TR/html4/frameset.dtd">
DT_HTML4_FRAME = DocType(
    u'HTML',
    u'http://www.w3.org/TR/html4/frameset.dtd',
    u'-//W3C//DTD HTML 4.01 Frameset//EN',
)




# <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
#                       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
DT_XHTML1_STRICT = DocType(
    u'html',
    u'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd',
    u'-//W3C//DTD XHTML 1.0 Strict//EN',
)
