'''Various filters for XML streams'''

from const import TEXT

__all__ = ['merge_text']


def merge_text(stream):
    last_event = None
    last_value = None
    for event, value in stream:
        if event is TEXT:
            if last_event is TEXT:
                last_value += value
            else:
                last_event = event
                last_value = value
        else:
            if last_event is not None:
                yield last_event, last_value
            yield event, value
            last_event = None
    if last_event is not None:
        yield last_event, last_value
