#-*- coding: iso-8859-2 -*-
from unittest import *
from xml4.elements import *
from xml4.filters import *
from xml4.const import *

class TestMergeTextFilter(TestCase):

    def p(self, stream):
        return list(merge_text(stream))

    def test_Empty(self):
        self.assertEqual(self.p([]), [])

    def test_OneText(self):
        self.assertEqual(
            self.p([(TEXT, 'foo')]),
            [(TEXT, 'foo')],
        )
    def test_ManyTexts(self):
        self.assertEqual(
            self.p([(TEXT, 'foo'), (TEXT, 'bar')]),
            [(TEXT, 'foobar')],
        )

    def test_TextWithElements(self):
        self.assertEqual(
            self.p([
                (START_TAG, ('div', [])),
                (TEXT, 'foo'),
                (TEXT, 'bar'),
                (END_TAG, ('div', [])),
            ]),
            [
                (START_TAG, ('div', [])),
                (TEXT, 'foobar'),
                (END_TAG, ('div', [])),
            ],
        )

def suite():
    return TestSuite((
        makeSuite(TestMergeTextFilter),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
