#-*- coding: iso-8859-2 -*-
from unittest import *
from xml4.elements import *
from xml4.definitions import *
from xml4 import parser


class TestSimpleXMLParser(TestCase):

    def setUp(self):
        self.parser = parser.SimpleXMLParser()

    def check(self, xml, doc):
        res = self.parser.parse(xml)
        self.assertEqual(
            list(res.expand(None)), list(doc.expand(None))
        )

    def test10_OneElement(self):
        self.check('<e/>', xml(xml.e()))

    def test11_OneElementWithText(self):
        self.check('<e>txt</e>', xml(xml.e('txt')))

    def test12_XMLEntitites(self):
        self.check('<e>t&amp;t&quot;t&lt;t</e>', xml(xml.e(Text('t&t"t<t'))))

    def test13_HTMLEntities(self):
        self.check(
            '%s<e>&lt;t&nbsp;t&gt;</e>' % DT_XHTML1_STRICT,
            xml(DT_XHTML1_STRICT, xml.e('<t',Literal('&nbsp;'),'t>'))
        )

    def test14_Comments(self):
        self.check(
            '<e><!-- comment --></e>',
            xml(xml.e(Comment(' comment ')))
        )


class TestXMLParser(TestCase):

    def setUp(self):
        self.parser = parser.XMLParser()

    def test10_NS(self):
        d = self.parser.parse(
            '<e xmlns="e@example.cz" xmlns:b="b@example.cz">'
              '<b:x xmlns:c="http://www.dat.cz/">'
                '<c:y c:href="yh">Y</c:y>'
                '<z href="zh"/>'
                '<x:z x:href="zh"/>'
              '</b:x>'
            '</e>'
        )


def suite():
    return TestSuite((
        makeSuite(TestSimpleXMLParser),
        makeSuite(TestXMLParser),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
