#-*- coding: iso-8859-2 -*-
from unittest import *
from xml4.elements import *
from xml4.const import *
from xml4.utils import *
from xml4 import serialization
from lib4.text import ufTemplate


class TestXMLSerializer(TestCase):

    def check(self, elem, result):
        out = u''.join(serialization.xml_serializer(elem.expand(None)))
        self.assertEqual(out, result)

    def test10_EmptyElement(self):
        self.check(xml(xml.e()), '<e />')
        self.check(xml(xml.e('', Literal(''), '')), '<e />')
        self.check(xml.e(Literal('')), '<e />')
        self.check(xml.e(xml.f(Literal(''))), '<e><f /></e>')

    def test11_NestedEmptyElements(self):
        self.check(xml(xml.e(xml.f(xml.g()))), '<e><f><g /></f></e>')
        self.check(xml(xml.e(xml.f(xml.g('', '')))), '<e><f><g /></f></e>')

    def test12_NonEmptyElement(self):
        self.check(xml(xml.e('a')), '<e>a</e>')
        self.check(xml(xml.e('','a','')), '<e>a</e>')

    def test14_NonelementNodes(self):
        self.check(Literal('a<b>c'), 'a<b>c')
        self.check(Text('a<b>c'), 'a&lt;b&gt;c')



class TestXHTMLSerializer(TestCase):

    def check(self, elem, result):
        out = u''.join(serialization.xhtml_serializer(elem.expand(None)))
        self.assertEqual(out, result)

    def test10_AllwaysNonempty(self):
        self.check(xml(xml.textarea()), '<textarea></textarea>')
        self.check(xml(xml.style()), '<style></style>')
        self.check(xml(xml.script()), '<script></script>')




def suite():
    return TestSuite((
        makeSuite(TestXMLSerializer),
        makeSuite(TestXHTMLSerializer),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
