#-*- coding: iso-8859-2 -*-
from unittest import *
from xml4 import xhtml as h

il2 = lambda s: unicode(s,'iso-8859-2')


class TestXHTML(TestCase):

    def test10_Empty(self):
        self.assertEqual(str(h.input()), '<input />')
        self.assertEqual(str(h.body()), '<body></body>')

    def test12_SimpleContent(self):
        self.assertEqual(str(h.body('a')), '<body>a</body>')

    def test13_Attributes(self):
        self.assertEqual(str(h.input(a=1)), '<input a="1" />')
        self.assertEqual(str(h.body(a=1)), '<body a="1"></body>')

    def test15_AttributeSubstitution(self):
        self.assertEqual(str(h.br(class_='A')), '<br class="A" />')
        self.assertEqual(str(h.br(_class='A')), '<br class="A" />')
        self.assertEqual(str(h.br(klass='A')), '<br class="A" />')
        self.assertEqual(
            str(h.meta(http_equiv='A', content='X')),
            u'<meta content="X" http-equiv="A" />'
        )
        self.assertEqual(
            str(h.meta({'http-equiv':'A'}, content='X')),
            u'<meta http-equiv="A" content="X" />'
        )
        self.assertEqual(
            str(h.meta([('http-equiv','A'),('content','X')])),
            u'<meta http-equiv="A" content="X" />'
        )
        # Attribute is substituted in constructor
        self.assertEqual(h.p(class_='A').get('class'), 'A')

    def test20_Unicode(self):
        self.assertEqual(
            unicode(h.p(il2(''), class_=il2('̩'))),
            il2('<p class="̩"></p>')
        )

    def test21_Literals(self):
        self.assertEqual(str(h.div(h.nbsp)), u'<div>&nbsp;</div>')

    def test30_Fragments(self):
        self.assertEqual(
            str(h.frag(h.span(), h.a())),
            u'<span></span><a></a>'
        )
        self.assertEqual(
            str(h.div(h.nbsp, h.frag(h.span(), h.a()))),
            u'<div>&nbsp;<span></span><a></a></div>'
        )


def suite():
    return TestSuite((
        makeSuite(TestXHTML),
    ))

if __name__ == '__main__':
    main(defaultTest='suite')
